import java.awt.*;

public class Diamond extends LegendMark {
  // pos = upperleft; size = "side" 
  int size;
  int alignment; // LEFT (-1), CENTER (0), RIGHT (1)
  Polygon diamond;

  Diamond(Point position)
  {
    this.size = 10;
    this.color = CustomColor.xFF3300;
    this.position = position;
  }

  Diamond(int size, Color color, int align)
  {
    this.size = size;
    this.color = color;
    this.alignment = align;
  }

  Diamond(Point position, int size, Color color)
  {
    this.position = position;
    this.size = size;
    this.color = color;
  }

  void setPosition(Point position)
  {
    this.position = position;
  }

  void setAlign(int align)
  {
    // LEFT=-1 CENTER=0 RIGHT=1
    this.alignment = align;
  }

  void draw(Graphics g)
  {
    Color currentColor;

    diamond = new Polygon();
    // closed polygon
    switch(alignment) {
      case -1: // LEFT ALIGNMENT
               diamond.addPoint(position.x, position.y + size/2);
               diamond.addPoint(position.x + size/2, position.y + size);
               diamond.addPoint(position.x + size, position.y + size/2);
               diamond.addPoint(position.x + size/2, position.y);
               break;
      case 0:  // CENTER ALIGNMENT
               diamond.addPoint(position.x, position.y);
               diamond.addPoint(position.x - size/2, position.y + size/2);
               diamond.addPoint(position.x, position.y + size);
               diamond.addPoint(position.x + size/2, position.y + size/2);
               break;
      case 1:  // RIGHT ALIGNMENT
               diamond.addPoint(position.x, position.y + size/2);
               diamond.addPoint(position.x - size/2, position.y + size);
               diamond.addPoint(position.x - size, position.y + size/2);
               diamond.addPoint(position.x - size/2, position.y);
               break;
    }

    currentColor = g.getColor();
    g.setColor(color);
    g.fillPolygon(diamond);

    // restore
    g.setColor(currentColor);
  } 

  void drawOLD(Graphics g)
  {
    Color currentColor;

    diamond = new Polygon();
    // closed polygon
    diamond.addPoint(position.x, position.y + size/2);
    diamond.addPoint(position.x + size/2, position.y + size);
    diamond.addPoint(position.x + size, position.y + size/2);
    diamond.addPoint(position.x + size/2, position.y);

    currentColor = g.getColor();
    g.setColor(color);
    g.fillPolygon(diamond);

    // restore
    g.setColor(currentColor);
  } 

  int width()
  {
    return size;
  }

  int height()
  {
    return size;
  }

  int x()
  {
    return position.x;
  }

  int y()
  {
    return position.y;
  }
}
