// verifies which fonts are available, and responds accordingly

import java.awt.*;

public class FontList {
  String[] fontList;
  String[] Sanserife = {"TimesRoman", "Courier"};
  String[] NonSanserife = {"Dialog", "Helvetica", "DialogInput"};

  static String[] fl;
  static {
    fl = Toolkit.getDefaultToolkit().getFontList();
    // DEBUG
    //for(int i=0; i<fl.length; i++)
    //  System.out.println("FONTLIST:" + i + fl[i]);
  }
    
  FontList()
  {
    fontList = Toolkit.getDefaultToolkit().getFontList();
  }

  String get(String original)
  {
    String match=null;

    // DEBUG
    //System.out.print("FontList:get:ORIGINAL:" + original + ":MATCH:");

    // is original in the list?
    match = isIn(fontList,original);
    if(match != null) {
    //  System.out.println(match);
      return(match);
    }

    // We don't have the orignal font in the list, so return another font
    // (of the same type) that is available

    // is it "Sanserife"-type?
    match = isIn(Sanserife,original);
    if(match != null) {
      for(int i=0; i<Sanserife.length; i++) {
        match = isIn(fontList,Sanserife[i]);
        if(match != null) {
        //  System.out.println(match + "(" + i + "/s" + ")");
          return(match);
        }
      }
    }
    // is it "Non-Sanserife"-type?
    match = isIn(NonSanserife,original);
    if(match != null) {
      for(int i=0; i<NonSanserife.length; i++) {
        match = isIn(fontList,NonSanserife[i]);
        if(match != null) {
        //  System.out.println(match + "(" + i + "/ns" + ")");
          return(match);
        }
      }
    }

    // if we cannot determine its type, return default (1st in the List)
    //System.out.println(fontList[0] + "(1st)");
    return(fontList[0]);
  }

  String isIn(String[] list, String element)
  {
    for(int i=0; i<list.length; i++) {
      if(element.equalsIgnoreCase(list[i]))
        return(element);
    }
    return(null);
  }
}
