import java.awt.*;

class VisualProject {
  // x Values
  int origin;
  double scale;

  // marks
  int squareSize = 10;         // square size
  int diamondSize = 10;        // diamond size

  final int iNIL = -1;
  final int taskCaptionFontSize = 14;

  //void calculateScale()
  //{
  //  scale = (float)(size().width - origin) / (endDate - startDate); 
  //} 

  //void drawChronogram(Graphics g, int x0, int y0, int length,
  //                    int start, int end, int today,
  //                    TimeFrame[] tf, Task[] task)
  //{
  //}

  void setNILs(Task t, int today)
  {
    if(t.getCurrentEnd() == iNIL)
      t.setCurrentEnd(today);
  }

  void drawTimeBar(Graphics g, int y0, int height, int stripeHeight,
                   int start, int end,
                   CoordinateMapper cm, TimeFrame tframe)
  {
    tframe.draw(g, y0, height, stripeHeight, start, end, cm);
  }

  void drawTimeFlag(Graphics g, TimeFlag tflag, CoordinateMapper mapper)
  {
    tflag.draw(g,mapper);
  }

  void drawTasks(Graphics g, int x0, int y0, int length,
                 int caption_width, int caption_height,
                 CoordinateMapper cm, Task[] task, HotSpot hotspots)
  {
    VisualTask vt;
    int x,y;
    Color old;

    x = x0;
    y = y0;
    for(int i=0; i<task.length; i++) {
      // create/initialize
      vt = new VisualTask(x, y, taskCaptionFontSize, task[i]);

      // draw task
      vt.stretch(caption_width);
      vt.draw(g, cm, hotspots);
      old = g.getColor();
      g.setColor(CustomColor.x666666);
      g.drawRect(x,y,length,vt.height());
      g.setColor(old);

      // add hotspot
      if(hotspots != null)
        hotspots.add(x,y,vt.width(),vt.height(), vt.getCaptionLink());

      y += vt.height();
    }
  }

  public int taskFrameWidth(Task[] task)
  {
    VisualTask vt;
    int dxMax = 0;

    for(int i=0; i<task.length; i++) {
      // create/initialize
      vt = new VisualTask(0, 0, taskCaptionFontSize, task[i]);
      if(dxMax < vt.width())
        dxMax = vt.width();
    }

    return(dxMax);
  }

  public int taskFrameHeight(Task[] task)
  {
    VisualTask vt;
    int dy = 0;

    for(int i=0; i<task.length; i++) {
      // create/initialize
      vt = new VisualTask(0, 0, taskCaptionFontSize, task[i]);
      dy += vt.height();
    }

    return(dy);
  }

  void drawLegend(Graphics g, int x0, int y0, int length)
  {
    VisualLegend vl[];
    Abc caption[];
    LegendMark mark[];
    int startIndex, endIndex;
    int legendLength;
    int xSpacing;                       // spacing between elements
    int LEFT_MARGIN = 0;         // left side margin
    int RIGHT_MARGIN = 10;         // left side margin
    int UPPER_MARGIN = 30;        // upper side margin
    int Y_SPACING = 15;           // spacing between rows

    // create arrays
    vl = new VisualLegend[6];
    caption = new Abc[6];
    mark = new LegendMark[6];

    // PREVISTO
    mark[0] = new Square(squareSize, CustomColor.x666666);
    caption[0] = new Abc("previsto", CustomColor.x666666);
    vl[0] = new VisualLegend(x0 + LEFT_MARGIN, y0 + UPPER_MARGIN,
                             mark[0], caption[0]);
    vl[0].draw(g);

    // NAO INICIADO
    mark[1] = new Diamond(diamondSize, CustomColor.xFF3300, -1);
    caption[1] = new Abc("nao iniciado", CustomColor.x666666);
    vl[1] = new VisualLegend(mark[1], caption[1]);

    // ATRASADO
    mark[2] = new Square(squareSize, CustomColor.xFF3300);
    caption[2] = new Abc("atrasado", CustomColor.x666666);
    vl[2] = new VisualLegend(mark[2], caption[2]);

    // EM ALERTA
    mark[3] = new Square(squareSize, CustomColor.xFFCC00);
    caption[3] = new Abc("em alerta", CustomColor.x666666);
    vl[3] = new VisualLegend(mark[3], caption[3]);

    // CONCLUIDO
    mark[4] = new Square(squareSize, CustomColor.x009900);
    caption[4] = new Abc("concluido", CustomColor.x666666);
    vl[4] = new VisualLegend(mark[4], caption[4]);

    // EM ANDAMENTO, NO PRAZO
    mark[5] = new Square(squareSize, CustomColor.x99CCFF);
    caption[5] = new Abc("em andamento, no prazo", CustomColor.x666666);
    vl[5] = new VisualLegend(mark[5], caption[5]);

    legendLength = 0;
    startIndex = 1;
    endIndex = 5;
    for(int i = startIndex; i <= endIndex; i++)
      legendLength += vl[i].width();

    xSpacing = (length - (LEFT_MARGIN + RIGHT_MARGIN) - legendLength) / (endIndex - startIndex);

    int xPos = x0 + LEFT_MARGIN;
    for(int i = startIndex; i <= endIndex; i++) {
      vl[i].setPosition(xPos, y0 + UPPER_MARGIN + Y_SPACING);
      vl[i].draw(g);
      xPos += vl[i].width() + xSpacing;
    }

  }

  //void draw(Project prj)
  //{
  //}
}
