/* <applet code="main.class" width=500 height=400>
   </applet>
*/

import java.applet.*;
import java.awt.*;
import java.awt.image.*;
import java.net.*;
import java.io.*;

public class main extends Applet implements ImageObserver {
  Project project = null;
  HotSpot hotspot = null;
  String dataSource = null;
  URL documentBase = null;
  Share share = null;

  //---Draw horizontal bar near cursor
  int cursorX, cursorY;
  int cursorX0, cursorX1;
  int cursorY0, cursorY1;

  //---Off Screen painting---
  Image     m_OffImage    = null;
  Graphics  m_OffGraphics = null;
  Dimension m_LastSize    = new Dimension(0,0); //modify only if resized

  //---Button to create Image
  Button bImage = null;
  public boolean isPrintCapable = false;

  //---Background Image
  Image bgImage;
  boolean bgImageLoaded;

  //---Frame
  Frame appletFrame;

  // data
  String data; 

  // contants
  static final int BUFFER_SIZE = 1024;


  void loadBackgroundImage()
  {
    bgImage = getImage(getDocumentBase(), getParameter("bgimage"));
    bgImageLoaded = false;
  }

  public boolean imageUpdate(Image img, int info, int x, int y,
                             int width, int height)
  {
    if( (info & ALLBITS) != 0) {
      bgImageLoaded = true;
      m_LastSize.width = 0;
      m_LastSize.height = 0;
      repaint();
      return false;
    }
    return true;
  }

  void observeBackgroundImage(Graphics g)
  {
    if(bgImage == null) {
      bgImageLoaded = true;
      return;
    }

    bgImageLoaded = g.drawImage(bgImage, 0,0, this);
  }

  void drawBackground(Graphics g)
  {
    int x,y;
    int sx, sy;
    int dx,dy;


    sx = size().width;
    sy = size().height;

    if(bgImage == null) {
      // paint white background
      Color old = g.getColor();
      g.setColor(Color.white);
      g.fillRect(0,0,sx,sy);
      g.setColor(old);
      return;
    }

    dx = bgImage.getHeight(this);
    dy = bgImage.getWidth(this);

    for(x=0;x<sx;x+=dx)
      for(y=0;y<sy;y+=dy)
        g.drawImage(bgImage, x,y, this);
  }

  public void init()
  {
    int height = Integer.parseInt(getParameter("height"));

    // read parameter
    dataSource = getParameter("Location");
    documentBase = this.getDocumentBase();
    if ( dataSource == null) {
       // exhibit error message
       System.err.println("erro: Parametro 'Location' nao definido");
       return;
    }
    if( getParameter("wwwrootdir") == null ) {
       // exhibit error message
       System.err.println("erro: Parametro 'wwwrootdir' nao definido");
       return;
    }
    if( getParameter("basedir") == null ) {
       // exhibit error message
       System.err.println("erro: Parametro 'basedir' nao definido");
       return;
    }
    //if( getParameter("servletname") == null ) {
    //   // exhibit error message
    //   System.err.println("erro: Parametro 'servletname' nao definido");
    ////   return;
    //}

    // init cursor: (0,0)
    cursorX = 0;
    cursorY = 0;

    // object with shared functiions
    share = new Share();

    // set layout manager
    setLayout(null);

    hotspot = new HotSpot();
    loadBackgroundImage();
    appletFrame = FrameGrabber.getFrame(this);
    validate();
  }

  public void start(Graphics g)
  {
    this.update(g);
  }

  public void update(Graphics g)
  {
      if (m_LastSize.width  != size().width ||
          m_LastSize.height != size().height )
      {  // ....first time or resized....

         m_LastSize = new Dimension(size());
         m_OffImage = createImage(size().width, size().height);
         m_OffGraphics = m_OffImage.getGraphics();

         observeBackgroundImage(m_OffGraphics);

         if(bgImageLoaded) {
           drawBackground(m_OffGraphics); 
           share.readProject(documentBase, dataSource);
           data = share.getData();
           StringBufferInputStream dataStream = new StringBufferInputStream(data);
           share.drawProject(m_OffGraphics, size(), dataStream, hotspot);
           cursorX0 = share.cursorX0();
           cursorY0 = share.cursorY0();
           cursorX1 = share.cursorX1();
           cursorY1 = share.cursorY1();
           validate();
         }
      }

      if(bgImageLoaded) {
        g.drawImage(m_OffImage,0,0,null);

        if((cursorX > cursorX0) && (cursorX < cursorX1) &&
           (cursorY > cursorY0) && (cursorY < cursorY1)) {
          Color old = g.getColor();
          g.setColor(Color.black);
          g.drawLine(cursorX,cursorY0, cursorX,cursorY1);
          g.setColor(old);
        }

        // init print button
        if((isPrintCapable == false) && (bImage == null)) {
          bImage = new Button("Imagem");
          bImage.setBackground(Color.lightGray);
          bImage.setForeground(Color.black);
          add(bImage);

          // displace button 
          Point p = bImage.location();
          Dimension d = bImage.size();
          bImage.reshape(10, size().height - 25 - 10, 70, 25);
        }
      }
      else {
        drawCenteredString("Carregando Cronograma...", 
                           size().width, size().height, g);
      }
  }

  // escreve texto centralizado em relacao a graphics
  void drawCenteredString(String text, int width, int height, Graphics g)
  {
    FontMetrics fm = g.getFontMetrics();
    int x = (width - fm.stringWidth(text)) / 2;
    int y = (fm.getAscent() + (height - (fm.getAscent() + fm.getDescent())) / 2);

    g.drawString(text, x, y);
  }

  // overwrite. Reduce flicking, no need to use background color.
  public void paint(Graphics g)
  {
    update(g);
  }

  public boolean mouseMove(Event event, int i, int j)
  {
    Link link;
    String linkString;
    Graphics g;

    link = hotspot.isHot(i,j);
    if(link != null) {
      String temp = link.getURL();
      if(temp==null) {
        appletFrame.setCursor(Frame.DEFAULT_CURSOR);
        showStatus("");
      }
      else {
        appletFrame.setCursor(Frame.HAND_CURSOR);
        showStatus(link.getURL());
      }
    }
    else {
      appletFrame.setCursor(Frame.DEFAULT_CURSOR);
      showStatus("");
    }

    cursorX = i;
    cursorY = j;
    repaint();

    return true;
  }

  public boolean mouseDown(Event event, int i, int j)
  {
    Link link;

    link = hotspot.isHot(i,j);
    if(link != null) {
      try {
          URL url = new URL(link.getURL());
          getAppletContext().showDocument(url, link.getFrame());
      }
      catch (Exception e)
      {
          e.printStackTrace();
      }
      return true;
    }
    else
      return false;
  }

  // ..................... Handle events ......................

  public boolean action(Event event, Object arg)
  {
    // botoes de opcao
    if(event.target instanceof Button) {

      Button b = (Button)event.target;
      String label  = b.getLabel();
      ObjectInputStream inStream = null;
      Socket client = null;

      // IMAGEM
      if(label.equals("Imagem")) {
        try {
          // call servlet
          URL appletUrl = getCodeBase();
          String host = appletUrl.getHost();
          //String servletName = "ChronogramServlet";
          //String servletName = getParameter("servletname");

          // set parameters
          int port = Integer.parseInt(getParameter("socketport"));
          int wakeupTime = Integer.parseInt(getParameter("wakeuptime"));

          client = new Socket(host, port);

          // send request
          ObjectOutputStream outStream = new ObjectOutputStream(client.getOutputStream());

          // Agent Input Info
          outStream.writeUTF(data);
          outStream.writeUTF(getParameter("wwwrootdir"));
          outStream.writeUTF(getParameter("basedir"));
          outStream.writeUTF(host);
          outStream.writeInt(port);
          outStream.writeInt(size().width);
          outStream.writeInt(size().height);
          outStream.writeInt(wakeupTime);
          outStream.flush();

          // input stream from servlet: receive response
          inStream = new ObjectInputStream(client.getInputStream());

          int result = inStream.readInt();

          if(result == AgentError.ERROR) {
            System.out.println("error on server");
            return true;
          }

          String imageUrl = inStream.readUTF();

          // exhibite image
          getAppletContext().showDocument(new URL(imageUrl), "appletImage");
        }
        catch(IOException e1) {
          e1.printStackTrace();
        }
        catch(SecurityException e2) {
          e2.printStackTrace();
        }
        catch(NumberFormatException e3) {
          e3.printStackTrace();
        }
        catch(Exception e4) {
          e4.printStackTrace();
        }
        finally {
          // always close the connection
          // this code executes no matter how the try block completes
          if(client != null) {
            try { client.close(); }
            catch(IOException ignored) {}
          }
        }
      }
    }

    return true;
  }

}
