import java.awt.*;

public class TimeFlag extends Symbol {
  // pos = center; size; 
  Abc caption;
  int height;
  int poleLength;

  // constants
  final int UPPER_MARGIN = 7;
  final int MIDDLE_MARGIN = 5;

  TimeFlag(int xPos, int yPos, int height, int poleLength, String caption, Color color)
  {
    this.position = new Point (xPos, yPos + UPPER_MARGIN);
    this.caption = new Abc(caption, position);
    this.height = height;
    this.poleLength = poleLength;
    this.caption.setAlign(0,-1);
    this.color = color;
  }

  void draw(Graphics g, CoordinateMapper mapper)
  {
    Polygon triangle;
    Color currentColor;
    int DX = 10;
    int DY = 10;

    caption.draw(g);

    currentColor = g.getColor();
    g.setColor(color);

    g.setColor(Color.red);
    // draw flag pole - dotted line
    int yi = position.y + MIDDLE_MARGIN + DY;
    int yf = (position.y - UPPER_MARGIN) + height + poleLength;
    int dy_on = 10;
    int dy_off = 4;
    int dy = dy_on;
    boolean fdraw = true;

    for(int y=yi; y<yf; y+=dy) {
      if(fdraw) {
        if(y+dy > yf)
          dy = yf - y;
        g.drawLine(position.x, y, position.x, y+dy);
      }

      fdraw = !fdraw;
      if(fdraw)
        dy = dy_on;
      else
        dy = dy_off;
    }

    // draw flag head - triangle
    triangle = new Polygon();
    triangle.addPoint(position.x - DX, position.y + MIDDLE_MARGIN);
    triangle.addPoint(position.x + DX, position.y + MIDDLE_MARGIN);
    triangle.addPoint(position.x, position.y + MIDDLE_MARGIN + DY);
    g.fillPolygon(triangle);

    // restore color
    g.setColor(currentColor);

  } 
}
