import java.awt.*;

public class VisualTask extends Task {
  Point position;
  Abc name;
  Abc resp;
  int width;
  int height;

  // margin for the task (title [left/upper] + bars [upper])
  final int leftMargin = 5; 
  int rightMargin = 10; 
  final int verticalMargin = 18;

  VisualTask(int x, int y, int captionSize, int responsavelSize, Task task)
  {
    Point pName, pResp;
    int maxWidth;
    position = new Point(x,y);
    this.name = new Abc(task.getCaption(), captionSize);
    this.resp = new Abc(task.getResponsavel(), responsavelSize);
    this.height = 2*verticalMargin + name.height() + resp.height();
    pName = new Point(x + leftMargin, y + (height/2 - name.height()));
    this.name.setColor(CustomColor.x666666);
    this.name.setPosition(pName);
    this.name.setAlign(-1,0); // x align = left; y align = upper
    pResp = new Point(x + leftMargin, y + height/2 + name.height()/2);
    this.resp.setColor(CustomColor.x666666);
    this.resp.setPosition(pResp);
    this.resp.setAlign(-1,0); // x align = left; y align = upper
    if (resp.width() > name.width()) 
        maxWidth = resp.width();
    else
        maxWidth = name.width();
    this.width = leftMargin + maxWidth + rightMargin;
    this.caption = task.caption;
    this.caption_link = task.caption_link;
    this.responsavel = task.responsavel;
    this.estimateStartLabel = task.estimateStartLabel;
    this.estimateEndLabel = task.estimateEndLabel;
    this.currentStartLabel = task.currentStartLabel;
    this.currentEndLabel = task.currentEndLabel;
    this.status = task.status;
    this.estimate = task.estimate;
    this.current = task.current;
    this.current_link = task.current_link;
  }

  public int width()
  {
    return(this.width);
  }

  public int height()
  {
    return(this.height);
  }

  public void stretch(int width)
  {
  	int maxWidth;
    this.width = width;
    if (resp.width() > name.width()) 
        maxWidth = resp.width();
    else
        maxWidth = name.width();
    // always align to the left --> recalculate rightMargin
    rightMargin = width - leftMargin - maxWidth; 
  }
  
  void draw(Graphics g, CoordinateMapper mapper, HotSpot hotspots)
  {
    Abc abc;
    int xpos, ypos;
    Point p;
    Color old;

    // background -- no background color (transparent)
    //old = g.getColor();
    //g.setColor(Color.white);
    //g.fillRect(position.x, position.y, width, height);
    //g.setColor(old);

    // task title
    //abc = new Abc(super.getCaption(), CustomColor.x666666);

    // Abc alignment test
    //xpos = position.x + leftMargin;
    //ypos = position.y + height/2;
    //g.drawLine(xpos,ypos,xpos+30,ypos);

    //p = new Point(xpos, ypos);
    //abc.setAlign(-1,0); // x align = left; y align = center
    //abc.setPosition(p);
    name.draw(g);
    resp.draw(g);

    // task bars
    old = g.getColor();
    g.setColor(CustomColor.x666666);
    g.drawLine(position.x, position.y,
               position.x, position.y+height);
    g.drawLine(position.x,       position.y,
               position.x+width, position.y);
    g.drawLine(position.x,       position.y+height,
               position.x+width, position.y+height);
    super.drawBars(g, position.y, height, mapper, hotspots);
    g.setColor(old);
  } 
}
