//-------------------------------------------------------------------------------------
// --- Curva S --- 
// Desenvolvimento: Simone Barbosa (03-2001)
// Reformulacao: Cesar Tadeu POZZER (05-05-2001)
//--------------------------------------------------------------------- 

//versao do dia 30/07/2001


// POZZER
// todas as variavies da figura sao dadas em pixels
// ------------------------------------------------------------  -                  
// |     valor                                                |  |                    
// |       ^                                                  |  | cabecalho
// |       |                                                  |  |       
// |  yfim-|----------------------------------------          |  -
// |       |                                       |          | 
// |       |                                       |          |                
// |       |                                       |          |                
// |       |dy                                     |          | height               
// |       |                                       |          |                
// |       |                                       |          |                
// |       |                                       |          |                
// |       |                dx                     |          |                
// |  yini-|------|--------------------------------|---> data |  -                                                       
// |      xini   graf                             xfim        |  |                   
// |                                                          |  | rodape        
// |                                                          |  |         
// ------------------------------------------------------------  -                                                                
// |-------|            width                      |----------|                
// margem_esq                                       margem_dir  
//                                
// cabecalho   = altura do cabecalho no eixo y
// rodape      = altura do rodape no eixo y. O valor de xini e' dado a partir deste valor
// margem_esq  = margem esquerda da area grafica no eixo x
// margem_dir  = margem direita da area grafica no eixo x
// yini        = height - rodape
// xini        = margem_esq
// graf        = posicao inicial do grafico de linhas
// yini e yfim = coordenadas iniciais de referencia para desenhar todo o grafico
// dy          = height-(cabecalho+rodape)
// dx          = width-(margem_esq+margem_dir)
// escala_y    = distancia em valor entre cada divisao do eixo y



import java.applet.*;
import java.awt.*;
import java.util.*;

public class curva2 extends Applet {
   static int width;
   static int height;
   static int num_meses;
   static String font_name;
   static int font_size;
   static Font font; 
  
   // POZZER
   // PS: usando o tipo Vector, da problemas de cache toda vez que os dados sao alterados.
   static Color colors[]      = new Color[100];
   static String descricoes[] = new String[100];
   static float valores_a[]     = new float[100];
   static float valores_b[]     = new float[100];
   static String legenda_x, legenda_y;
   static String legenda_a, legenda_b;
   
   //POZZER
   static int escala_y; //incrementos em pixels para cada divisao no eixo y.
   static float soma_a, soma_b; //soma dos valores dos graficos a e b.
   static float max_a_b;        //maior valor entre soma_a e soma_b
   
   //POZZER
   static int cabecalho  = 50;  //(PREDEFINIDO)
   static int margem_esq = 50;  //(PREDEFINIDO)
   static int margem_dir = 100; //(PREDEFINIDO)
   static int rodape     = 30;  //(PREDEFINIDO)
   static int graf       = 20;  //(PREDEFINIDO)

   // chamado apenas uma vez, quando a pgina HTML  carregada
   public void init() {
      int i;
      String temp = new String();

      // l parmetros do arquivo HTML   
      width    = Integer.parseInt(this.getParameter("width"));
      height   = Integer.parseInt(this.getParameter("height"));
      num_meses= Integer.parseInt(this.getParameter("num_barras"));
      
      temp = this.getParameter("escala_y");
      escala_y = 30;
      if (temp != null) {
         escala_y = Integer.parseInt(temp);
      }

      temp = this.getParameter("font_size");
      font_size = 10;
      if (temp != null) {
         font_size = Integer.parseInt(temp);
      }


      legenda_x = this.getParameter("legenda_x");
      legenda_y = this.getParameter("legenda_y");

      legenda_a = this.getParameter("legenda_a");
      legenda_b = this.getParameter("legenda_b");

      temp = this.getParameter("font_name");
      if (temp == null) {
         font_name = new String("SansSerif");
      }
      else {
         font_name = new String(temp);
      }

      // inicializacoes gerais
      soma_a = soma_b = 0;
      
      // l valores e descries      
      for (i=0; i < num_meses; i++) {
         valores_a[i]  = Float.valueOf(this.getParameter("valora" + (i+1))).floatValue();
         valores_b[i]  = Float.valueOf(this.getParameter("valorb" + (i+1))).floatValue();
         descricoes[i] = (String)(this.getParameter("data" + (i+1)));

         soma_a += valores_a[i];
         soma_b += valores_b[i]; 
         
         if(soma_a > soma_b)
            max_a_b = soma_a;
         else
            max_a_b = soma_b;
     }

      // l cores dos graficos
      colors[0] = (Color)this.getColorParameter("cora");
      colors[1] = (Color)this.getColorParameter("corb");

      // inicializa fonte
      font = new Font(font_name, Font.BOLD, font_size);
   }


   // chamado toda a vez em que a pgina  redesenhada
   public void paint(Graphics g) {
      int i;
      
      //POZZER
      int x, y, x2, y2;
      int incx, incy;  //incrementos em x e y para desenhar tudo
      int xini, yini;  //inicio da area util para desenhar
      int dx, dy;      //tamanho da area util para desenhar
      float valor;       //valor do mes somado com os anteriores
      float razao;     //razao entre um pixel e valor numerico do grafico
      int max_meses_real; //numero de meses que o valor de realizado nao e' zero
      

      String tickString = new String();
      String descricao = new String();

      // limpa a tela
      g.setColor(Color.white);
      g.fillRect(0,0,width,height);

      //---------------------------------------------------------------------------------------------
      //define variaveis de coordenadas graficas, conforme legenda inicial
      //---------------------------------------------------------------------------------------------
      dy   = height-(cabecalho+rodape);
      dx   = width-(margem_esq+margem_dir+graf);
      xini = margem_esq;
      yini = height - rodape;

      //---------------------------------------------------------------------------------------------
      // desenha os eixos e suas setas
      //---------------------------------------------------------------------------------------------
      g.setColor(Color.black);
      g.drawLine(xini, yini, xini, cabecalho-10); // vertical axis
      g.drawLine(xini, cabecalho-10, xini-2, cabecalho-10+3);
      g.drawLine(xini, cabecalho-10, xini+2, cabecalho-10+3);

      g.drawLine(xini-5, yini, width-margem_dir+10, yini);  // horizontal axis
      g.drawLine(width-margem_dir+10, yini, width-margem_dir+5, yini-3);
      g.drawLine(width-margem_dir+10, yini, width-margem_dir+5, yini+3);

      //---------------------------------------------------------------------------------------------
      // legendas dos eixos
      //---------------------------------------------------------------------------------------------
      if (legenda_x != "") {
         g.setFont(font);
         g.drawString(legenda_x, width-margem_dir+10-g.getFontMetrics(font).stringWidth(legenda_x), yini+15);
      }
      if (legenda_y != "") {
         g.setFont(font);
         g.drawString(legenda_y, 0, cabecalho-20);
      }

      //---------------------------------------------------------------------------------------------
      // legendas do grfico
      //---------------------------------------------------------------------------------------------
      g.setColor((Color)colors[0]);
      g.drawLine(xini+30, cabecalho+30+0, xini+60, cabecalho+30+0);
      g.drawLine(xini+30, cabecalho+30+1, xini+60, cabecalho+30+1);
      g.drawLine(xini+30, cabecalho+30+2, xini+60, cabecalho+30+2);
     
      g.setColor((Color)colors[1]);
      g.drawLine(xini+30, cabecalho+50+0, xini+60, cabecalho+50+0);
      g.drawLine(xini+30, cabecalho+50+1, xini+60, cabecalho+50+1);
      g.drawLine(xini+30, cabecalho+50+2, xini+60, cabecalho+50+2);

      g.setColor(Color.black);
      g.drawString(legenda_a, xini+63, cabecalho+34);
      g.drawString(legenda_b, xini+63, cabecalho+54);

      //--------------------------------------------------------------------------------------------
      // desenha os ticks no eixo vertical e escreve os valores correspondentes
      //--------------------------------------------------------------------------------------------
      razao = (float)dy/(float)max_a_b;
      for (valor=0; valor<=(max_a_b); valor+=escala_y)
      {
         tickString = String.valueOf((int)valor);
         y = yini - (int)(razao*(float)valor);
         // desenha o tick
         g.drawLine(xini-2, y, xini+2, y);
         // escreve o valor correspondente
         g.drawString(tickString, xini - 10 - g.getFontMetrics(font).stringWidth(tickString), y+6);
      }

      //--------------------------------------------------------------------------------------------
      // desenha os ticks no eixo horizontal e escreve as datas correspondentes
      //--------------------------------------------------------------------------------------------
      incx = dx/num_meses;
      x = xini+graf;
      for (i=0; i< num_meses; i++) {
         tickString = descricoes[i];
         // desenha o tick
         g.drawLine(x, yini-2, x, yini+2);
         // escreve o valor correspondente
         g.drawString(tickString, x - g.getFontMetrics(font).stringWidth(tickString)/2, yini+15);
         x+=incx;
      }

      //------------------------------------------------------------------------
      // valores previstos
      // desenha as barras e escreve as descries ( esquerda do eixo vertical) e os valores ( direita da barra)
      //------------------------------------------------------------------------
      g.setColor(colors[0]);
      valor = 0;
      razao = (float)dy/(float)max_a_b;
      x     = xini+graf;
      incx  = dx/num_meses;
      x2    = y2 = 0;
      for (i=0; i < num_meses; i++) 
      {
         valor += valores_a[i];
         y = yini - (int)(razao*(float)valor);
         
         // desenha a linha
         if(i>0)
            g.drawLine(x, y, x2, y2);
         g.fillOval(x-1, y-1, 4, 4);

         // prepara para escrever as descricoes e os valores
         g.setFont(font);
         g.drawString(String.valueOf(valor), x+4, y+11);

         x2 = x;
         y2 = y;
         x += incx;
      }

      //------------------------------------------------------------------------
      // valores realizados
      // desenha as barras e escreve as descries ( esquerda do eixo vertical) e os valores ( direita da barra)
      //------------------------------------------------------------------------
      g.setColor(colors[1]);
      valor = 0;
      razao = (float)dy/(float)max_a_b;
      x     = xini+graf;
      incx  = dx/num_meses;
      x2    = y2 = 0;
      
      //----------------------------------------------------------------------
      // descobre qual o ultimo mes que tem valor realizado diferente de zero.
      //----------------------------------------------------------------------
      max_meses_real = 0;
      for (i=0; i < num_meses; i++) 
      {
         if(valores_b[i] != 0)
            max_meses_real = i;
      }
      
      for (i=0; i <= max_meses_real; i++) 
      {
         valor += valores_b[i];
         y = yini - (int)(razao*(float)valor);
         
         // desenha a linha
         if(i>0)
            g.drawLine(x, y, x2, y2);
         g.fillOval(x-1, y-1, 4, 4);

         // prepara para escrever as descricoes e os valores
         g.setFont(font);
         //nao mostra o realizado se o valor gasto no mes for igual a zero.
         if(valores_b[i] != 0)
            g.drawString(String.valueOf(valor), x+4, y+11);

         x2 = x;
         y2 = y;
         x += incx;
      }
   }

   // converte RRGGBB para uma cor valida
   protected Color getColorParameter(String name) 
   {
      String value = this.getParameter(name);
      try { return new Color(Integer.parseInt(value, 16)); }
      catch (Exception e) { return null; }
   }
}
