import java.util.Vector;
import java.awt.*;

class Tag {
  // implementation
  String caption;
  int pos;
}

public class YearSet {
  Tag year;
  // Tag's
  Vector months;

  // constants
  final int FONT_SIZE = 12;
  final int iINIT = 0;

  int max = iINIT;
  int min = iINIT;

  YearSet()
  {
    year = new Tag();
    months = new Vector();
  }

  public int getFontSize()
  {
    return(FONT_SIZE);
  }

  public int getMin()
  {
    return(min);
  }

  public int getMax()
  {
    return(max);
  }

  void updateMinMax(int position)
  {
    // init max & min
    if(max==iINIT && min==iINIT) {
      max = position;
      min = position;
      return;
    }

    // update max & min
    if(max < position) max = position;
    if(min > position) min = position;
  }

  public void addMonth(String caption, int position)
  {
    Tag month;

    month = new Tag();

    month.caption = caption;
    month.pos = position;
    months.addElement(month);

    // update min & max
    updateMinMax(position);
  }

  public void setYear(String caption)
  {
    year.caption = caption;
  }

  public void calcYearPosition()
  {
    double f;
    // year.position = (x of first month + x of last month) / 2
    f = (double)(min + max) / 2.0;
    year.pos = (int) f;
  }

  public void draw(Graphics g, int y0, int tbHeight,
                   CoordinateMapper mapper)
  {
     Abc abc;
     int xpos;
     Point p;
     int UPPER_MARGIN = 10;
     int LOWER_MARGIN = 10;

     // no mapper
     if(mapper==null)
       return;

     // year
     calcYearPosition();
     xpos = mapper.user2Screen(year.pos);
     p = new Point(xpos, y0 + UPPER_MARGIN);
     abc = new Abc(year.caption, p, FONT_SIZE);
     abc.setAlign(0,1); // x align = center; yalign = up
     abc.setStyle(Font.BOLD);
     abc.draw(g);

     // Year alignment test
     //g.drawLine(xpos, y0-5, xpos, y0+5);

     // months
     for(int i=0; i<months.size(); i++) {
       Tag tag;

       tag = (Tag)months.elementAt(i);
       xpos = mapper.user2Screen(tag.pos);
       p = new Point(xpos, y0 + tbHeight - LOWER_MARGIN);
       abc = new Abc(tag.caption, p, FONT_SIZE);
       abc.setAlign(0,0); // x align = center; yalign = center
       abc.draw(g);
       // Month alignment test
       //g.drawLine(xpos, y0+tbHeight, xpos, y0+tbHeight+10);
     }
  }

}
