-- ------------------------------------------------------------------------
-- CONECTANDO O BANCO
-- ------------------------------------------------------------------------

function AbreBD()
-- ------------------------------------------------------------------------
-- Funo que faz conexo com o Banco de Dados. Em caso de erro, retorna a
-- mensagem a ser apresentada
-- ------------------------------------------------------------------------
   --local erro = DBOpen("DSN=PEGASO;")
   local erro = DBOpen("DSN=pegaso_26_09_2003;")
   --local erro = DBOpen("DSN=pegaso_teste;")

   if erro then
      if not getuser then
         dofile('global.lua')
      end
      error( 'No foi possvel estabelecer conexo com o  Banco de Dados. '..
 	           'Talvez seu login ('..getuser()..') no tenha acesso ao BD.'..
 	           'Entre em contato com suporte.\n<BR>Error='..erro )
   else
      ESTADO_BD = 'aberto'
      return nil
   end
end


function FechaBD()
   DBClose()
   ESTADO_BD = 'fechado'
   return
end



-- ------------------------------------------------------------------------
-- ACESSO AO BANCO
-- ------------------------------------------------------------------------


function AbreTransacao()
   DBSetAttribute("AUTOCOMMITMODE","OFF")
end


function FechaTransacao()
   DBExec("%COMMIT")
   DBSetAttribute("AUTOCOMMITMODE","ON")
end


function ConsultaBD(tabelas,colunas,condicoes,ordem)
   local temp = {}
   local cond,ord
   if condicoes and condicoes ~= '' then
      cond = ' WHERE '..condicoes
   else
      cond = ''
   end
   if ordem and ordem ~= '' then
     ord = ' ORDER BY '..ordem
   else
     ord = ''
   end
   if not colunas or colunas == '' then
      execsql = 0
   end
   if tabelas and not execsql then
      if ESTADO_BD ~= 'aberto' then
         AbreBD()
      end
      strtab = "SELECT "..colunas.." FROM "..tabelas.."  "..cond.." "..ord.." "
      DBExec(strtab)
      temp = DBRow()
      if not temp then
         temp = ''
      end
      if ( type(temp) == 'string' ) then
         local t = temp
         temp = { }
         temp[1] = t
      end
      return temp
   else
      write('Erro ao consultar Dados, provavelmente no existe o campo tabela.\n')
   end
end


function ConsultaBD2(tabelas,colunas,condicoes,ordem)
   local temp, temp2 = {}, {}
   local cond,ord
   local i
   if condicoes and condicoes ~= '' then
      cond = ' WHERE '..condicoes
   else
      cond = ''
   end
   if ordem and ordem ~= '' then
     ord = ' ORDER BY '..ordem
   else
     ord = ''
   end
   if not colunas or colunas == '' then
      execsql = 0
   end
   if tabelas and not execsql then
      strtab = "SELECT "..colunas.." FROM "..tabelas.."  "..cond.." "..ord.." "
      if ESTADO_BD ~= 'aberto' then
         AbreBD()
      end
      DBExec(strtab)
      temp = DBRow()
      i = 1
      if ( not temp ) then
         temp = {}
         temp[1] = ''
         temp2[1] = temp
      else
         while ( temp ) do
            temp2[i] = temp
            temp = DBRow()
            if ( type(temp) == 'string' ) then
               local t = temp
               temp = { }
               temp[1] = t
            end
            i = i + 1
         end
      end
      return temp2
   else
      write('Erro ao consultar Dados, provavelmente no existe o campo tabela.\n')
   end
end


function EscreveBD(tabela,colunas,valores)
   local strtab
   if not colunas or not valores then
      execsql = 0
   end
   if tabela and not execsql then
      if ESTADO_BD ~= 'aberto' then
         AbreBD()
      end
      strtab = "INSERT INTO "..tabela.." ("..colunas..") VALUES ("..valores..") "
      DBExec(strtab)
   else
      write('Erro ao inserir Dados, provavelmente no existe o campo tabela.\n')
   end
end


function AlteraBD2( tabela, colunas, valores, condicoes )
   -- Controla se o comando SQL ser executado ou no
   local execsql = 1
   -- String com as condies para alterao no BD
   local cond
   -- Trata caso de tabela invlida ou inextistente
   if ( not tabela or tabela == '' ) then
      write( 'AlteraBD : Sem tabelas para alterar!' )
      execsql = 0
   end
   -- Trata caso de colunas invlidas ou inextistentes
   if ( not colunas or colunas == '' ) then
      write( 'AlteraBD : Sem colunas para alterar!' )
      execsql = 0
   end
   -- Trata caso de valores inexistentes
   if ( not valores ) then
      write( 'alteraBD : Sem valores para alterar!' )
      execsql = 0
   end
   -- Trata os casos de existir ou no condies
   if ( not condicoes ) then
      cond = ''
   else
      cond = ' WHERE ' .. condicoes
   end

   -- INCOMPLETO Montar tabela separando as colunas e outra separando os valores e fazer um loop
   strtab = 'UPDATE ' .. tabela .. ' SET (' .. colunas .. ') VALUES (' .. valores .. ') ' .. cond

   -- Executa comando SQL se execsql = 1
   if ( execsql == 1 ) then
      if ESTADO_BD ~= 'aberto' then
         AbreBD()
      end
      DBExec(strtab)
   end
end


function AlteraBD( tabela, colunas, condicoes )
   -- Controla se o comando SQL ser executado ou no
   local execsql = 1
   -- String com as condies para alterao no BD
   local cond
   -- Trata caso de tabela invlida ou inextistente
   if ( not tabela or tabela == '' ) then
      write( 'AlteraBD : Sem tabelas para alterar!' )
      execsql = 0
   end
   -- Trata caso de colunas invlidas ou inextistentes
   if ( not colunas or colunas == '' ) then
      write( 'AlteraBD : Sem colunas para alterar!' )
      execsql = 0
   end

   -- Trata os casos de existir ou no condies
   if ( not condicoes ) then
      cond = ''
   else
      cond = ' WHERE ' .. condicoes
   end

   -- INCOMPLETO Montar tabela separando as colunas e outra separando os valores e fazer um loop
   strtab = 'UPDATE ' .. tabela .. ' SET ' .. colunas .. ' ' .. cond

   -- Executa comando SQL se execsql = 1
   if ( execsql == 1 ) then
      if ESTADO_BD ~= 'aberto' then
         AbreBD()
      end
      DBExec(strtab)
   end
end


function ApagaBD( tabela, condicoes )
   -- Controla se o comando SQL ser executado ou no
   local execsql = 1
   -- String com as condies para alterao no BD
   local cond
   -- Trata caso de tabela invlida ou inextistente
   if ( not tabela or tabela == '' ) then
      write( 'ApagaBD : Sem tabela para apagar!' )
      execsql = 0
   end
   -- Trata os casos de existir ou no condies
   if ( not condicoes or condicoes == '' ) then
      cond = ''
      write( 'ApagaBD : So necessrias condies para apagar uma tupla do BD!' )
      execsql = 0
   else
      cond = ' WHERE ' .. condicoes
   end

   -- Monta comando SQL
   strtab = 'DELETE FROM ' .. tabela .. cond

   -- Executa comando SQL se execsql = 1
   if ( execsql == 1 ) then
      if ESTADO_BD ~= 'aberto' then
         AbreBD()
      end
      DBExec(strtab)
   end
end
