-- ------------------------------------------------------------------------------------------------
-- CORES.LUA
-- ------------------------------------------------------------------------------------------------

-- ------------------------------------------------------------------------------------------------
-- Tratamento do diretrio atual para detectar onde deve se buscar os scripts LUA e onde deve se 
-- buscar as imagens 
-- ------------------------------------------------------------------------------------------------
   if ( strfind(cgilua.script_vdir, '/lua') ) then
       dirLua = ''                   -- diretorio LUA
       dirImg = '../'                -- diretorio IMAGENS
   else
       dirLua = 'lua/'               -- diretorio LUA
       dirImg = ''                   -- diretorio IMAGENS
   end 
   
-- ------------------------------------------------------------------------------------------------
-- funcao que monta tabela com endereco e legenda respectiva a todos os status possiveis   
-- ------------------------------------------------------------------------------------------------
function init_bolas()       
   dofile( dirLua.."constantes.lua" )
   
   bolas = {              
              bola_conclui     = {dirImg.._IMG_CONCLUIDO_, _DESCR_IMG_CONCLUIDO_},
              bola_desempenho1 = {dirImg.._IMG_DESEMPENHO_NEGATIVO_, _DESCR_IMG_DESEMPENHO_NEGATIVO_},              
              bola_desempenho2 = {dirImg.._IMG_DESEMPENHO_PREVISTO_, _DESCR_IMG_DESEMPENHO_PREVISTO_},
              bola_desempenho3 = {dirImg.._IMG_DESEMPENHO_POSITIVO_, _DESCR_IMG_DESEMPENHO_POSITIVO_},
              bola_edita       = {dirImg.._IMG_EDICAO_, _DESCR_IMG_EDICAO_},
              bola_cancela     = {dirImg.._IMG_CANCELADO_, _DESCR_IMG_CANCELADO_}                   
           }  

   return bolas
end


-- ------------------------------------------------------------------------------------------------
-- funcao que identifica o status de uma fase e retorna o endereco do jpg correspondente
-- ------------------------------------------------------------------------------------------------
function CorFase(codigo, stat_cod, proj_desempenho)  
   dofile( dirLua.."global.lua" )
   
   bolas = init_bolas()  
   
   local bola = {}   
   
   if not temConteudo(proj_desempenho) then
      if ESTADO_BD ~= 'aberto' then
         AbreBD()
      end
    
      DBExec('SELECT stat_cod, proj_desempenho FROM projeto WHERE proj_cod = '..codigo)
      local projeto = DBRow()
      if projeto then
         stat_cod = projeto.stat_cod
         proj_desempenho = projeto.proj_desempenho
      end    
   end
      
   if stat_cod == 1 then                  -- em edicao
      bola = bolas.bola_edita
   elseif stat_cod == 2 then              -- em andamento
      if proj_desempenho == 0 then        -- nao ha atividades para o projeto (na verdade o projeto deveria estar em edicao)
         bola = bolas.bola_desempenho2
      elseif proj_desempenho == 1 then    -- abaixo do previsto
         bola = bolas.bola_desempenho1
      elseif proj_desempenho == 2 then    -- de acordo com o previsto
         bola = bolas.bola_desempenho2
      elseif proj_desempenho == 3 then    -- acima do previsto
         bola = bolas.bola_desempenho3
      end      
   elseif stat_cod == 3 then              -- cancelado
      bola = bolas.bola_cancela
   elseif stat_cod == 4 then              -- concluido
      bola = bolas.bola_conclui
   end           
  
   return bola[1],bola[2]
end

-- ------------------------------------------------------------------------------------------------
-- Monta cabecalho com todas as GIFs e suas respectivas descricoes
-- ------------------------------------------------------------------------------------------------
function montaBolasLegendas(dirImagens)   
   dofile( dirLua.."constantes.lua" ) 
   
   if not( temConteudo(dirImagens) ) then
      dirImagens = ''
   end     
       
   write ( '<table border="0" width="100%"><TR valign="top">\n' )                             
   write ( '<TD><IMG SRC="',dirImagens,_IMG_EDICAO_,'" align="right"></TD><TD width="33%">',_DESCR_IMG_EDICAO_,'</TD>\n' )
   write ( '<TD><IMG SRC="',dirImagens,_IMG_CONCLUIDO_,'" align="right"></TD><TD width="30%">',_DESCR_IMG_CONCLUIDO_,'</TD>\n' )  
   write ( '<TD><IMG SRC="',dirImagens,_IMG_CANCELADO_,'" align="right"></TD><TD width="30%">',_DESCR_IMG_CANCELADO_,'</TD>\n' )       
   write ( '</TR><TR valign="top">\n' )         
   write ( '<TD><IMG SRC="',dirImagens,_IMG_DESEMPENHO_PREVISTO_,'" align="right"></TD><TD width="33%">',_DESCR_IMG_DESEMPENHO_PREVISTO_,'</TD>\n' )     
   write ( '<TD><IMG SRC="',dirImagens,_IMG_DESEMPENHO_POSITIVO_,'" align="right"></TD><TD width="30%">',_DESCR_IMG_DESEMPENHO_POSITIVO_,'</TD>\n' )  
   write ( '<TD><IMG SRC="',dirImagens,_IMG_DESEMPENHO_NEGATIVO_,'" align="right"></TD><TD width="30%">',_DESCR_IMG_DESEMPENHO_NEGATIVO_,'</TD>\n' )                                                                                                                                                   
   write ( '</TR></table>\n' )
end