dofile ("acessabd.lua")
dofile( "global.lua" )

diaatual = date("%d")
mesatual = date("%m")
anoatual = date("%Y")
dataatual = diaatual..'/'..mesatual..'/'..anoatual

-- -------------------------------------------------
-- Entrada : codigo do Projeto
-- Saida : Custos Anuais Previstos
-- -------------------------------------------------
function retornaCustoPrev( cod )
   local result = {}
   if ( cod ) then
      local sql = "SELECT custo_ano, custo_prev_ano FROM custo WHERE proj_cod = "..cod.." ORDER BY custo_ano"
      DBExec(sql)
      local linha = DBRow()

      while linha do
         result[linha.custo_ano] = linha.custo_prev_ano
         linha = DBRow()
      end
   end
   return result
end

-- -------------------------------------------------
-- Entrada : codigo do Projeto
-- Saida : Custos Anuais Realizados
-- -------------------------------------------------
function retornaCustoReal( cod )
   local result = {}
   if ( cod ) then
      local sql = "SELECT year(dt_realizacao) as ano, sum(valor_real) as custo_real FROM custo_realizado "..
                  "WHERE proj_cod = "..cod.." GROUP BY year(dt_realizacao)"
      DBExec(sql)
      local linha = DBRow()

      while linha do
         result[linha.ano] = linha.custo_real
         linha = DBRow()
      end
   end
   return result
end

-- --------------------------------------------------------------------------
-- Verifica o valor passado como parametro retornando '' se o valor for NULO
-- --------------------------------------------------------------------------
function verifica(valor)
   if not(temConteudo(valor)) then
      valor = ''
   end
   return valor
end

function mostraInfoCustoPorMes ( cod )
   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end
   local sql = "SELECT proj_dt_ini_prev, proj_dt_fim_prev FROM projeto WHERE proj_cod = "..cod
   DBExec(sql)
   local resultado = DBRow()
   if resultado and resultado.proj_dt_ini_prev then
      proj_dt_ini_prev = resultado.proj_dt_ini_prev
      proj_dt_fim_prev = resultado.proj_dt_fim_prev
   end
   tamanho   = {'30%', '50%', '70%', '90%'}
   tab_meses = {'jan','fev','mar','abr','mai','jun','jul','ago','set','out','nov','dez','total anual'}
   mes_ini         = strsub(proj_dt_ini_prev,4,5)
   mes_fim         = strsub(proj_dt_fim_prev,4,5)
   ano_ini         = strsub(proj_dt_ini_prev,7,10)
   ano_fim         = strsub(proj_dt_fim_prev,7,10)
   num_anos        = ( ano_fim - ano_ini ) + 1
   ult_dig_ano_ini = strsub(ano_ini,4,4)
   ult_dig_ano_fim = strsub(ano_fim,4,4)
   num_anos_fixo   = num_anos

   -- -------------------------------------------------------------------------------------------------
   -- EXIBICAO DOS CAMPOS REFERENTES AO CUSTO ANUAL (DATAS E VALORES) CASO TENHAM SIDO CADASTRADOS
   -- -------------------------------------------------------------------------------------------------
   tabela = ''
   i      = strsub(ano_ini,4,4)
   i_fixo = i

   -- ----------------------------------------------------------------------------------------------------
   -- MONTA CABECALHO DA TABELA COM OS ANOS
   -- ----------------------------------------------------------------------------------------------------
   write('<HR WIDTH=85%>\n' )
   write('<table border="0" align="center"><tr><td class="fieldLabel" align="center" colspan="2">Custo Previsto por Ms</td></tr></table>\n' )
   while num_anos > 0 do
      if tonumber(num_anos) == tonumber(num_anos_fixo) then
         tabela = tabela..'<tr>\n'
         tabela = tabela..'<td width="20%"><b>Ms/Ano</b></td>\n'
         tabela = tabela..'<td width="20%" align="center" class="fieldLabel">200'..i..'</td>\n'
      else
         tabela = tabela..'<td width="20%" align="center" class="fieldLabel">200'..i..'</td>\n'
      end
      if tonumber(num_anos) == 1 then
         tabela = tabela..'</tr>\n'
      end
      i        = i + 1
      num_anos = num_anos - 1
   end

   -- ----------------------------------------------------------------------------------------------------
   -- MONTA MESES
   -- ----------------------------------------------------------------------------------------------------
   j = 1
   while tab_meses[j] do
      i = i_fixo
      num_anos = num_anos_fixo
      while num_anos > 0 do
         if tonumber(num_anos) == tonumber(num_anos_fixo) then
            tabela = tabela..'<tr>\n'
            tabela = tabela..'<td width="20%" class="fieldLabel">'..strupper(tab_meses[j])..'</td>\n'
            if j == 13 then
               tab_meses[j] = 'tot_ano'
            end
            -- ------------------------------------------------------------------
            -- TESTE SE O MES ATUAL DO LOOP  MENOR QUE O MES DA DATA DE INICIO
            -- ------------------------------------------------------------------
            if (tonumber(j) < tonumber(mes_ini)) then
               tabela = tabela..'<td width="20%" align="center">n/a</TD>\n'
            else
               if (tonumber(j) == 13) then
                  local sql = "SELECT sum(valor_real) as total FROM custo_previsto WHERE year(dt_prevista) = 200"..i.." AND proj_cod = "..tonumber(cod)
                  DBExec(sql)
                  local resultado = DBRow()
                  if resultado and resultado.total then
                     tabela = tabela..'<td width="20%" align="center"><b>'..ponto_centavo(formata_valor(resultado.total))..'</b></td>\n'
                  else
                     tabela = tabela..'<td width="20%" align="center"><b>0,00</b></td>\n'
                  end
               else
                  local sql = "SELECT valor_real FROM custo_previsto WHERE year(dt_prevista) = 200"..i.." AND month(dt_prevista) = "..j.." AND proj_cod = "..tonumber(cod)
                  DBExec(sql)
                  local resultado = DBRow()
                  if resultado and resultado.valor_real then
                     tabela = tabela..'<td width="20%" align="center">'..ponto_centavo(formata_valor(resultado.valor_real))..'</td>\n'
                  else
                     tabela = tabela..'<td width="20%" align="center">-</td>\n'
                  end
               end
            end
         else
            -- ------------------------------------------------------------------
            -- TESTE SE O MES ATUAL DO LOOP  MAIOR QUE O MES DA DATA DE FIM
            -- ------------------------------------------------------------------
            if (tonumber(i) < tonumber(ult_dig_ano_fim)) then
               if (tonumber(j) == 13) then
                  local sql = "SELECT sum(valor_real) as total FROM custo_previsto WHERE year(dt_prevista) = 200"..i.." AND proj_cod = "..tonumber(cod)
                  DBExec(sql)
                  local resultado = DBRow()
                  if resultado and resultado.total then
                     tabela = tabela..'<td width="20%" align="center"><b>'..ponto_centavo(formata_valor(resultado.total))..'</b></td>\n'
                  else
                     tabela = tabela..'<td width="20%" align="center"><b>0,00</b></td>\n'
                  end
               else
                  local sql = "SELECT valor_real FROM custo_previsto WHERE year(dt_prevista) = 200"..i.." AND month(dt_prevista) = "..j.." AND proj_cod = "..tonumber(cod)
                  DBExec(sql)
                  local resultado = DBRow()
                  if resultado and resultado.valor_real then
                     tabela = tabela..'<td width="20%" align="center">'..ponto_centavo(formata_valor(resultado.valor_real))..'</td>\n'
                  else
                     tabela = tabela..'<td width="20%" align="center">-</td>\n'
                  end
               end
            else
               if (tonumber(j) > tonumber(mes_fim)) and (j ~= 13) then
                  tabela = tabela..'<td width="20%" align="center">n/a</TD>\n'
               else
                  if (tonumber(j) == 13) then
                     local sql = "SELECT sum(valor_real) as total FROM custo_previsto WHERE year(dt_prevista) = 200"..i.." AND proj_cod = "..tonumber(cod)
                     DBExec(sql)
                     local resultado = DBRow()
                     if resultado and resultado.total then
                        tabela = tabela..'<td width="20%" align="center"><b>'..ponto_centavo(formata_valor(resultado.total))..'</b></td>\n'
                     else
                        tabela = tabela..'<td width="20%" align="center"><b>0,00</b></td>\n'
                     end
                  else
                     local sql = "SELECT valor_real FROM custo_previsto WHERE year(dt_prevista) = 200"..i.." AND month(dt_prevista) = "..j.." AND proj_cod = "..tonumber(cod)
                     DBExec(sql)
                     local resultado = DBRow()
                     if resultado and resultado.valor_real then
                        tabela = tabela..'<td width="20%" align="center">'..ponto_centavo(formata_valor(resultado.valor_real))..'</td>\n'
                     else
                        tabela = tabela..'<td width="20%" align="center">-</td>\n'
                     end
                  end
               end
            end
         end
         if tonumber(num_anos) == 1 then
            tabela = tabela..'</tr>\n'
         end
         i = i + 1
         num_anos = num_anos - 1
      end
      j = j + 1
   end
   if (tonumber(num_anos_fixo) < 5) then
      write('<table border="1" width="'..tamanho[num_anos_fixo]..'" align="center">\n')
   else
      write('<table border="1" width="100%" align="center">\n')
   end
   write(tabela)
   write('</table>\n')
end

function mostraInfoCustoPorMesAcomp ( cod )
   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end
   local sql = "SELECT proj_dt_ini_prev, proj_dt_fim_prev, proj_dt_ini_real, proj_dt_fim_real "..
               "FROM projeto WHERE proj_cod = "..tonumber(cod)
   DBExec(sql)
   local resultado = DBRow()
   if resultado and resultado.proj_dt_ini_prev then
      proj_dt_ini_prev = resultado.proj_dt_ini_prev
      proj_dt_fim_prev = resultado.proj_dt_fim_prev
      if resultado.proj_dt_ini_real then
         proj_dt_ini_real = resultado.proj_dt_ini_real
      end
      if resultado.proj_dt_fim_real then
         proj_dt_fim_real = resultado.proj_dt_fim_real
      end
   end

   tamanho   = {'30%', '50%', '70%', '90%'}
   tab_meses = {'jan','fev','mar','abr','mai','jun','jul','ago','set','out','nov','dez','total anual'}

   -- Mes e Ano Previstos
   mes_ini_prev = strsub(proj_dt_ini_prev,4,5)
   ano_ini_prev = strsub(proj_dt_ini_prev,7,10)
   mes_fim_prev = strsub(proj_dt_fim_prev,4,5)
   ano_fim_prev = strsub(proj_dt_fim_prev,7,10)

   -- Datas INICIAIS: Atribui mes e anos minimos e maximos do projeto
   if temConteudo(proj_dt_ini_real) then
      mes_ini_real = strsub(proj_dt_ini_real,5,6)
      if mes_ini_real < mes_ini_prev then
      	 mes_ini = mes_ini_real
      else
         mes_ini = mes_ini_prev
      end
      ano_ini_real = strsub(proj_dt_ini_real,0,4)
      if ano_ini_real < ano_ini_prev then
         ano_ini = ano_ini_real
      else
         ano_ini = ano_ini_prev
      end
   else
      mes_ini = mes_ini_prev
      ano_ini = ano_ini_prev
      mes_ini_real = mes_ini_prev
      ano_ini_real = ano_ini_prev
   end

   -- Datas FINAIS
   if temConteudo(proj_dt_fim_real) then
      mes_fim_real = strsub(proj_dt_fim_real,5,6)
      if mes_fim_real > mes_fim_prev then
      	 mes_fim = mes_fim_real
      else
         mes_fim = mes_fim_prev
      end
      ano_fim_real = strsub(proj_dt_fim_real,0,4)
      if ano_fim_real > ano_fim_prev then
         ano_fim = ano_fim_real
      else
         ano_fim = ano_fim_prev
      end
   else
      if (anoatual > ano_fim_prev) then
      	 mes_fim = tonumber(mesatual)
         ano_fim = tonumber(anoatual)
         mes_fim_real = tonumber(mesatual)
         ano_fim_real = tonumber(ano_atual)
      else
         mes_fim = mes_fim_prev
         ano_fim = ano_fim_prev
         mes_fim_real = mes_fim_prev
         ano_fim_real = ano_fim_prev
      end
   end

   num_anos        = ( ano_fim - ano_ini ) + 1
   ult_dig_ano_ini = strsub(ano_ini,4,4)
   ult_dig_ano_fim = strsub(ano_fim,4,4)
   num_anos_fixo   = num_anos

   -- ---------------------------------------------------------------------------------------------
   -- EXIBICAO DOS CAMPOS REFERENTES AO CUSTO ANUAL (DATAS E VALORES) CASO TENHAM SIDO CADASTRADOS
   -- ---------------------------------------------------------------------------------------------
   tabela = ''
   i      = strsub(ano_ini,4,4)
   i_fixo = i

   -- ---------------------------------------------------------------------------------------------
   -- MONTA CABECALHO DA TABELA COM OS ANOS
   -- ---------------------------------------------------------------------------------------------
   write('<HR WIDTH=85%>\n' )
   write('<table border="0" align="center"><tr><td class="fieldLabel" align="center" colspan="2">Custo Previsto/Realizado por Ms</td></tr></table>\n' )
   while num_anos > 0 do
      if tonumber(num_anos) == tonumber(num_anos_fixo) then
         tabela = tabela..'<tr>\n'
         tabela = tabela..'<td width="20%"><b>Ms/Ano</b></td>\n'
         tabela = tabela..'<td width="20%" align="center" class="fieldLabel">200'..i..'(Prev.)</td>\n'
         tabela = tabela..'<td width="20%" align="center" class="fieldLabel">200'..i..'(Real.)</td>\n'
      else
         tabela = tabela..'<td width="20%" align="center" class="fieldLabel">200'..i..'(Prev.)</td>\n'
         tabela = tabela..'<td width="20%" align="center" class="fieldLabel">200'..i..'(Real.)</td>\n'
      end
      if tonumber(num_anos) == 1 then
         tabela = tabela..'</tr>\n'
      end
      i        = i + 1
      num_anos = num_anos - 1
   end

   -- ----------------------------------------------------------------------------------------------
   -- MONTA VALORES DA TABELA
   -- ----------------------------------------------------------------------------------------------
   j = 1
   while (tab_meses[j]) do
      i = i_fixo
      num_anos = num_anos_fixo
      while (num_anos > 0) do
      	 if (tonumber(num_anos) == tonumber(num_anos_fixo)) then
            tabela = tabela..'<tr>\n'
            tabela = tabela..'<td width="20%" class="fieldLabel">'..strupper(tab_meses[j])..'</td>\n'
     	   end
         -- -----------------------------------------------------------------------------------------------
         -- Custos PREVISTOS
      	 -- -----------------------------------------------------------------------------------------------
      	 if ((tonumber(i) < tonumber(strsub(ano_ini_prev,4,4))) or ((tonumber(i) == tonumber(strsub(ano_ini_prev,4,4))) and (tonumber(j) < tonumber(mes_ini_prev)))) then
            if (tonumber(j) == 13) then
               tabela = tabela .. '<td width="20%" align="center"><b>0,00</b></TD>\n'
            else
               tabela = tabela .. '<td width="20%" align="center">n/a</TD>\n'
            end

      	 elseif ((tonumber(i) == tonumber(strsub(ano_fim_prev,4,4))) and (tonumber(j) > tonumber(mes_fim_prev))) or (tonumber(i) > tonumber(strsub(ano_fim_prev,4,4))) then
      	    if (tonumber(j) == 13) then
               local sql = "SELECT SUM(valor_real) as valor_real FROM custo_previsto WHERE proj_cod = " .. cod .. " and year(dt_prevista) = 200" .. i
               DBExec(sql)
               local result = DBRow()
               if result and result.valor_real then
                  tabela = tabela .. '<td width="20%" align="center"><b>' .. ponto_centavo(formata_valor(result.valor_real)) .. '</b></TD>\n'
               else
                  tabela = tabela .. '<td width="20%" align="center"><b>0,00</b></TD>\n'
               end
      	    else
      	       tabela = tabela .. '<td width="20%" align="center">n/a</TD>\n'
      	    end

      	 else
      	    if (tonumber(j) == 13) then
      	       local sql = " SELECT sum(valor_real) as valor_real FROM custo_previsto WHERE year(dt_prevista) = 200"..i..
    	                     " AND proj_cod = " .. cod
    	         DBExec(sql)
    	         local result = DBRow()
               if result and result.valor_real then
                  tabela = tabela .. '<td width="20%" align="center"><b>' .. ponto_centavo(formata_valor(result.valor_real)) .. '</b></TD>\n'
               else
                  tabela = tabela .. '<td width="20%" align="center"><b>0,00</b></TD>\n'
               end
            else
  	        local sql = " SELECT valor_real FROM custo_previsto WHERE year(dt_prevista) = 200"..i..
	                      " AND month(dt_prevista) = " .. j .. " AND proj_cod = " .. cod
	          DBExec(sql)
	          local result = DBRow()
               if result and result.valor_real then
                  tabela = tabela .. '<td width="20%" align="center">' .. ponto_centavo(formata_valor(result.valor_real)) .. '</TD>\n'
               else
                  tabela = tabela .. '<td width="20%" align="center">-</TD>\n'
               end
            end
      	 end

         -- ----------------------------------------------------------------------------------------------------
         -- Custos REALIZADOS
      	 -- ----------------------------------------------------------------------------------------------------
      	 if (tonumber(j) == 13) then
  	    local sql = " SELECT sum(valor_real) as valor_real FROM custo_realizado WHERE year(dt_realizacao) = 200"..i..
	                " AND proj_cod = " .. tonumber(cod)
	    DBExec(sql)
	    local result = DBRow()
            if result and result.valor_real then
               tabela = tabela .. '<td width="20%" align="center"><b>' .. ponto_centavo(formata_valor(result.valor_real)) .. '</b></TD>\n'
            else
               tabela = tabela .. '<td width="20%" align="center"><b>0,00</b></TD>\n'
            end
      	 else
      	    local sql = " SELECT sum(valor_real) as valor_real FROM custo_realizado WHERE year(dt_realizacao) = 200"..i..
	                " AND month(dt_realizacao) = " .. j .. " AND proj_cod = " .. tonumber(cod)
	    DBExec(sql)
	    local result = DBRow()
            if result and result.valor_real then
               tabela = tabela .. '<td width="20%" align="center">' .. ponto_centavo(formata_valor(result.valor_real)) .. '</TD>\n'
            else
               tabela = tabela .. '<td width="20%" align="center">-</TD>\n'
            end
         end
      	 if (tonumber(num_anos) == 1) then
      	    tabela = tabela .. '</tr>\n'
      	 end
      	 i = i + 1
      	 num_anos = num_anos - 1
      end
      j = j + 1
   end
   write('<table border="0" width="100%">\n' )
   write('<tr><td width=10>&nbsp;</td><td>\n' )
   if (tonumber(num_anos_fixo) < 5) then
      write('<center><table border="1" width="'..tamanho[num_anos_fixo]..'">\n')
   else
      write('<center><table border="1" width="100%">\n')
   end
   write(tabela)
   write('</table></center>\n')
   write('</td></tr></table><br>\n' )
end

function AtualizaCustoPorMes ( cod )
   write( '<BR>\n' )
   write( '<TABLE BORDER="0" ALIGN="CENTER">\n' )

   if (strsub(diaatual,0,1) == '0') then
      diaatual = strsub(diaatual,2,3)
   end

   if (strsub(mesatual,0,1) == '0') then
      mesatual = strsub(mesatual,2,3)
   end

   write( '<TR><TD COLSPAN=3><B>ltima atualizao</B></TD></TR>\n' )
   ultimadata = {}
   ultimadatatemp = {}
   -- ---------------------------------------------------------------------------------------------------------
   -- Busca os valores da tabela CUSTO_REALIZADO, exibindo as informacoes em "Ultima atualizacao" referentes a
   -- ultima insercao no campo VALOR_REAL (usando DESC)
   -- ---------------------------------------------------------------------------------------------------------
   ultimadatatemp = ConsultaBD2("custo_realizado","*","proj_cod = "..cod," proj_cod, dt_realizacao, seq_real DESC ")
   i = 1
   j = 1
   -- -----------------------------------------------------------------------------------
   -- PEGA DATAS DO ANO ATUAL
   -- -----------------------------------------------------------------------------------
   if ultimadatatemp[1].valor_real then
      while ultimadatatemp[i] do
         if strfind(ultimadatatemp[i].dt_inclusao,anoatual) then
            ultimadata[j] = ultimadatatemp[i]
            j = j + 1
         end
         i = i + 1
      end
   end
   i = 1
   dt_ultima_atualizacao = 0
   if ultimadata[i] then
      acumulador_data_realizacao = inclui_data(strsub(ultimadata[1].dt_realizacao,0,10))
      acumulador_data_inclusao = inclui_data(strsub(ultimadata[1].dt_inclusao,0,10))
      acumulador_seq  = ultimadata[1].seq_real
   end
   temp = {}
   while ultimadata[i] do
      temp_data_realizacao = inclui_data(strsub(ultimadata[i].dt_realizacao,0,10))
      temp_data_inclusao = inclui_data(strsub(ultimadata[i].dt_inclusao,0,10))
      temp_seq = ultimadata[i].seq_real
      if (temp_data_realizacao > acumulador_data_realizacao) then
         acumulador_data_realizacao = temp_data_realizacao
         acumulador_data_inclusao = temp_data_inclusao
         ultimo_valor = ultimadata[i].valor_real
         justificativa = ultimadata[i].justificativa
      end
      if ((temp_data_realizacao == acumulador_data_realizacao) and (temp_seq >= acumulador_seq)) then
         acumulador_data_realizacao = temp_data_realizacao
         acumulador_data_inclusao = temp_data_inclusao
         ultimo_valor = ultimadata[i].valor_real
         justificativa = ultimadata[i].justificativa
         acumulador_seq = temp_seq
      end
      i = i + 1
   end
   if acumulador_data_realizacao then
      acumulador_data_realizacao = formataData2(acumulador_data_realizacao)
   else
      acumulador_data_realizacao = '-'
   end
   if acumulador_data_inclusao then
      acumulador_data_inclusao = formataData2(acumulador_data_inclusao)
   else
      acumulador_data_inclusao = '-'
   end

   if temConteudo(ultimo_valor) then
      ultima_insercao = 'R$ '.. ponto_centavo( formata_valor(ultimo_valor) )
   else
      ultima_insercao = '-'
   end
   write( '<TR><TD colspan="2">Data de realizao: <B>',acumulador_data_realizacao,'</B></TD><TD>Valor: <B>',ultima_insercao,'</B></TD></TR>\n' )
   write( '<TR><TD COLSPAN=3>Data de incluso: <B>',acumulador_data_inclusao,'</B></TD></TR>\n' )

   -- Os projetos podem nao possuir valores realizados cadastrados na base de dados (valor or 0)
   if (tonumber(ultimo_valor or 0) < 0) and temConteudo(justificativa) then
      write( '<TR><TD COLSPAN=3>Justificativa: <B>',justificativa,'</B></TD></TR>\n' )
   elseif (tonumber(ultimo_valor or 0) < 0) then
      write( '<TR><TD COLSPAN=3>Justificativa: <B> - </B></TD></TR>\n' )
   end
   write( '<TR><TD COLSPAN=3>&nbsp</TD></TR>\n' )

   write( '<TR><TD COLSPAN=3 class="msgCampos">\n' )
   write( 'No dia 09 de janeiro de 2002 os valores informados em Reais mil foram alterados para Reais.<br>\n' )
   write( 'A partir desta data todos os campos que se referem a custo devero ser preenchidos em Reais.\n' )
   write( '</TD></TR>\n' )
   write( '<TR><TD COLSPAN=3>&nbsp</TD></TR>\n' )

   if ((cgi.msg_data_inclusao or cgi.msg_custoReal) and cgi.msg_custoatual) or (temConteudo(cgi.data_inclusao) or temConteudo(cgi.custoatual)) then
      write( '<TR><TD><B><A HREF=Javascript:window.top.abre_hint("hint_Custo_realizado_em_Acompanhamento_de_Projeto__")><font color=black>Custo realizado em</font></a></B></td><td align="middle">&nbsp;&nbsp;<INPUT TYPE="text" NAME="data_inclusao" VALUE="'..cgi.data_inclusao..'" SIZE="13" MAXLENGTH="13" onChange="javascript:comparaDataCusto();"></B>: </TD><TD  align="middle"><INPUT TYPE="text" NAME="custoatual" SIZE="13" MAXLENGTH="13" VALUE="'..cgi.custoatual..'" onChange="javascript:formataCustoReal();"></TD></TR>\n' )
      write( '<TR valign="center"><TD>&nbsp;</TD><TD align="middle">(dd/mm/aaaa)</td><td align="middle">R$</td></TR>\n' )
   else
      write( '<TR><TD><B><A HREF=Javascript:window.top.abre_hint("hint_Custo_realizado_em_Acompanhamento_de_Projeto__")><font color=black>Custo realizado em </font></a></B></td><td  align="middle">&nbsp;&nbsp;<INPUT TYPE="text" NAME="data_inclusao" SIZE="10" MAXLENGTH="10" onChange="javascript:comparaDataCusto();"></B>: </TD><TD align="middle"><INPUT TYPE="text" NAME="custoatual" SIZE="13" MAXLENGTH="13" onChange="javascript:formataCustoReal();"></TD></TR>\n' )
      write( '<TR align="middle"><TD>&nbsp;</TD><TD>(dd/mm/aaaa)</td><td align="middle">R$</td></TR>\n' )
   end

   if cgi.msg_data_inclusao then
      write( '<TR><TD COLSPAN=3><FONT CLASS=msgErro>',cgi.msg_data_inclusao,'</TD></TR>\n' )
   end

   if cgi.msg_custoReal then
      write( '<TR><TD COLSPAN=3><FONT CLASS=msgErro>',cgi.msg_custoReal,'</TD></TR>\n' )
   end

   -- CAMPO NOVO
   -- Justificativa para insero de custo negativo
   write( '<TR><TD class="fieldLabel" COLSPAN="3"><A HREF=Javascript:window.top.abre_hint("hint_Justificativa_custo_realizado_Negativo_em_Acompanhamento_de_Projeto") class="hint">Justificativa para Custo Negativo:</a></TD></TR>\n' )
   write( '<TR><TD COLSPAN="3"><TEXTAREA NAME="custo_just" WRAP="soft" COLS="50" ROWS="5">',verifica(cgi.custo_just),'</TEXTAREA></TD></TR>\n' )
   write( '<TR><TD COLSPAN="3" class="msgCampos">(*) O campo torna-se obrigatrio se o valor inserido para o custo realizado for negativo, devendo<br> ter no mximo 150 caracteres e ao menos uma letra</TD></TR>\n' )
   if cgi.msg_custo_just then
      write( '<TR><TD COLSPAN="3" class="msgErro">',cgi.msg_custo_just,'</TD></TR>\n' )
   end

   write( '<TR><TD COLSPAN=3>&nbsp</TD></TR>\n' )
   totalmes = {}
   totalmes = ConsultaBD2("custo_realizado","SUM(valor_real) as sum_total","proj_cod = "..cod ..
                          " AND DATEPART(month,dt_realizacao) = " .. mesatual ..
                          " AND DATEPART(year, dt_realizacao) = " .. anoatual,nil)
   contador_mes_atual = 0
   if totalmes[1] then
      contador_mes_atual = totalmes[1].sum_total
   end
   mes = date("%m")
   tab = {'Janeiro','Fevereiro','Maro','Abril','Maio','Junho','Julho','Agosto','Setembro','Outubro','Novembro','Dezembro'}
   i = 1
   while tab[i] do
      if tonumber(mes) == tonumber(i) then
         mes = tab[i]
      end
      i = i + 1
   end
   if not contador_mes_atual or contador_mes_atual == '' then
      contador_mes_atual = 0
   end
   write( '<TR><TD><B>Total do ms de ',mes,'</B>: </TD><TD colspan="2"><B>R$ ',ponto_centavo(formata_valor(contador_mes_atual)),'</B></TD></TR>\n' )
   write( '</TABLE>\n' )
end

function atualizaInfoCustoProj( cod , func )
   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end
   local sql = "SELECT proj_cod FROM custo_previsto WHERE proj_cod = "..cod
   DBExec(sql)
   local resultado = DBRow()

   -- -------------------------------------------------------------------------
   -- Se existem valores cadastrados em CUSTO_PREVISTO (custo previsto mensal)
   -- -------------------------------------------------------------------------
   if resultado and resultado.proj_cod then
      -- ----------------------------------------------------------------------
      -- Verifica se existem valores cadastrados em CUSTO_REALIZADO
      -- ----------------------------------------------------------------------
      local sql = "SELECT DISTINCT proj_cod FROM custo_realizado WHERE proj_cod = "..cod
      DBExec(sql)
      local resultado = DBRow()
      -- -------------------------------------------------------------------------------
      -- Escolhe a funcao de exibicao de custo de acordo com o resultado da query acima
      -- -------------------------------------------------------------------------------
      if resultado and resultado.proj_cod then
         mostraInfoCustoPorMesAcomp ( cod )
      else
         mostraInfoCustoPorMes ( cod )
      end
      if func == 'acompanha' then
         AtualizaCustoPorMes ( cod )
      end
   else
      write('<hr width="85%">\n' )
      write('<table border="0" align="center"><tr><td class="fieldLabel" align="center" colspan="2">Custo Previsto/Realizado Anual</td></tr></table>\n')
      write('<table border="1" align="center" width="70%">\n')
      write( '<TR>\n' )
      write( '<TD ALIGN=CENTER width="15%"><B>Ano</B></TD>\n' )
      write( '<TD ALIGN=CENTER><B>Custo Previsto</B></TD>\n' )
      write( '<TD ALIGN=CENTER><B>Custo Realizado</B></TD>\n' )
      write( '</TR>\n' )

      local sql = "SELECT year(proj_dt_ini_prev) as ano_ini_prev, year(proj_dt_fim_prev) as ano_fim_prev, "..
                  "       substring(proj_dt_ini_real, 1, 4) as ano_ini_real, substring(proj_dt_fim_real, 1, 4) as ano_fim_real "..
                  "FROM projeto "..
                  "WHERE proj_cod = "..cod
      DBExec(sql)
      local datas = DBRow()

      -- Ano INICIAL: Atribui anos minimos e maximos do projeto
      if temConteudo(datas.ano_ini_prev) then
         if temConteudo(datas.ano_ini_real) and (tonumber(datas.ano_ini_real) < datas.ano_ini_prev) then
            ano_inicio = tonumber(datas.ano_ini_real)
         else
            ano_inicio = datas.ano_ini_prev
         end
      else -- se der algum erro na data de inicio prevista que  obrigatria
         ano_inicio = 2000
      end

      -- Ano FINAL
      if temConteudo(datas.ano_fim_prev) then
         if not(temConteudo(datas.ano_ini_real)) then -- O projeto ainda nao foi inicializado (inicio real)
            ano_fim = datas.ano_fim_prev
         elseif temConteudo(datas.ano_fim_real) and (tonumber(datas.ano_fim_real) > datas.ano_fim_prev) then -- O projeto terminou
            ano_fim = tonumber(datas.ano_fim_real)
         else
            if (tonumber(date('%Y')) > datas.ano_fim_prev) then -- O projeto iniciou mas a data atual eh maior do que a termino prevista
               ano_fim = tonumber(date('%Y'))
            else -- O projeto iniciou e a data de termino prevista eh maior do que a data atual
               ano_fim = datas.ano_fim_prev
            end
         end
      else -- se der algum erro na data de fim previsto que  obrigatria
         ano_fim = tonumber(date('%Y'))
      end

      local custo_prev = retornaCustoPrev (cod)
      local custo_real = retornaCustoReal (cod)
      local total_prev = 0
      local total_real = 0

      while (ano_inicio <= ano_fim) do
         write( '<TR>\n' )
         write( '<TD ALIGN=center><B>'..ano_inicio..'</B></TD>\n' )

         if (custo_prev and custo_prev[ano_inicio]) then
            custo_prev_ano = custo_prev[ano_inicio]
         else
            custo_prev_ano = 0
         end
         write( '<TD ALIGN=right>' .. ponto_centavo(formata_valor(custo_prev_ano)) .. '</TD>\n' )


         if (custo_real and custo_real[ano_inicio]) then
            custo_real_ano = custo_real[ano_inicio]
         else
            custo_real_ano = 0
         end
         write( '<TD ALIGN=right>' .. ponto_centavo(formata_valor(custo_real_ano)) .. '</TD>\n' )
         write( '</TR>\n' )

         total_real = total_real + custo_real_ano
         total_prev = total_prev + custo_prev_ano
         ano_inicio = ano_inicio + 1
      end

      write( '<TR><TD ALIGN=CENTER><B>Custo Total</B></TD>\n' )
      write( '<TD align="right" width=50%><B>' .. ponto_centavo(formata_valor(total_prev)) .. '</B>&nbsp;</TD>\n' )
      write( '<TD align="right" width=50%><B>' .. ponto_centavo(formata_valor(total_real)) .. '</B>&nbsp;</TD></TR>\n' )
      write( '</TABLE><BR>\n' )
      if func == 'acompanha' then
         AtualizaCustoPorMes ( cod )
      end
   end
end

-- Utilizada em Relatrios e Consultas
function listaJustificativaCusto( cod, limite, titulo )
   if ( strfind(cgilua.script_vdir, '/lua') ) then
       reldir = '../'
   else
       reldir = './'
   end

   dofile( reldir..'acessabd.lua' )

   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end

   query = "SELECT dt_realizacao, dt_inclusao, valor_real, justificativa "..
           "FROM custo_realizado WHERE proj_cod = " .. cod .. " AND valor_real < 0 "..
           "ORDER BY dt_realizacao DESC, seq_real DESC "
   DBExec( query )
   custo = DBRow()

   if custo then
      write( '<TABLE WIDTH="80%" BORDER="0" ALIGN="CENTER">\n')
      if titulo then
         write( '<TR>\n' )
         write( '<TD COLSPAN=4 ALIGN=CENTER class=fieldLabel><B>'..titulo..'</B></TD>\n')
         write( '</TR>\n' )
         write( '<TR><TD COLSPAN=4>&nbsp;</TD></TR>\n' )
      end
      write( '<TR>\n' )
      write( '<TD><B>Custo</B></TD>\n' )
      write( '<TD><B>Justificativa</B></TD>\n' )
      write( '<TD><B>Data de Realizao</B></TD>\n' )
      write( '<TD><B>Data de Incluso</B></TD>\n' )
      write( '</TR>\n' )
      tab = {}
      cont = 1
      sem_limite = 0
      if limite == 0 then
      	 limite = cont + 1
      	 sem_limite = 1
      end
      while custo and cont <= limite do
      	    tab[cont] = {}
      	    tab[cont].realizacao = formataData(custo.dt_realizacao)
            tab[cont].inclusao = formataData(custo.dt_inclusao)
            tab[cont].custo = 'R$ '..ponto_centavo(formata_valor(custo.valor_real))
            tab[cont].justificativa = custo.justificativa
            custo  = DBRow()
            cont = cont + 1
            if sem_limite == 1 then
               limite = limite + 1
            end
      end
      cor = "#CCCCCC"
      cont = cont - 1
      while tab[cont] and cont > 0 do
      	    cor = AlternaCorLinha(cor)
      	    write( '<TR BGCOLOR=',cor,'>\n' )
      	    write( '<TD nowrap>'..tab[cont].custo..'</TD>\n' )
      	    if tab[cont].justificativa then
               write( '<TD>'..tab[cont].justificativa..'</TD>\n' )
            else
               write( '<TD> - </TD>\n' )
            end
      	    write( '<TD nowrap>'..tab[cont].realizacao..'</TD>\n' )
            write( '<TD nowrap>'..tab[cont].inclusao..'</TD>\n' )
            write( '</TR>\n' )
            cont = cont - 1
      end
      write( '</TABLE><BR>\n')
  else
    write( '<TABLE WIDTH="80%" BORDER="0" ALIGN="CENTER">\n')
       write( '<TR>\n' )
         write( '<TD ALIGN=CENTER class=fieldLabel><B>No h registro de Custos Negativos para esse projeto.</B></TD>\n')
       write( '</TR>\n')
    write( '</TABLE>\n')
  end

  if ESTADO_BD == 'aberto' then
     FechaBD()
  end

end