-- ---------------------------------------------------------------------------------------------------------------------
-- PROJETOS.LUA
-- ---------------------------------------------------------------------------------------------------------------------
dofile( "lua/acessabd.lua" )
dofile( "lua/permissao_acesso.lua" )
dofile( "lua/global.lua" )
dofile( "lua/orgaos.lua" )
dofile( "lua/OT.lua" )
dofile( "lua/desempenho.lua" )

--------------------------------------------------
--Verifica se a versao acessada e maxima(ultima)--
--------------------------------------------------
function VerificaVersao(proj_cod)
   local sql, tmp, flagv, proj_sigla
   sql = "SELECT proj_sigla FROM projeto WHERE proj_cod = "..proj_cod
   DBExec(sql)
   proj_sigla = DBRow().proj_sigla

   sql="SELECT proj_versao as vatual, vmaxima = (SELECT max(proj_versao) FROM projeto "..
       "WHERE proj_sigla = '"..proj_sigla.."') FROM projeto WHERE proj_cod = "..proj_cod
   DBExec(sql)
   tmp = DBRow()
   if tmp then
      if tmp.vatual == tmp.vmaxima then
         flagv = 1
      else
         flagv = 0
      end
   end
   return flagv
end


--Monta o SELECT com os estados
function MontaEstados(est_un)
   assert(dofile("lua/estados.lua"))
   local i,estado
   i=1
   estado = '<SELECT NAME="estado_un"><OPTION VALUE="">'
   while estados[i] do

      if est_un == estados[i] then
         estado = estado..'\n<option value="'..estados[i]..'" selected>'..estados[i]
      else
         estado = estado..'\n<option value="'..estados[i]..'">'..estados[i]
      end
      i=i+1
   end
   estado = estado..'</SELECT>\n'
   return estado
end



-- ----------------------------------------------------------------------------
-- Na tela com os campos de Dutos:
-- 1. aceitar os campos numricos informando "," e no "." quando tem decimal.
-- 2. exibir o zero antes da vrgula ex: 0,430 (errado: ,430)
-- 3. no exibir os zeros aps os nmeros inteiros.
-- ----------------------------------------------------------------------------
   function exibe_valor_duto(valor)
      -- ----------------------------------------------------------------------------
      -- Os valores de diametro, espessura e extensao devem ser impressos no formato
      -- d*,dddd
      -- ----------------------------------------------------------------------------
         if valor and valor ~= '' and valor ~= .0000 then
         -- -------------------------------------------------------------------------
         -- Substitui tudo o que no for dgito (nesse caso o ponto - . -) por
         -- vrgula ( - , - )
         -- -------------------------------------------------------------------------
            valor = gsub( valor, "%D", "," )
         elseif valor == .0000 then
            valor = '0'
         end

      -- ----------------------------------------------------------------------------
      -- Adiciona um zero antes da vrgula (EX: .987 -> 0,987)
      -- ----------------------------------------------------------------------------
         if valor and valor ~= '' and valor ~= ' ' then
            ini, fim = strfind(valor,"%D")
            if ini == 1 then
               valor = '0'..valor
            elseif ini then
            -- ----------------------------------------------------------------------------
            -- Remove as casas decimais se o numero eh inteiro (EX: 10.0000 -> 10)
            -- ----------------------------------------------------------------------------
               decimais = strsub(valor,ini+1)
               if decimais == '0000' then
                  valor = strsub(valor,1,ini-1)
               end
            end
         end
      return valor
   end

function VersoesAnteriores( codigo, versao, funcao, pagina_func, info)
  local resultado = ''
  -- Busca a sigla associada ao projeto selecionado
  DBExec ("SELECT proj_sigla FROM projeto WHERE proj_cod = "..codigo)
  local temp = DBRow()
  -- Busca a ultima versao associada a sigla encontrada na query anterior
  DBExec ("SELECT proj_cod FROM projeto WHERE last_versao = 's' AND proj_sigla = '"..temp.proj_sigla.."'")
  local temp1 = DBRow()
  -- Busca todos as versoes associadas a sigla encontrada na primeira query
  DBExec ("SELECT proj_versao, proj_cod FROM projeto WHERE proj_sigla ='"..temp.proj_sigla.."' ORDER BY proj_versao, proj_cod")
  local temp2 = DBRow()
  while temp2 and temp2.proj_cod do
    if temp2.proj_versao ~= versao then
       if temp2.proj_cod ~= temp1.proj_cod then
          resultado = resultado.."<a href='result_consulta.html?"..cgilua.encodetable({cod=temp2.proj_cod, tipo_servico=funcao, pagina_func=pagina_func, cond_filtro=info, cod_last_versao=temp1.proj_cod}).."'>"..temp2.proj_versao.."</a>,&nbsp\n"
       else
          resultado = resultado.."<a href='"..pagina_func.."?"..cgilua.encodetable({tipo_servico=funcao, cond_filtro=info, cod=temp2.proj_cod }).."'>"..temp2.proj_versao.."</a>,&nbsp\n"
       end
    end
    temp2 = DBRow()
  end
  -- Remove a ultima virgula que fica sobrando
  return strsub(resultado,0,(strlen(resultado)-8))
end

function retornaFrequencia( cod )
   local consulta = "SELECT proj_freq FROM projeto WHERE proj_cod = "..cod
   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end
   DBExec(consulta)
   resultado = DBRow()
   return resultado.proj_freq
end

function retornaNome( cod )
   local result = {}

   if ( cod ) then
      result = ConsultaBD2( "projeto", "proj_nome", "proj_cod = '" .. cod .. "'" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido.'
   end
end

function retornaCodUsuarioProj ( cod )
   local result = {}

   if ( cod ) then
      result = ConsultaBD2( "projeto", "proj_cod_usuario", "proj_cod = '" .. cod .. "'" , nil )
      if ( not result[1][1] ) then
      	 result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo do Projeto Invlido.'
   end
end

function retornaDataUltimoFUP( fup_cod )
   if ( fup_cod ) then
      DBExec( 'SELECT fup_data FROM follow_up WHERE fup_cod = '.. fup_cod)
      temp = DBRow()

      if ( temp and temp.fup_data ) then
      	 return temp.fup_data
      else
         return nil
      end
   else
      return 'Cdigo de Follow-Up Invlido.'
   end
end

function retornaMetas ( cod )
   local result = {}

   if ( cod ) then
      result = ConsultaBD2( "projeto, meta", "meta_descr", "proj_cod = '" .. cod .. "' AND proj_meta= meta_cod", nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo do Projeto Invlido.'
   end
end

function retornaMetasDescr ( cod_meta )
   local result

   if ( cod_meta ) then
      DBExec( "select meta_descr from meta where meta_cod = " .. cod_meta )
      result = DBRow()
      if ( result and result.meta_descr ) then
          return result.meta_descr
      end
   end

   return 'Cdigo da Meta Invlido.'
end

function retornaOrgProj( cod )
   local result = {}

   if ( cod ) then
      result = ConsultaBD2( "projeto", "org_cod", "proj_cod = " .. cod, nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido.'
   end
end

function retornaDescrStat ( stat_cod )
   local result = {}

   if ( stat_cod ) then
      result = ConsultaBD2( "status", "stat_descr", "stat_cod = '" .. stat_cod .. "'" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo da Situao Invlido.'
   end

end

function retornaPrioridade( cod )
   local result = {}

   if ( cod ) then
      result = ConsultaBD2( "projeto", "proj_prior", "proj_cod = " .. cod .. "" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido.'
   end
end

function retornaDataInicioPrev( cod )
   local result = {}

   if ( cod ) then
      result = ConsultaBD2( "projeto", "proj_dt_ini_prev", "proj_cod = " .. cod .. "" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido.'
   end
end

function retornaDataFimPrev( cod )
   local result = {}

   if ( cod ) then
      result = ConsultaBD2( "projeto", "proj_dt_fim_prev", "proj_cod = '" .. cod .. "'" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido.'
   end
end

function retornaDataInicioReal( cod )
   local result = {}

   if ( cod ) then
      result = ConsultaBD2( "projeto", "proj_dt_ini_real", "proj_cod = '" .. cod .. "'" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido.'
   end
end

function retornaDataFimReal( cod )
   local result = {}

   if ( cod ) then
      result = ConsultaBD2( "projeto", "proj_dt_fim_real", "proj_cod = '" .. cod .. "'" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido.'
   end
end

function retornaCustoFim( cod )
   local result = {}

   if ( cod ) then
      result = ConsultaBD2( "custo", "sum(custo_prev_ano) AS custo_total", "proj_cod = '" .. cod .. "' GROUP BY proj_cod" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido.'
   end
end

function retornaVersao( cod )
   local result = {}

   if ( cod ) then
      result = ConsultaBD2( "projeto", "proj_versao", "proj_cod = '" .. cod .. "'" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido.'
   end
end


-- Busca a versao CONSOLIDADA do projeto associada a sigla encontrada na primeira query
function retornaVersaoConsolidada( cod )
   local aux, resultado, temp, temp1, temp2

   DBExec ("SELECT proj_sigla FROM projeto WHERE proj_cod = "..cod)
   temp = DBRow()

   if ( cod ) then
      DBExec(" SELECT MAX(cons_cod) as cons_cod FROM consolidacao ")
      aux = DBRow()
      if aux and aux.cons_cod then
         DBExec ("SELECT p.proj_cod FROM consolidacaoProjeto p, consolidacaoUnidade u WHERE p.proj_sigla = '"..
                 temp.proj_sigla.."' AND p.cons_cod = "..aux.cons_cod.." AND u.cons_cod = "..aux.cons_cod..
                 " AND p.unid_cod = u.unid_cod AND u.aprovada = 1" )
         temp1 = DBRow()
      end

      if temp1 and temp1.proj_cod then
      	 DBExec("SELECT proj_versao FROM projeto WHERE proj_cod = ".. temp1.proj_cod)
      	 temp2 = DBRow()
      end
   end

   if temp2 and temp2.proj_versao then
      return temp2.proj_versao
   else
      return ''
   end

end

function retornaStatus( cod )
   local result = {}

   if ( cod ) then
      result = ConsultaBD2( "projeto", "stat_cod", "proj_cod = '" .. cod .. "'" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido.'
   end
end

-- Entrada: codigo do status
function retornaStatusDescr( cod )
   local result = {}

   if ( cod ) then
      result = ConsultaBD2( "status", "stat_descr", "stat_cod = '" .. cod .. "'" , nil )
     if ( not result[1][1] ) then
         result[1][1] = ''
      end
     return result[1][1]
   else
      return 'Cdigo da Situao Invlido.'
   end
end

function retornaJustCancel( cod )
   local result = {}

   if ( cod ) then
     result = ConsultaBD2( "log", "log_justifica", "proj_cod = '" .. cod .. "'" , nil )
     if ( not result[1][1] ) then
         result[1][1] = ''
     end
     return result[1][1]
   else
     return ' No h justificativa de cancelamento para o projeto.'
   end
end

function retornaDataInclusao( cod )
   local result = {}

   if ( cod ) then
      result = ConsultaBD2( "projeto", "proj_dt_incl", "proj_cod = '" .. cod .. "'" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido.'
   end
end

function retornaDescricao( cod )
   local result = {}

   if ( cod ) then
      result = ConsultaBD2( "projeto", "proj_descr", "proj_cod = '" .. cod .. "'" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido.'
   end
end

function retornaUnidProj( cod )
   local result = {}

   if ( cod ) then
      result = ConsultaBD2( "projeto", "unid_cod", "proj_cod = '" .. cod .. "'" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido.'
   end
end

function retornaNomeUnid( cod )
   local result = {}

   if ( cod ) then
      result = ConsultaBD2( "unidade", "unid_nome", "unid_cod = '" .. cod .. "'" , nil )
      return result[1][1]
   else
      return 'Cdigo da Unidade Invlido.'
   end
end

function retornaSiglaUnid( cod )
   local result
   local un = ''

   if temConteudo( cod ) and cod ~= 'Cdigo de Projeto Invlido.'  then
      DBExec( "select unid_sigla as sigla from unidade where unid_cod in (" .. cod .. ")" )
      result = DBRow()
      while result do
      	 if temConteudo(un) then
      	    un = un..', '..result.sigla
      	 else
      	    un = result.sigla
      	 end

      	 result = DBRow()
      end
      if un then return un else return '-' end
   end

   return '-'
end

function retornaSiglaOrgao( cod )
   local result
   local an = ''

   if ( cod ) then
      DBExec( "select org_sigla as sigla from orgao where org_cod in (" .. cod .. ")" )
      result = DBRow()
      while result do
      	 if temConteudo(an) then
      	    an = an..', '..result.sigla
      	 else
      	    an = result.sigla
      	 end

      	 result = DBRow()
      end
      if an then return an end
   end

   return 'Cdigo do rgo Invlido.'
end

function retornaSiglaGer( cod )
   local result
   local ger = ''

   if ( cod ) then
      DBExec( "select ger_sigla as sigla from gerencia where ger_cod in (" .. cod .. ")" )
      result = DBRow()
      while result do
      	 if temConteudo(ger) then
      	    ger = ger..', '..result.sigla
      	 else
      	    ger = result.sigla
      	 end

      	 result = DBRow()
      end
      if ger then return ger end
   end

   return 'Cdigo da Gerncia Invlido.'
end

function retornaClassificacao( cod )
   local result
   local class = ''

   if ( cod ) then
      DBExec( "select clas_descr as descr from classificacao where clas_cod in (" .. cod .. ")" )
      result = DBRow()
      while result do
      	 if temConteudo(class) then
      	    class = class..'; '..result.descr
      	 else
      	    class = result.descr
      	 end

      	 result = DBRow()
      end
      if class then return class end
   end

   return 'Cdigo Invlido.'
end

function retornaDesempenho( cod )
   local result = {}

   if ( cod ) then
      result = ConsultaBD2( "desempenho", "desempenho_descr", "desempenho_cod = " .. cod , nil )
      return result[1][1]
   else
      return 'Cdigo de Desempenho Invlido.'
   end
end

-- ----------------------------------------------------------------------
-- Function : retornaDadosTranspetro
-- Description : Retorna uma tabela com os dados do projeto relacionados
--               a TRASPETRO
-- Parameters :
--      cod : codigo do projeto
-- Return :
--      tabela tbTranspetro que contem os dados do projeto relacionados a
--      transpetro
-- ----------------------------------------------------------------------
function retornaDadosTranspetro ( cod )
   local tbTranspetro = {} -- retorno
   local tbTemp = {} -- auxiliar

   tbTemp = ConsultaBD2( "transpetro", "*", "proj_cod = " .. cod, nil )

   if tbTemp then -- existe cadastro transpetro para esse projeto
      -- guardo na tabela de retorno os dados
      tbTranspetro.tipo = tbTemp[1].trans_tipo
      tbTranspetro.eng = tbTemp[1].trans_eng
      tbTranspetro.cbi = tbTemp[1].trans_cbi
      tbTranspetro.cac = tbTemp[1].trans_cac
      tbTranspetro.cad = tbTemp[1].trans_cad
      tbTranspetro.ui = tbTemp[1].trans_ui
      tbTranspetro.prog = tbTemp[1].trans_prog
      tbTranspetro.proj = tbTemp[1].trans_proj
   end

   return tbTranspetro

end

-- Utilizada no acompanhento de projetos p/ o usuario fornecer as datas de fim e inicio real
function recebeDatasRealProj (cod)
   -- -------------------------------------------------------------------------------------------------
   -- DATA DE INICIO REAL DE PROJETO
   -- -------------------------------------------------------------------------------------------------
   flagv = VerificaVersao(cod)

   dt_ini_real = formataData2(retornaDataInicioReal(cod))
   write( '<TR>\n' )
   write( '<TD><B><A HREF=Javascript:window.top.abre_hint("hint_Data_de_Inicio_Real_Acompanhamento_de_Projeto__")><font color=black>Data de Incio Real </font></a></B></TD>\n' )
   if flagv == 0 then
      write( '<TD>'..dt_ini_real..'</TD>\n' )
   elseif cgi.DataInicioReal then
      write( '<TD><INPUT TYPE="text" MAXLENGTH="10" SIZE="8" NAME="DataInicioReal" VALUE="' .. cgi.DataInicioReal .. '" onChange="javascript:msgDataReal(\'DataInicioReal\', \'' .. cgi.DataInicioReal .. '\');">(dd/mm/aaaa)</TD>\n' )
   else
      write( '<TD><INPUT TYPE="text" MAXLENGTH="10" SIZE="8" NAME="DataInicioReal" VALUE="' ..dt_ini_real.. '" onChange="javascript:msgDataReal(\'DataInicioReal\', \'' ..dt_ini_real.. '\');">(dd/mm/aaaa)</TD>\n' )
   end
   write( '</TR>\n' )
   if cgi.msg_DataInicioReal then
      write( '<TR>\n' )
      write( '<TD>&nbsp;</TD>\n' )
      write( '<TD><FONT COLOR="red">'..cgi.msg_DataInicioReal..'</FONT></TD>\n' )
      write( '</TR>\n' )
   elseif cgi.msg_dt_ini then
      write( '<TR>\n' )
      write( '<TD>&nbsp;</TD>\n' )
      write( '<TD><FONT COLOR="red">'.. cgi.msg_dt_ini..'</FONT></TD>\n' )
      write( '</TR>\n' )
   end

   -- -------------------------------------------------------------------------------------------------
   -- DATA DE FIM REAL DE PROJETO
   -- -------------------------------------------------------------------------------------------------
   dt_fim_real = formataData2(retornaDataFimReal(cod))
   write( '<TR>\n' )
   write( '<TD><B><B><A HREF=Javascript:window.top.abre_hint("hint_Data_de_Termino_Real_Acompanhamento_de_Projeto__")><font color=black>Data de Trmino Real </font></a></B></TD>\n' )
   if flagv == 0 then
      write( '<TD>'..dt_fim_real..'</TD>\n' )
   elseif cgi.DataFimReal then
      write( '<TD><INPUT TYPE="text" MAXLENGTH="10" SIZE="8" NAME="DataFimReal" VALUE="' .. cgi.DataFimReal .. '" onChange="javascript:msgDataReal(\'DataFimReal\', \'' .. cgi.DataFimReal .. '\');">(dd/mm/aaaa)\n' )
   else
      write( '<TD><INPUT TYPE="text" MAXLENGTH="10" SIZE="8" NAME="DataFimReal" VALUE="' ..dt_fim_real.. '" onChange="javascript:msgDataReal(\'DataFimReal\', \'' ..dt_fim_real.. '\');">(dd/mm/aaaa)\n' )
   end
   write( '</TD></TR>\n' )
   if cgi.msg_DataFimReal then
      write( '<TR>\n' )
      write( '<TD>&nbsp;</TD>\n' )
      write( '<TD><FONT COLOR="red">'..cgi.msg_DataFimReal..'</FONT></TD>\n' )
      write( '</TR>\n' )
   elseif cgi.msg_dt_fim then
      write( '<TR>\n' )
      write( '<TD>&nbsp;</TD>\n' )
      write( '<TD><FONT COLOR="red">'..cgi.msg_dt_fim..'</FONT></TD>\n' )
      write( '</TR>\n' )
   end
end

-- Utilizada nas funcoes de formalizacao, revisao, cancelamento e conclusao
function mostraDatasRealProj (cod)
   dt_ini_real = formataData2(retornaDataInicioReal(cod))
   write( '<TR>\n' )
   write( '<TD><B>Data de Incio Real</B></TD>\n' )
   write( '<INPUT TYPE="hidden" NAME="dt_ini_real" VALUE="'..dt_ini_real..'">')
   write( '<TD>' ..dt_ini_real.. '</TD>' )
   write( '</TR>\n' )

   dt_fim_real = formataData2(retornaDataFimReal(cod))
   write( '<TR>\n' )
   write( '<TD><B><B>Data de Trmino Real</B></TD>\n' )
   write( '<INPUT TYPE="hidden" NAME="dt_fim_real" VALUE="'..dt_fim_real..'">')
   write( '<TD>' ..dt_fim_real.. '</TD>' )
   write( '</TR>\n' )
end

-- ------------------------------------------------------------------------
-- usada para visualizar informaes de projetos no ACOMPANHAMENTO
-- COD: codigo do projeto
-- FUNCAO: cancelamento, conclusao, consulta, consolidacao, etc...
-- PAGINA_FUNC: pagina relacionada a FUNCAO
-- INFO: valores adicionais que o usuario deseje passar por parametro,
--       como eh o caso da condicao de filtragem ou a pagina que originou
--       a chamada (no caso de consolidacao)
-- CUSTO_NEGATIVO: libera a visualizao das justificativas para os custos
--                 cadastrados com valores negativos
-- ------------------------------------------------------------------------
function mostraInfoProj( cod, funcao, pagina_func, info, custo_negativo )
   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end
   if not( temConteudo(cgi.tipo_servico) ) then
      cgi.tipo_servico = ''
   end
   write( '<TABLE WIDTH="80%" BORDER="0" ALIGN="CENTER">')
   write( '<TR><TD><A HREF="cronog/cron_proj.html?proj_cod='..cod..'&pagina='..cgi.pagina..'&tipo_servico='..cgi.tipo_servico..'" ONMOUSEOVER=Over("cronogr"); ONMOUSEOUT=Out("cronogr");><IMG SRC="imagens/cronogr.gif" BORDER=0 NAME="cronogr"></A></TD></TR>\n')
   write( '<TR><TD><A HREF="curva/curvas.html?proj_cod='..cod..'&pagina='..cgi.pagina..'&tipo_servico='..cgi.tipo_servico..'&realizacao=financeira" ONMOUSEOVER=Over("curvfinanceira"); ONMOUSEOUT=Out("curvfinanceira");><IMG SRC="imagens/curvfinanceira.gif" BORDER=0 NAME="curvfinanceira"></A></TD></TR>\n')
   write( '<TR><TD><A HREF="curva/curvas.html?proj_cod='..cod..'&pagina='..cgi.pagina..'&tipo_servico='..cgi.tipo_servico..'&realizacao=fisica" ONMOUSEOVER=Over("curvfisica_nov"); ONMOUSEOUT=Out("curvfisica_nov");><IMG SRC="imagens/curvfisica_nov.gif" BORDER=0 NAME="curvfisica_nov"></A></TD></TR>\n')
   write( '<TR><TD><A HREF=javascript:AbreJanela("lista_follow_up.html?proj_cod='..cod..'") ONMOUSEOVER=Over("followup"); ONMOUSEOUT=Out("followup");><IMG SRC="imagens/followup.gif" BORDER=0 NAME="followup"></A></TD></TR>\n')
   write( '<TR><TD><A HREF="upload/lista_doc.html?proj_cod='..cod..'&tipo_servico='..cgi.tipo_servico..'&ativ=Consulta" ONMOUSEOVER=Over("anexos"); ONMOUSEOUT=Out("anexos");><IMG SRC="imagens/anexos.gif" BORDER=0 NAME="anexos"></A></TD></TR>\n')
   if temConteudo(custo_negativo) and custo_negativo == 1 then
      write( '<TR><TD><A HREF=javascript:AbreJanela("lista_custo_negativo.html?proj_cod='..cod..'") ONMOUSEOVER=Over("custonegativo"); ONMOUSEOUT=Out("custonegativo");><IMG SRC="imagens/custonegativo.gif" BORDER=0 NAME="custonegativo"></A></TD></TR>\n')
   end

   cod_user = retornaCodUsuarioProj ( cod )
   write( '<TR>\n')
   write( '<TD><B>Cdigo do Projeto</B></TD>\n' )
   write( '<TD>' .. cod_user..'</TD>\n' )
   write( '</TR>\n' )

   write( '<TR>\n' )
   write( '<TD valign="top"><B>Nome do Projeto</B></TD>\n' )
   write( '<TD>' .. retornaNome(cod) .. '</TD>\n' )
   write( '</TR>\n' )

   write( '<TR>\n' )
   write( '<TD><B>Nome da rea de Negcio</B></TD>\n' )
   write( '<TD>' .. retornaNomeOrg(retornaOrgProj ( cod )) .. '</TD>\n' )
   write( '</TR>\n' )

   write( '<TR>\n' )
   write( '<TD><B>Responsvel da rea de Negcio</B></TD>\n' )
   write( '<TD>' .. retornaRespOrg(retornaOrgProj ( cod )) .. '</TD>\n' )
   write( '</TR>\n' )

   write( '<TR>\n' )
   write( '<TD><B>Nome da Unidade de Negcio</B></TD>\n' )
   write( '<TD>' .. retornaNomeUnid(retornaUnidProj ( cod )) .. '</TD>\n' )
   write( '</TR>\n' )

   write( '<TR>\n' )
   write( '<TD><B>Responsvel da Unidade de Negcio</B></TD>\n' )
   write( '<TD>' .. retornaRespUnid(retornaUnidProj ( cod )) .. '</TD>\n' )
   write( '</TR>\n' )

   sql = "select * from projeto a, orgao b where a.proj_cod = "..cod.." and a.org_cod = b.org_cod"
   DBExec(sql)
   orgao = DBRow()
   if orgao.org_sigla == 'TRANSPETRO' then

      sql = "SELECT b.ger_sigla FROM projeto a,gerencia b WHERE proj_cod = "..cod.." AND a.ger_cod = b.ger_cod"
      DBExec(sql)
      dados = DBRow()
      if dados then
         write( '<TR>\n' )
         write( '<TD><B>Nome da Ger&ecirc;ncia</B></TD>\n' )
         write( '<TD>'..dados.ger_sigla..'</TD>\n' )
         write( '</TR>\n' )
      end

      sql = "select b.set_sigla from projeto a,setor b where proj_cod = "..cod.." and a.set_cod = b.set_cod"
      DBExec(sql)
      dados_set = DBRow()
      if dados_set then
         write( '<TR>\n' )
         write( '<TD><B>Nome do Setor</B></TD>\n' )
         write( '<TD>'..dados_set.set_sigla..'</TD>\n' )
         write( '</TR>\n' )
      end
   end

--- classificacao
   write( '<TR>\n' )
   write( '<TD><B>Classificao</B></TD>\n' )
   write( '<TD>' .. retornaNomeClas(retornaCodClasProj ( cod )) .. '</TD>\n' )
   write( '</TR>\n' )

--- ot clas
   write( '<TR>\n' )
   write( '<TD><B>OT Classificao</B></TD>\n' )
   write( '<TD>' .. retornaOTClas(retornaCodOTClasProj( cod )) .. '</TD>\n' )
   write( '</TR>\n' )

--- subclassificacao ( apenas se existir para a classificao escolhida)
   subclas = retornaNomeClas(retornaCodSubClasProj ( cod ))
   if ( subclas and subclas ~= nil) then
      write( '<TR>\n' )
      write( '<TD><B>Subclassificao</B></TD>\n' )
      write( '<TD>' .. retornaNomeClas(retornaCodSubClasProj ( cod )) .. '</TD>\n' )
      write( '</TR>\n' )

--- ot subclas
      write( '<TR>\n' )
      write( '<TD><B>OT Subclassificao</B></TD>\n' )
      write( '<TD>' .. retornaOTClas(retornaCodOTSubClasProj( cod )) .. '</TD>\n' )
      write( '</TR>\n' )
   end

--- metas
   meta = retornaMetas ( cod )
   write( '<TR>\n')
   write( '<TD><B>Metas</B></TD>\n' )
   write( '<TD>' .. meta .. '</TD>\n' )
   write( '</TR>\n' )

--- ot operacional
   write( '<TR>\n' )
   write( '<TD><B>OT Operacional</B></TD>\n' )
   write( '<TD>' .. retornaOTOper(retornaCodOTOperProj( cod )) .. '</TD>\n' )
   write( '</TR>\n' )

--- ot especfica
   ot_esp = retornaOtEspProj ( cod )
   write( '<TR>\n' )
   write( '<TD><B>OT Especfica</B></TD>\n' )
   write( '<TD>' .. ot_esp..'</TD>\n' )
   write( '</TR>\n' )

   consulta_colaboradores = "SELECT p.pes_nguerra,p.pes_chave FROM colaboradores as c, pessoal as p WHERE c.proj_cod = "..tonumber(cod).." AND c.colaborador = p.pes_cod ORDER BY p.pes_nguerra"
   DBExec(consulta_colaboradores)
   resultado_colaboradores = DBRow()
   if resultado_colaboradores and resultado_colaboradores.pes_chave then
      tab_colaboradores = {}
      local z = 1
      while resultado_colaboradores do
         tab_colaboradores[z] = resultado_colaboradores
         z = z + 1
         resultado_colaboradores = DBRow()
      end
   end

   consulta_projeto = "SELECT pj.proj_coord, pj.proj_colab, pj.proj_est_un, pj.proj_tipo_un, "..
                      "pj.proj_funcao_un, ps.pes_nguerra, pj.proj_class, pj.proj_plano_rec, pj.proj_paeid "..
                      "FROM projeto as pj, pessoal as ps "..
                      "WHERE pj.proj_cod = "..tonumber(cod).." AND ps.pes_chave = pj.proj_colab"

   DBExec(consulta_projeto)
   resultado_projeto = DBRow()

   if resultado_projeto and resultado_projeto.proj_coord then
      coordenador = resultado_projeto.proj_coord
   else
      coordenador = ''
   end
   if resultado_projeto and resultado_projeto.proj_colab then
      colaborador = resultado_projeto.proj_colab
      colab_guerra = resultado_projeto.pes_nguerra
   else
      colaborador = ''
      colab_guerra = ''
   end

--- coordenador
   write( '<TR>\n' )
   write( '<TD><B>Coordenador</B></TD>\n' )
   if resultado_projeto and resultado_projeto.proj_coord then
      write( '<TD>' .. coordenador..'</TD>\n' )
   end
   write( '</TR>\n' )

--- colaborador
   write( '<TR>\n' )
   write( '<TD><B>Colaborador</B></TD>\n' )
      write( '<TD>'..colab_guerra..' (' .. colaborador..')</TD>\n' )
   write( '</TR>\n' )

--- outros colaboradores
   write( '<TR>\n' )
   write( '<TD VALIGN="top"><B>Outros Colaboradores</B></TD>\n' )
   z = 1
   if tab_colaboradores and tab_colaboradores[z].pes_chave then
      write( '<TD>' )
      while tab_colaboradores[z] do
         write( ''..tab_colaboradores[z].pes_nguerra..' (' ..tab_colaboradores[z].pes_chave..')<BR>\n' )
         z = z + 1
      end
      write( '</TD>' )
   end
   write( '</TR>\n' )

-- Plano de Recuperao
   write( '<TR>\n' )
   write( '<TD><B>Plano de Recuperao</B></TD>\n' )
   if resultado_projeto and resultado_projeto.proj_plano_rec == 1 then
      plano_recuperacao = "Sim"
   elseif resultado_projeto and resultado_projeto.proj_plano_rec == 0 then
      plano_recuperacao = "No"
   else
      plano_recuperacao = ""
   end
   write( '<TD>' .. plano_recuperacao .. '</TD>\n' )
   write( '</TR>\n' )

   -- Plano emergencial de integridade de dutos
   if resultado_projeto and resultado_projeto.proj_paeid then
      write( '<TR>\n' )
      write( '<TD><B>Plano emergencial de integridade de dutos</B></TD>\n' )
      if resultado_projeto.proj_paeid == 1 then
         plano_emergencial_dutos = "Sim"
      else
         plano_emergencial_dutos = "No"
      end
      write( '<TD>' .. plano_emergencial_dutos .. '</TD>\n' )
      write( '</TR>\n' )
   end

   -- Classificao do acompanhamento do projeto
   write( '<TR>\n' )
   write( '<TD><B>Classificao do acompanhamento do projeto</B></TD>\n' )
   if resultado_projeto and resultado_projeto.proj_class then
      if resultado_projeto and resultado_projeto.proj_class == 1 then
         class_acomp = "I"
      end
      if resultado_projeto and resultado_projeto.proj_class == 2 then
         class_acomp = "II"
      end
      if resultado_projeto and resultado_projeto.proj_class == 3 then
         class_acomp = "III"
      end
      write( '<TD>' .. class_acomp .. '</TD>\n' )
   else
      write( '<TD>Sem classificao</TD>\n' )
   end
   write( '</TR>\n' )

   -- Frequencia de Follow-Up
   write( '<TR>\n' )
   write( '<TD><B>Frequncia de Follow-Up</B></TD>\n' )
   write( '<TD>' .. retornaFrequencia(cod) .. '</TD>\n' )
   write( '</TR>\n' )

   -- Prioridade
   write( '<TR>\n' )
   write( '<TD><B>Prioridade</B></TD>\n' )
   write( '<TD>' .. retornaPrioridade(cod) .. '</TD>\n' )
   write( '</TR>\n' )

   --pertence = Pertence()
   --if pertence == "SIM" then

      local tab = {}
      tab = ConsultaBD2("orgao a, pessoal b","b.pes_chave","b.pes_cod = a.org_cod AND a.org_sigla = 'TRANSPETRO'",nil)

      -- Usuario da maquina
      local curr_user
      curr_user = getuser()

      local tabela = {}
      tabela = retornaDadosTranspetro( cod )

      write( '<TR>\n' )
      write( '<TD><B>Engenharia</B></TD>\n' )
      if tabela.eng == 'S' then
         write( '<TD>Sim</TD>\n' )
      elseif tabela.eng == 'N' then
         write( '<TD>No</TD>\n' )
      end
      write( '</TR>\n' )
      write( '<TR>\n' )
      write( '<TD><B>Tipo</B></TD>\n' )
      if tabela.tipo == '1' then
         write( '<TD>Operao</TD>\n' )
      elseif tabela.tipo == '0' then
         write( '<TD>Investimento</TD>\n' )
      end
      write( '</TR>\n' )
      write( '<TR>\n' )
      write( '<TD><B>CAC</B></TD><TD>' .. troca_nil_por_vazio(tabela.cac) .. '</TD></TR>' )
      write( '<TR><TD><B>CAD</B></TD><TD>' .. troca_nil_por_vazio(tabela.cad) .. '</TD></TR>' )
      write( '<TR><TD><B>CBI</B></TD><TD>' .. troca_nil_por_vazio(tabela.cbi) .. '</TD></TR>' )
      write( '<TR><TD><B>UI</B></TD><TD>' .. troca_nil_por_vazio(tabela.ui) .. '</TD></TR>' )
      write( '<TR><TD><B>Programa</B></TD><TD>' .. troca_nil_por_vazio(tabela.prog) .. '</TD></TR>' )
      write( '<TR><TD><B>Projeto</B></TD><TD>' .. troca_nil_por_vazio(tabela.proj) .. '</TD>\n' )
      write( '</TR>\n' )
   --end

-- ----------------------------------------------------------------
-- CAMPOS REFERENTES AO Plano emergencial de integridade de dutos --
-- ----------------------------------------------------------------
   if plano_emergencial_dutos == "Sim" then
      sql = "SELECT * FROM dutos WHERE proj_cod = "..tonumber(cod)
      DBExec(sql)
      dados_dutos = DBRow()

      if not dados_dutos then
         -- Dimetro
         write( '<TR>\n' )
         write( '<TD><B>Dimetro </B></TD>\n' )
         write( '<TD>&nbsp;</TD>\n' )
         write( '</TR>\n' )

         -- Espessura
         write( '<TR>\n' )
         write( '<TD><B>Espessura </B></TD>\n' )
         write( '<TD>&nbsp;</TD>\n' )
         write( '</TR>\n' )

         -- Extenso
         write( '<TR>\n' )
         write( '<TD><B>Extenso</B></TD>\n' )
         write( '<TD>&nbsp;</TD>\n' )
         write( '</TR>\n' )

         -- Materiais
         write( '<TR>\n' )
         write( '<TD><B>Materiais</B></TD>\n' )
         write( '<TD>&nbsp;</TD>\n' )
         write( '</TR>\n' )

         -- Origem
         write( '<TR>\n' )
         write( '<TD><B>Origem </B></TD>\n' )
         write( '<TD>&nbsp;</TD>\n' )
         write( '</TR>\n' )

         -- Destino
         write( '<TR>\n' )
         write( '<TD><B>Destino </B></TD>\n' )
         write( '<TD>&nbsp;</TD>\n' )
         write( '</TR>\n' )

         -- Produto
         write( '<TR>\n' )
         write( '<TD><B> Produto </B></TD>\n' )
         write( '<TD>&nbsp;</TD>\n' )
         write( '</TR>\n' )

         -- Outras Caractersticas
         write( '<TR>\n' )
         write( '<TD valign = "top"><B>Outras Caractersticas </B></TD>\n' )
         write( '<TD>&nbsp;</TD>\n' )
         write( '</TR>\n' )
      else
         -- Dimetro
         if not dados_dutos.duto_diametro then
            dados_dutos.duto_diametro = ""
         end
         write( '<TR>\n' )
         write( '<TD><B>Dimetro </B></TD>\n' )
         if tonumber(dados_dutos.duto_diametro) == 0 then
            dados_dutos.duto_diametro = ""
         end
         write( '<TD>'..exibe_valor_duto(dados_dutos.duto_diametro)..'</TD>\n' )
         write( '</TR>\n' )

         -- Espessura
         if not dados_dutos.duto_espessura then
            dados_dutos.duto_espessura = ""
         end
         write( '<TR>\n' )
         write( '<TD><B>Espessura </B></TD>\n' )
         if tonumber(dados_dutos.duto_espessura) == 0 then
            dados_dutos.duto_espessura = ""
         end
         write( '<TD>'..exibe_valor_duto(dados_dutos.duto_espessura)..'</TD>\n' )
         write( '</TR>\n' )

         -- Extenso
         if not dados_dutos.duto_extensao then
            dados_dutos.duto_extensao = ""
         end
         write( '<TR>\n' )
         write( '<TD><B>Extenso</B></TD>\n' )
         if tonumber(dados_dutos.duto_extensao) == 0 then
            dados_dutos.duto_extensao = ""
         end
         write( '<TD>'..exibe_valor_duto(dados_dutos.duto_extensao)..'</TD>\n' )
         write( '</TR>\n' )

         -- Materiais
         if not dados_dutos.duto_materiais then
            dados_dutos.duto_materiais = ""
         end
         write( '<TR>\n' )
         write( '<TD><B>Materiais</B></TD>\n' )
         write( '<TD>'..dados_dutos.duto_materiais..'</TD>\n' )
         write( '</TR>\n' )

         -- Origem
         if not dados_dutos.duto_origem then
            dados_dutos.duto_origem = ""
         end
         write( '<TR>\n' )
         write( '<TD><B>Origem </B></TD>\n' )
         write( '<TD>'..dados_dutos.duto_origem..'</TD>\n' )
         write( '</TR>\n' )

         -- Destino
         if not dados_dutos.duto_destino then
            dados_dutos.duto_destino = ""
         end
         write( '<TR>\n' )
         write( '<TD><B>Destino </B></TD>\n' )
         write( '<TD>'..dados_dutos.duto_destino..'</TD>\n' )
         write( '</TR>\n' )

         -- Produto
         if not dados_dutos.duto_produto then
            dados_dutos.duto_produto = ""
         end
         write( '<TR>\n' )
         write( '<TD><B> Produto </B></TD>\n' )
         write( '<TD>'..dados_dutos.duto_produto..'</TD>\n' )
         write( '</TR>\n' )

         -- Outras Caractersticas
         if not dados_dutos.duto_outras then
            dados_dutos.duto_outras = ""
         end
         write( '<TR>\n' )
         write( '<TD valign = "top"><B>Outras Caractersticas </B></TD>\n' )
         write( '<TD>')
         -- Dah break no texto de acordo com o numero de caracteres da quebra (nesse caso 70) e imprime o texto
         QuebraLinha(dados_dutos.duto_outras,70)
         write('&nbsp;</TD>\n' )
         write( '</TR>\n' )
      end
   end

   -- Data de Inclusao
   write( '<TR>\n' )
   write( '<TD><B>Data de Incluso</B></TD>\n' )
   write( '<TD>' .. formataData(retornaDataInclusao(cod)) .. '</TD>\n' )
   write( '</TR>\n' )
   dados = DadosProjeto(cod)

   -- Data de Formalizacao
   write( '<TR>\n' )
   write( '<TD><B>Data de Formalizao</B></TD>\n' )
   if dados.proj_dt_form then
      write( '<TD>' ..formataData(dados.proj_dt_form).. '</TD>\n' )
   else
      write( '<TD>&nbsp</TD>\n' )
   end
   write( '</TR>\n' )

   -- Data de Conclusao
   write( '<TR>\n' )
   write( '<TD><B>Data de Concluso</B></TD>\n' )
   if dados.proj_dt_conc then
      write( '<TD>'..formataData(dados.proj_dt_conc)..'</TD>\n' )
   else
      write( '<TD>&nbsp</TD>\n' )
   end
   write( '</TR>\n' )

   -- Data Inicio Previsto
   write( '<TR>\n' )
   write( '<TD><B>Data de Incio Previsto</B></TD>\n' )
   write( '<TD>' .. formataData(retornaDataInicioPrev(cod)) .. '</TD>\n' )
   write( '</TR>\n' )

   -- Data Termino Previsto
   write( '<TR>\n' )
   write( '<TD><B>Data de Trmino Previsto</B></TD>\n' )
   write( '<TD>' .. formataData(retornaDataFimPrev(cod)) .. '</TD>\n' )
   write( '</TR>\n' )

   if temConteudo(funcao) and funcao == 'acompanha' then
      recebeDatasRealProj (cod)
   else
      mostraDatasRealProj (cod)
   end

   -- Versao
   write( '<TR>\n' )
   write( '<TD><B>Verso</B></TD>\n' )
   write( '<TD>' .. retornaVersao(cod) .. '</TD>\n' )
   -- Informacao passada p/ a pagina de revisao
   write( '<INPUT TYPE="hidden" NAME="versao" VALUE="'..retornaVersao(cod)..'">')
   versoes = VersoesAnteriores(cod, retornaVersao(cod), funcao, pagina_func, info)
   if temConteudo( versoes ) then
      write( '</TR><TR><TD><b>Outras Verses</b></TD><TD>' ..versoes.. '</TD>\n' )
   end
   write( '</TR>\n' )
   write( '<TR>\n' )
   write( '<TD><B>Verso Consolidada</B></TD>\n' )
   write( '<TD>' .. retornaVersaoConsolidada( cod )  .. '</TD>\n' )
   write( '</TR>\n' )
   -- Situacao
   write( '<TR>\n' )
   write( '<TD><B>Situao</B></TD>\n' )
   write( '<TD>' .. retornaStatusDescr(retornaStatus(cod)) .. '</TD>\n' )
   write( '</TR>\n' )

   -- Justificativa de Cancelamento
   if retornaStatusDescr(retornaStatus(cod)) == 'Cancelado' then
      write( '<TR>\n' )
      write( '<TD><B>Justificativa do Cancelamento</B></TD>\n' )
      write( '<TD>' .. retornaJustCancel(cod) .. '</TD>\n' )
      write( '</TR>\n' )
   end

   -- Descricao
   if retornaDescricao(cod) == "NULL" then
      descricao = ""
   else
      descricao = retornaDescricao(cod)
   end
   write( '<TR>\n' )
   write( '<TD valign="top"><B>Descrio</B></TD>\n' )
   write( '<TD>' .. descricao .. '</TD>\n' )
   write( '</TR>\n' )

   -- Custo Final Previsto
   write( '<TR>\n' )
   write( '<TD><B>Custo Final Previsto</B></TD>\n' )
   -- -----------------------------------------------------------------------------------------------------
   -- Se o valor de retornaCustoFim(cod) no existir ou existir e for vazio, quando passado para a funo
   -- FORMATA_VALOR() [ formata_valor(retornaCustoFim(cod)) ] ocasionar um erro
   -- Portanto,  necessrio que se verifique o valor de retornaCustoFim(cod) previamente
   -- -----------------------------------------------------------------------------------------------------
   if temConteudo(retornaCustoFim(cod)) then
      write( '<TD>R$ ' .. ponto_centavo(formata_valor(retornaCustoFim(cod))) .. '</TD>\n' )
   else
      write( '<TD>0,00</TD>\n' )
   end
   write( '</TR>\n' )

   ------------------------------------------------------
   --Dados referentes a estado, funcao e tipo de acao. --
   ------------------------------------------------------
   local estado_un, tipo_un, funcao_un
   if resultado_projeto.proj_est_un then
      estado_un = resultado_projeto.proj_est_un

      if resultado_projeto.proj_tipo_un == "p" then
         tipo_un = "Preventiva"
      else
         tipo_un = "Corretiva"
      end

      if resultado_projeto.proj_funcao_un == "s" then
         funcao_un = "Segurana"
      else
         funcao_un = "Meio Ambiente"
      end

   else
      estado_un = ""
      tipo_un = ""
      funcao_un = ""
   end

   if cgi.tipo_servico=="revisa_dados" then
      local sel_tipo1, sel_tipo2, sel_funcao1, sel_funcao2

      estado_un = MontaEstados(estado_un)
      sel_tipo1 = ""
      sel_tipo2 = ""
      sel_funcao1 = ""
      sel_funcao2 = ""

      if tipo_un == "Preventiva" then
         sel_tipo1 = "checked"
      elseif tipo_un == "Corretiva" then
         sel_tipo2 = "checked"
      end

      if funcao_un == "Segurana" then
         sel_funcao1 = "checked"
      elseif funcao_un == "Meio Ambiente" then
         sel_funcao2 = "checked"
      end

      write('\n\n<FORM METHOD="POST" ACTION="lua/atualiza_dados_un.lua" NAME="form1">\n')
      write('<INPUT TYPE="HIDDEN" NAME="cod" VALUE="'..cgi.cod..'">\n')
      write('<INPUT TYPE="HIDDEN" NAME="tipo_servico" VALUE="'..cgi.tipo_servico..'">\n')
      write('<TR>\n')
      write('<TD valign="top"><B>Estado</B></TD>\n')
      write('<TD>'..estado_un..'</TD>\n')
      write('</TR>\n')

      write('<TR>\n')
      write('<TD valign="top"><B>Natureza do Projeto</B></TD>\n')
      write('<TD><input type="radio" name="funcao_un" value="s" '..sel_funcao1..'>Segurana')
      write('<input type="radio" name="funcao_un" value="m" '..sel_funcao2..'>Meio Ambiente</TD>\n')
      write('</TR>\n')

      write('<TR>\n')
      write('<TD valign="top"><B>Tipo de Ao</B></TD>\n')
      write('<TD><INPUT TYPE="RADIO" NAME="tipo_un" VALUE="p" '..sel_tipo1..'>Preventiva')
      write('<INPUT TYPE="RADIO" NAME="tipo_un" VALUE="c" '..sel_tipo2..'>Corretiva</TD>\n')
      write('</TR>\n')

      write('</FORM>\n\n')
    else
      write('<TR>\n')
      write('<TD><B>Estado</B></TD>\n')
      write('<TD>'..estado_un..'</TD>\n')
      write('</TR>\n')
      write('<TR>\n')
      write('<TD><B>Natureza do Projeto</B></TD>\n')
      write('<TD>'..funcao_un..'</TD>\n')
      write('</TR>\n')
      write('<TR>\n')
      write('<TD><B>Tipo de Ao</B></TD>\n')
      write('<TD>'..tipo_un..'</TD>\n')
      write('</TR>\n')
    end
   write( '</TABLE><BR>\n')

   if ESTADO_BD == 'aberto' then
      FechaBD()
   end

end

-- -------------------------------------------------------------------------------------------------
-- FUNCOES PARA LISTAGEM DE PROJETOS PARA CONSULTA E RELATORIO
-- -------------------------------------------------------------------------------------------------
function montaCabecalho( cont_proj, cod_projs )
   -- -----------------------------------------------------------------------------------------------
   -- O cabecalho da tabela de resultados eh montado nessa etapa
   -- -----------------------------------------------------------------------------------------------
   if ( cont_proj == 0 ) then
      write ( '<HR WIDTH="98%">\n' )
      write ( '<TABLE BORDER="0" WIDTH="100%">' )
      write ( '<TR><TD>&nbsp;</TD></TR>\n')
      write ( '<TR><TD align="center"><b>Nenhum projeto satisfaz a consulta.</b></TD></TR>\n' )
      write ( '<TR><TD>&nbsp;</TD></TR>\n')
      write ( '</TABLE>\n' )
   elseif ( cont_proj > 0 ) then
      -- -----------------------------------------------------------------------------------------
      -- Variaveis usadas em listaProjsporOrgao() para imprimir a descricao das ANs, UNs e Status
      -- evitando repeticoes
      -- -----------------------------------------------------------------------------------------
      OrgAnt  = ''
      UniAnt  = ''
      StatAnt = ''

      if ( strfind(cgilua.script_vdir, '/lua') ) then
         dir_img = '../'
      else
         dir_img = './'
      end

      -- Captura informacoes que devem ser exibidas no relatorio
      if temConteudo(cgi.recebe_informacoes) then
         tab_info = Separa_Variaveis(cgi.recebe_informacoes)
   	 queriesOrdenaCampos( cod_projs )
      end

      write ( '<HR WIDTH="98%">\n' )
      write ( '<TABLE BORDER="0">' )
      write ( '<TR><TD WIDTH=12>&nbsp;</TD>\n')
      write ( '<TD><p align="left">&nbsp;<FONT COLOR=green><I>Nmero de projetos (<b>',cont_proj,'</b>)</I></FONT></TD></TR>' )
      write ( '<TD WIDTH=12>&nbsp;</TD><TD>\n' )
      montaBolasLegendas(dir_img)  -- vem de CORES.LUA
      write ( '</TD>\n' )
      write ( '</TR></TABLE>\n' )
      write ( '<HR WIDTH = "98%">\n' )
   end
end

-- Funcao auxiliar utilizada em listaResultado()
function montaLista(lista, valor)
   if temConteudo(lista) and temConteudo(valor) then
   	  lista = lista..','..valor
   elseif temConteudo(valor) then
   	  lista = valor
   else
      lista = ''
   end
   return lista
end

function listaResultado(proj_inter, cod_projs, cont_proj, limite, filtro)
   -- -----------------------------------------------------------------------------------------------
   -- Como o resultado da consulta eh exibido dentro de tabelas HTML, ou seja, o conteudo da tabela
   -- soh eh visualizado quando a tabela eh fechada, os projetos sao exibidos de 20 em 20 dentro de
   -- tabelas diferentes para que o resultado seja mostrado aos poucos e nao somente ao ser impresso
   -- o ultimo projeto, por isso a utilizacao do LOOP abaixo
   -- -----------------------------------------------------------------------------------------------

   -- Imprime o cabecalho da consulta/relatorio
   montaCabecalho( cont_proj, cod_projs )
   if filtro then
      write(filtro)
   end
   
   -- Captura em uma tabela os valores do percentual previsto e realizado dos projetos em andamento e concludos
   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end
   
   consulta = "SELECT proj_perc_fisico_planejado AS esperado, proj_perc_fisico_realizado AS realizado "..
              "FROM projeto WHERE proj_cod IN ("..cod_projs..") AND stat_cod IN (2,4)"
   DBExec(consulta)
   resultado = DBRow()
   perc_fisico_total = {}
   contador = 1
   while resultado do
      perc_fisico_total[contador] = {}
      perc_fisico_total[contador].esperado = resultado.esperado
      perc_fisico_total[contador].realizado = resultado.realizado
      contador = contador + 1
      resultado = DBRow()
   end
   
   if ESTADO_BD == 'aberto' then
      FechaBD()
   end
   
   -- Imprime o calculo do percentual fisico de todos os projetos selecionados
   local perc_previsto  = 0
   local perc_realizado = 0
   local qtd_projetos   = 0
   local i              = 1
   write ( '<table border="0" width="80%" ><tr><td width="2%">&nbsp;</td><td><table border="0">' )
   write ( '<tr><td colspan="2"><b>Percentual Fsico Total dos Projetos Selecionados: </b></td></tr>' )
   while i <= cont_proj do
      if perc_fisico_total[i] and (temConteudo(perc_fisico_total[i].esperado) or temConteudo(perc_fisico_total[i].realizado)) then
         qtd_projetos = qtd_projetos + 1
      	 if temConteudo(perc_fisico_total[i].esperado) then
            perc_previsto  = perc_previsto + perc_fisico_total[i].esperado
         end
         if temConteudo(perc_fisico_total[i].realizado) then
            perc_realizado = perc_realizado + perc_fisico_total[i].realizado
         end
      end
      i = i + 1
   end
   write ( '<tr>' )
   write ( '<td align="left" width="50%"><b>% Fsico Previsto:</td>' )
   if qtd_projetos ~= 0 then
      write ( '<td align="left" width="50%">',formata_valor(perc_previsto/qtd_projetos),' %</td>\n' )
   else
      write ( '<td align="left" width="50%"> - </td>\n' )
   end
   write ( '</tr>' )
   write ( '<tr>' )
   write ( '<td align="left" width="50%"><b>% Fsico Realizado:</td>' )
   if qtd_projetos ~= 0 then
      write ( '<td align="left" width="50%">',formata_valor(perc_realizado/qtd_projetos),' %</td>\n' )
   else
      write ( '<td align="left" width="50%"> - </td>\n' )
   end
   write ( '</tr></table></td></tr></table><br>' )
   write ( '<hr width=98%><br>' )
   
   -- Fim da impressao do calculo de percentual fisico dos projetos

   local i = 1
   local j = 1
   limite = limite + 1
   lista = {}

   if temConteudo(cgi.recebe_informacoes) then
      while proj_inter[i] and i <= cont_proj do
      	
      	  lista[j] = proj_inter[i]
      	  lista_proj_cod = montaLista(lista_proj_cod, proj_inter[i].proj_cod)
      	  j = j + 1
      	  if j == limite or i == cont_proj then
      	     listaProjsporOrgao( lista, cont_proj, lista_proj_cod )
      	     j = 1
      	     lista = {}
      	     lista_proj_cod = ''
      	  end
      	  i = i + 1
      end

      -- Caso tenha sido selecionado o campo custo total ele deve ser impresso no final do relatrio.
      i = 1
      local total_previsto = 0
      local total_realizado = 0
      if temConteudo(tab_info) then
         while tab_info[i] do
            if tab_info[i] == 'custo_total' then
               -- Monta a tabela com os valores de custo para todos os projetos selecionados
               local ano = _ANO_INI_PEGASO_
               write ( '<table border="0" width="100%" cellspacing="0"><tr><td width="4%">&nbsp;</td><td><table border="0">' )
               write ( '<tr><td colspan="3"><B>Custo Total dos Projetos Selecionados: </b></td></tr>' )
               write ( '<tr><td><b>Ano</TD><TD align="right"><b>&nbsp;&nbsp;&nbsp; Custo Previsto</td>' )
               write ( '<td align="right"><b>&nbsp;&nbsp;&nbsp; Custo Realizado</td></tr>' )
               while ano <= _ANO_FIM_PEGASO_ do
                  write( '<tr>' )
                  write( '<td>',ano,'</td>' )
                  if not(custo_prev_total[ano]) then
                     custo_prev_total[ano] = '0.00'
                  end
                  total_previsto = total_previsto + custo_prev_total[ano]
                  write( '<td align="right">&nbsp;&nbsp;&nbsp;',ponto_centavo(formata_valor(custo_prev_total[ano])),'</td>\n' )
                  if not(custo_real_total[ano]) then
                  	  custo_real_total[ano] = '0.00'
                  end
                  total_realizado = total_realizado + custo_real_total[ano]
                  write( '<td align="right">&nbsp;&nbsp;&nbsp;',ponto_centavo(formata_valor(custo_real_total[ano])),'</td>\n' )
                  ano = ano + 1
                  write( '</tr>' )
               end
               write( '<tr></tr><tr>' )
               write( '<td><b>total: </td>' )
               write( '<td align="right">&nbsp;&nbsp;&nbsp;',ponto_centavo(formata_valor(total_previsto)),'</td>\n' )
               write( '<td align="right">&nbsp;&nbsp;&nbsp;',ponto_centavo(formata_valor(total_realizado)),'</td>\n' )
               write( '</tr></table></td></tr></table>' )
            end
            i = i + 1
         end
      end
   else
      while proj_inter[i] and i <= cont_proj do
      	  lista[j] = proj_inter[i]
      	  j = j + 1
      	  if j == limite or i == cont_proj then
      	     listaProjsporOrgao( lista, cont_proj )
      	     j = 1
      	     lista = {}
      	  end
      	  i = i + 1
      end
   end
end


function queriesOrdenaCampos ( lista_proj_cod )
   local resultado
   local consulta
   local k = 1
   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end

   while tab_info[k] do
      if tab_info[k] == 'resp_an' then
         consulta = "SELECT o.org_cod, p.pes_nome, p.pes_chave FROM orgao as o, pessoal as p WHERE o.org_cod IN ("..
                    "select org_cod from projeto where proj_cod in ("..lista_proj_cod..")) AND o.pes_cod_resp = p.pes_cod"
         DBExec(consulta)
         resultado = DBRow()
         an_resp_nome = {}
         an_resp_chave = {}
         while resultado do
            an_resp_nome[resultado.org_cod] = resultado.pes_nome
            an_resp_chave[resultado.org_cod] = resultado.pes_chave
            resultado = DBRow()
         end
      end

      if tab_info[k] == 'resp_un' then
         consulta = "SELECT u.unid_cod, p.pes_nome, p.pes_chave FROM unidade as u, pessoal as p WHERE u.unid_cod IN ("..
                    "select unid_cod from projeto where proj_cod in ("..lista_proj_cod..")) AND u.pes_cod_resp = p.pes_cod"
         DBExec(consulta)
         resultado = DBRow()
         un_resp_nome = {}
         un_resp_chave = {}
         while resultado do
            un_resp_nome[resultado.unid_cod] = resultado.pes_nome
            un_resp_chave[resultado.unid_cod] = resultado.pes_chave
            resultado = DBRow()
         end
      end

      if tab_info[k] == 'gerencia' then
         consulta = "SELECT ger_cod, ger_sigla FROM gerencia WHERE ger_cod IN (select ger_cod from projeto where proj_cod IN ("..
                    lista_proj_cod.."))"
         DBExec(consulta)
         resultado = DBRow()
         ger_sigla = {}
         while resultado do
            ger_sigla[resultado.ger_cod] = resultado.ger_sigla
            resultado = DBRow()
         end
      end

      if tab_info[k] == 'classificacao' then
         consulta = "SELECT b.proj_cod, a.clas_descr, c.ot_chave FROM classificacao a, proj_ot b, ot c WHERE b.proj_cod "..
                    "IN ("..lista_proj_cod..") AND b.clas_cod = a.clas_cod AND a.clas_cod = c.clas_cod"
         DBExec(consulta)
         resultado = DBRow()
         ot_clas = {}
         clas_descr = {}
         while resultado do
         	  if resultado and resultado.ot_chave then
               ot_clas[resultado.proj_cod] = ' ('..resultado.ot_chave..')'
            else
               ot_clas[resultado.proj_cod] = ''
            end
            clas_descr[resultado.proj_cod] = resultado.clas_descr
            resultado = DBRow()
         end
      end

      if tab_info[k] == 'subclassificacao' then
         consulta = "SELECT b.proj_cod, a.clas_descr, c.ot_chave FROM classificacao a, proj_ot b, ot c WHERE b.proj_cod "..
                     "IN ("..lista_proj_cod..") AND b.proj_ot_subcl_cod = a.clas_cod AND a.clas_cod = c.clas_cod"
         DBExec(consulta)
         resultado = DBRow()
         ot_subclas = {}
         subclas_descr = {}
         while resultado do
         	  if resultado and resultado.ot_chave then
               ot_subclas[resultado.proj_cod] = ' ('..resultado.ot_chave..')'
            else
               ot_subclas[resultado.proj_cod] = ''
            end
            subclas_descr[resultado.proj_cod] = resultado.clas_descr
            resultado = DBRow()
         end
      end

      if tab_info[k] == 'meta' then
         consulta = "SELECT p.proj_cod, meta_descr FROM projeto as p, meta as m WHERE p.proj_cod IN ("..lista_proj_cod..
                    ") AND p.proj_meta = m.meta_cod"
         DBExec(consulta)
         resultado = DBRow()
         meta_descr = {}
         while resultado do
         	  meta_descr[resultado.proj_cod] = resultado.meta_descr
            resultado = DBRow()
         end
      end

      if tab_info[k] == 'dt_last_fup' then
      	 consulta = "SELECT fup_proj_cod, fup_data FROM follow_up WHERE fup_cod IN (select last_fup_cod from projeto "..
      	            "where proj_cod IN ("..lista_proj_cod.."))"
         DBExec(consulta)
         resultado = DBRow()
      	 data_fup = {}
      	 while resultado do
            data_fup[resultado.fup_proj_cod] = resultado.fup_data
            resultado = DBRow()
         end
      end

      if tab_info[k] == 'auditoria' then
      	 consulta = "SELECT proj_cod, MAX(aud_data) as data FROM auditoria "..
      	            "WHERE proj_cod IN ("..lista_proj_cod..") GROUP BY proj_cod"
         DBExec(consulta)
         resultado = DBRow()
      	 data_aud = {}
      	 while resultado do
            data_aud[resultado.proj_cod] = resultado.data
            resultado = DBRow()
         end
      end

      if tab_info[k] == 'tipo' then
         consulta = "SELECT proj_cod, trans_tipo FROM transpetro WHERE proj_cod IN ("..lista_proj_cod..")"
         DBExec(consulta)
         resultado = DBRow()
         trans_tipo = {}
      	 while resultado do
      	    if tonumber(resultado.trans_tipo) == 0 then
               trans_tipo[resultado.proj_cod] = 'Investimento'
            elseif tonumber(resultado.trans_tipo) == 1 then
               trans_tipo[resultado.proj_cod] = 'Operao'
            else
               trans_tipo[resultado.proj_cod] = ''
            end
            resultado = DBRow()
         end
      end

      if tab_info[k] == 'atividades' then
      	 local hoje = date("%Y%m%d")
      	 ativ = {}
   	     local j = 1
   	     local projeto = ''
         consulta = "SELECT a.proj_cod, ativ_nome, ativ_dt_ini_prev, ativ_dt_fim_prev, ativ_dt_ini_real, ativ_dt_fim_real, "..
                    "ativ_peso_rel_proj, ativ_perc_real, tipo_curva FROM atividade a, orgao o, projeto p "..
                    "WHERE a.proj_cod IN ("..lista_proj_cod..") AND o.org_cod = p.org_cod AND a.proj_cod = p.proj_cod "..
                    "ORDER BY proj_nome, ativ_dt_ini_prev, ativ_nome"

         DBExec(consulta)
         resultado = DBRow()
         if resultado and resultado.proj_cod then
         	 while resultado and resultado.proj_cod do
         	 	   if resultado.proj_cod ~= projeto then
         	        j = 1
         	        projeto = resultado.proj_cod
         	     end
            	 ativ[projeto..'_'..j] = {}
               if resultado.ativ_nome then
                  ativ[projeto..'_'..j]['nome'] = resultado.ativ_nome
               else
                  ativ[projeto..'_'..j]['nome'] = ''
               end
               if resultado.ativ_dt_ini_prev then
                  ativ[projeto..'_'..j]['dt_ini_prev'] = resultado.ativ_dt_ini_prev
               else
                  ativ[projeto..'_'..j]['dt_ini_prev'] = ''
               end
               if resultado.ativ_dt_fim_prev then
                  ativ[projeto..'_'..j]['dt_fim_prev'] = resultado.ativ_dt_fim_prev
               else
                  ativ[projeto..'_'..j]['dt_fim_prev'] = ''
               end
               if resultado.ativ_dt_ini_real then
                  ativ[projeto..'_'..j]['dt_ini_real'] = resultado.ativ_dt_ini_real
               else
                  ativ[projeto..'_'..j]['dt_ini_real'] = ''
               end
               if resultado.ativ_dt_fim_real then
                  ativ[projeto..'_'..j]['dt_fim_real'] = resultado.ativ_dt_fim_real
               else
                  ativ[projeto..'_'..j]['dt_fim_real'] = ''
               end
               if resultado.ativ_peso_rel_proj then
                  ativ[projeto..'_'..j]['peso_rel'] = resultado.ativ_peso_rel_proj
               else
                  ativ[projeto..'_'..j]['peso_rel'] = ''
               end
               if resultado.ativ_perc_real then
                  ativ[projeto..'_'..j]['perc_real'] = resultado.ativ_perc_real
               else
                  ativ[projeto..'_'..j]['perc_real'] = 0
               end

               -- calculos em funcao do tipo da curva
               ativ[projeto..'_'..j]['tipo_curva'] = resultado.tipo_curva
               ativ[projeto..'_'..j]['peso'] = (tonumber(ativ[projeto..'_'..j]['peso_rel']) or 0)/100
               if ativ[projeto..'_'..j]['peso'] > 0 then
                  ativ[projeto..'_'..j]['realizado'] = tonumber(ativ[projeto..'_'..j]['perc_real'])/ativ[projeto..'_'..j]['peso']
               else
                  ativ[projeto..'_'..j]['realizado'] = 0
               end
               ativ[projeto..'_'..j]['planejado'] = planejadoCurvaS(tipo_curva, ativ[projeto..'_'..j]['dt_ini_prev'], ativ[projeto..'_'..j]['dt_fim_prev'], hoje)

               resultado = DBRow()
               j = j + 1
            end
         end
      end

      if tab_info[k] == 'custo' then
      	 local codigo
         -- Captura em uma tabela os valores do custo realizado
         consulta = "SELECT proj_cod, YEAR(dt_realizacao) AS ano_real, SUM(valor_real) AS custo_real FROM "..
                    "custo_realizado WHERE proj_cod IN ("..lista_proj_cod..") GROUP BY proj_cod, "..
                    "YEAR(dt_realizacao) ORDER BY proj_cod, YEAR(dt_realizacao)"
         DBExec(consulta)
         resultado = DBRow()
         custo_real_ano = {}
         codigo = -1
         while resultado do
         	  if tonumber(resultado.proj_cod) ~= codigo then
         	     custo_real_ano[resultado.proj_cod] = {}
         	  end
         	  codigo = tonumber(resultado.proj_cod)
            custo_real_ano[resultado.proj_cod][resultado.ano_real] = (resultado.custo_real or '0.00')
            resultado = DBRow()
         end

         -- Captura os valores de custo previsto na tabela de custo
         consulta = "SELECT proj_cod, custo_ano AS ano_prev, custo_prev_ano AS custo_prev FROM custo WHERE proj_cod IN ("..
                     lista_proj_cod..") ORDER BY proj_cod, custo_ano"
         DBExec(consulta)
         resultado = DBRow()
         custo_prev_ano = {}
         codigo = -1
         while resultado do
            if tonumber(resultado.proj_cod) ~= codigo then
         	     custo_prev_ano[resultado.proj_cod] = {}
         	  end
         	  codigo = tonumber(resultado.proj_cod)
            custo_prev_ano[resultado.proj_cod][resultado.ano_prev] = (resultado.custo_prev or '0.00')
            resultado = DBRow()
         end
      end

      if tab_info[k] == 'custo_total' then
         -- Captura em uma tabela os valores do custo realizado
         consulta = "SELECT YEAR(dt_realizacao) AS ano_real, SUM(valor_real) AS custo_real "..
                    "FROM custo_realizado WHERE proj_cod IN ("..lista_proj_cod..") "..
                    "GROUP BY YEAR(dt_realizacao) ORDER BY YEAR(dt_realizacao)"
         DBExec(consulta)
         resultado = DBRow()
         custo_real_total = {}
         while resultado do
            custo_real_total[resultado.ano_real] = (resultado.custo_real or '0.00')
            resultado = DBRow()
         end

         -- Captura os valores de custo previsto na tabela de custo
         consulta = "SELECT custo_ano AS ano_prev, SUM(custo_prev_ano) AS custo_prev FROM custo "..
                    "WHERE proj_cod IN ("..lista_proj_cod..") GROUP BY custo_ano ORDER BY custo_ano"
         DBExec(consulta)
         resultado = DBRow()
         custo_prev_total = {}
         while resultado do
            custo_prev_total[resultado.ano_prev] = (resultado.custo_prev or '0.00')
            resultado = DBRow()
         end
      end

      if tab_info[k] == 'real_fisica' then
      	 local ativ_planejado, peso
      	 local planejado, realizado
         local hoje = date("%Y%m%d")
         perc_planejado = {}
      	 perc_realizado = {}
         consulta = "SELECT a.proj_cod, ativ_dt_ini_prev, ativ_dt_fim_prev, ativ_peso_rel_proj, ativ_perc_real, "..
                    "tipo_curva, stat_cod FROM atividade a, orgao o, projeto p WHERE a.proj_cod IN ("..lista_proj_cod..
                    ") AND o.org_cod = p.org_cod AND a.proj_cod = p.proj_cod ORDER BY a.proj_cod"
         DBExec(consulta)
         resultado = DBRow()
         local codigo
         while resultado do
            if resultado.proj_cod ~= codigo then
               codigo = resultado.proj_cod
               planejado = 0
               realizado = 0
            end
            ativ_planejado = planejadoCurvaS(resultado.tipo_curva, resultado.ativ_dt_ini_prev, resultado.ativ_dt_fim_prev, hoje)
            peso = tonumber(resultado.ativ_peso_rel_proj)/100
            planejado = planejado + ativ_planejado * peso
            if ((resultado.stat_cod == 2) or (resultado.stat_cod == 4)) then
               perc_planejado[resultado.proj_cod] = formata_valor(planejado)
            end
            if (resultado.ativ_perc_real) then
               realizado = realizado + tonumber(resultado.ativ_perc_real)
               if ((resultado.stat_cod == 2) or (resultado.stat_cod == 4)) then
                  perc_realizado[resultado.proj_cod] = formata_valor(realizado)
               end
            end
            resultado = DBRow()
         end
      end

      k = k + 1
   end

   if ESTADO_BD == 'aberto' then
      FechaBD()
   end
end


function ordenaCampos ( tab_projs )
   local k = 1
   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end
   write('<table border="0">')
   while tab_info[k] do
      if tab_info[k] == 'area_negocio' then
         if not( temConteudo(tab_projs.org_sigla) ) then
            write ( '<TR><TD colspan="3"><B>rea de Negcio: </B>-</TD></TR>\n' )
         else
            write ( '<TR><TD colspan="3"><B>rea de Negcio: </B>',tab_projs.org_sigla,'</TD></TR>\n' )
         end
      end
      if tab_info[k] == 'resp_an' then
         if an_resp_nome and an_resp_nome[tab_projs.org_cod] then
            write ( '<TR><TD colspan="3"><B>Responsvel pela AN: </B>',an_resp_nome[tab_projs.org_cod],' (<I>',an_resp_chave[tab_projs.org_cod],'</I>)</TD></TR>\n' )
         else
            write ( '<TR><TD colspan="3"><B>Responsvel pela AN: </B>-</TD></TR>\n' )
         end
      end
      if tab_info[k] == 'unidade_negocio' then
         if not( temConteudo(tab_projs.unid_sigla) ) then
            write ( '<TR><TD colspan="3"><B>Unidade de Negcio: </B>-</TD></TR>\n' )
         else
            write ( '<TR><TD colspan="3"><B>Unidade de Negcio: </B>',tab_projs.unid_sigla,'</TD></TR>\n' )
         end
      end
      if tab_info[k] == 'resp_un' then
         if tab_projs.unid_cod and un_resp_nome and un_resp_nome[tab_projs.unid_cod] then
            write ( '<TR><TD colspan="3"><B>Responsvel pela UN: </B>',un_resp_nome[tab_projs.unid_cod],' (<I>',un_resp_chave[tab_projs.unid_cod],'</I>)</TD></TR>\n' )
         else
            write ( '<TR><TD colspan="3"><B>Responsvel pela UN: </B>-</TD></TR>\n' )
         end
      end
      if tab_info[k] == 'gerencia' then
         if tab_projs.ger_cod and ger_sigla and ger_sigla[tab_projs.ger_cod] then
            write ( '<TR><TD colspan="3"><B>Gerncia: </B>',ger_sigla[tab_projs.ger_cod],'</TD></TR>\n' )
         else
            write ( '<TR><TD colspan="3"><B>Gerncia: </B>-</TD></TR>\n' )
         end
      end
      if tab_info[k] == 'classificacao' then
         if clas_descr and clas_descr[tab_projs.proj_cod] then
            write ( '<TR><TD colspan="3"><B>Classificao: </B>',clas_descr[tab_projs.proj_cod],ot_clas[tab_projs.proj_cod],'</TD></TR>\n' )
         else
            write ( '<TR><TD colspan="3"><B>Classificao: </B>-</TD></TR>\n' )
         end
      end
      if tab_info[k] == 'subclassificacao' then
         if subclas_descr and subclas_descr[tab_projs.proj_cod] then
            write ( '<TR><TD colspan="3"><B>Sub-Classificao: </B>',subclas_descr[tab_projs.proj_cod],ot_subclas[tab_projs.proj_cod],'</TD></TR>\n' )
         else
            write ( '<TR><TD colspan="3"><B>Sub-Classificao: </B>-</TD></TR>\n' )
         end
      end
      if tab_info[k] == 'meta' then
         if meta_descr[tab_projs.proj_cod] then
            write ( '<TR><TD colspan="3"><B>Meta: </B>',meta_descr[tab_projs.proj_cod],'</TD></TR>\n' )
         else
            write ( '<TR><TD colspan="3"><B>Meta: </B>-</TD></TR>\n' )
         end
      end
      if tab_info[k] == 'prioridade' then
         if not tab_projs.proj_prior or tab_projs.proj_prior == '' then
            write ( '<TR><TD colspan="3"><B>Prioridade: </B>-</TD></TR>\n' )
         else
            write ( '<TR><TD colspan="3"><B>Prioridade: </B>',tab_projs.proj_prior,'</TD></TR>\n' )
         end
      end
      if tab_info[k] == 'codigo_projeto' then
         if not tab_projs.proj_cod_usuario or tab_projs.proj_cod_usuario == '' then
            write ( '<TR><TD colspan="3"><B>Cdigo do Projeto: </B>-</TD></TR>\n' )
         else
            write ( '<TR><TD colspan="3"><B>Cdigo do Projeto: </B>',tab_projs.proj_cod_usuario,'</TD></TR>\n' )
         end
      end

      if tab_info[k] == 'status' then
         if not tab_projs.stat_cod or tab_projs.stat_cod == '' then
            write ( '<TR><TD colspan="3"><B>Situao: </B>-</TD></TR>\n' )
         else
            write ( '<TR><TD colspan="3"><B>Situao: </B>',tab_projs.stat_descr,'</TD></TR>\n' )
         end
      end
      if tab_info[k] == 'plano_rec' then
         if not tab_projs.proj_plano_rec or tab_projs.proj_plano_rec == '' then
            write ( '<TR><TD colspan="3"><B>Plano de Recuperao: </B>-</TD></TR>\n' )
         else
            if tonumber(tab_projs.proj_plano_rec) == 1 then
               plano_rec = 'Sim'
            else
               plano_rec = 'No'
            end
            write ( '<TR><TD colspan="3"><B>Plano de Recuperao: </B>',plano_rec,'</TD></TR>\n' )
         end
      end
      if tab_info[k] == 'classacomp' then
         if not tab_projs.proj_class or tab_projs.proj_class == '' then
            write ( '<TR><TD colspan="3"><B>Classificao do Acompanhamento: </B>-</TD></TR>\n' )
         else
            proj_class = {}
            proj_class[1] = 'I'
            proj_class[2] = 'II'
            proj_class[3] = 'III'
            write ( '<TR><TD colspan="3"><B>Classificao do Acompanhamento: </B>',proj_class[tonumber(tab_projs.proj_class)],'</TD></TR>\n' )
         end
      end
      if tab_info[k] == 'dt_ini_prev' then
         if not( temConteudo(tab_projs.proj_dt_ini_prev) ) then
            write ( '<TR><TD colspan="3"><B>Data de Incio Previsto: </B>-</TD></TR>\n' )
         else
            write ( '<TR><TD colspan="3"><B>Data de Incio Previsto: </B>',formataData(tab_projs.proj_dt_ini_prev),'</TD></TR>\n' )
         end
      end
      if tab_info[k] == 'dt_fim_prev' then
         if not( temConteudo(tab_projs.proj_dt_fim_prev) ) then
            write ( '<TR><TD colspan="3"><B>Data de Trmino Previsto: </B>-</TD></TR>\n' )
         else
            write ( '<TR><TD colspan="3"><B>Data de Trmino Previsto: </B>',formataData(tab_projs.proj_dt_fim_prev),'</TD></TR>\n' )
         end
      end
      if tab_info[k] == 'dt_ini_real' then
         if not( temConteudo(tab_projs.proj_dt_ini_real) ) then
            write ( '<TR><TD colspan="3"><B>Data de Incio Realizado: </B>-</TD></TR>\n' )
         else
            write ( '<TR><TD colspan="3"><B>Data de Incio Realizado: </B>',formataData2(tab_projs.proj_dt_ini_real),'</TD></TR>\n' )
         end
      end
      if tab_info[k] == 'dt_fim_real' then
         if not( temConteudo(tab_projs.proj_dt_fim_real) ) then
            write ( '<TR><TD colspan="3"><B>Data de Trmino Realizado: </B>-</TD></TR>\n' )
         else
            write ( '<TR><TD colspan="3"><B>Data de Trmino Realizado: </B>',formataData2(tab_projs.proj_dt_fim_real),'</TD></TR>\n' )
         end
      end
      if tab_info[k] == 'dt_last_fup' then
         if data_fup and data_fup[tab_projs.proj_cod] then
            write ( '<TR><TD colspan="3"><B>Data do ltimo Follow-up: </B>',formataData2(data_fup[tab_projs.proj_cod]),'</TD></TR>\n' )
         else
            write ( '<TR><TD colspan="3"><B>Data do ltimo Follow-up: </B>-</TD></TR>\n' )
         end
      end
      if tab_info[k] == 'auditoria' then
         if data_aud and data_aud[tab_projs.proj_cod] then
            write ( '<TR><TD colspan="3"><B>Data da ltima Auditoria: </B>',formataData(data_aud[tab_projs.proj_cod]),'</TD></TR>\n' )
         else
            write ( '<TR><TD colspan="3"><B>Data da ltima Auditoria: </B>-</TD></TR>\n' )
         end
      end
      if tab_info[k] == 'tipo' then
         if trans_tipo and trans_tipo[tab_projs.proj_cod] then
         	  write ( '<TR><TD colspan="3"><B>Tipo: </B>',trans_tipo[tab_projs.proj_cod], '</TD></TR>\n' )
         else
            write ( '<TR><TD colspan="3"><B>Tipo: </B>-</TD></TR>\n' )
         end
      end

      if tab_info[k] == 'atividades' then
         local j = 1
         if ativ[tab_projs.proj_cod..'_'..j] then
            write ( '</TABLE><TABLE border="0">' )
            write ( '<TR><TD colspan="8"><B>Atividades: </B></TD></TR>' )
            write ( '<TR><TD><b>Nome da Atividade</TD><TD><b>Data de Incio Prevista</TD>' )
            write ( '<TD><b>Data de Trmino Prevista</TD><TD><b>Data de Incio Realizada</TD><TD><b>Data de Trmino Realizada</TD>' )
            write ( '<TD><b>Peso da Atividade</TD><TD><b>% Realizado<br>(% Previsto)</b></TD><TD><b>% Realizado no Projeto (% Previsto)</TD></TR>' )
            while ativ[tab_projs.proj_cod..'_'..j] do
               write( '<TR>' )
               write( '<TD>',ativ[tab_projs.proj_cod..'_'..j]['nome'],'</TD>' )
               write( '<TD>',formataData2(ativ[tab_projs.proj_cod..'_'..j]['dt_ini_prev']),'</TD>' )
               write( '<TD>',formataData2(ativ[tab_projs.proj_cod..'_'..j]['dt_fim_prev']),'</TD>' )
               write( '<TD>',formataData2(ativ[tab_projs.proj_cod..'_'..j]['dt_ini_real']),'</TD>' )
               write( '<TD>',formataData2(ativ[tab_projs.proj_cod..'_'..j]['dt_fim_real']),'</TD>' )
               write( '<TD>',ativ[tab_projs.proj_cod..'_'..j]['peso_rel'],'</TD>' )
               write( '<TD>',formata_valor(ativ[tab_projs.proj_cod..'_'..j]['realizado']),'% (',formata_valor(ativ[tab_projs.proj_cod..'_'..j]['planejado']),'%)</TD>' )
               write( '<TD>',formata_valor(ativ[tab_projs.proj_cod..'_'..j]['realizado']*ativ[tab_projs.proj_cod..'_'..j]['peso']),'% (',formata_valor(ativ[tab_projs.proj_cod..'_'..j]['planejado']*ativ[tab_projs.proj_cod..'_'..j]['peso']),'%)</TD>' )
               write( '</TR>' )
               j = j + 1
            end
            write ( '</TABLE><TABLE border="0">' )
         else
            write ( '</TABLE><TABLE border="0">' )
            write ( '<TR><TD><B>Atividades: </B>no h atividades para este projeto.</TD></TR>\n' )
            write ( '</TABLE><TABLE border="0">' )
         end
      end

      if tab_info[k] == 'custo' then
         -- Monta a tabela com os valores de custo
         local ano = _ANO_INI_PEGASO_
         write ( '</TABLE><TABLE border="0">' )
         write ( '<TR><TD colspan="3"><B>Custo: </B></TD></TR>' )
         write ( '<TR><TD><b>Ano &nbsp;&nbsp;&nbsp;</TD><TD align="right"><b>Custo Previsto</TD>' )
         write ( '<TD align="right"><b>&nbsp;&nbsp;&nbsp; Custo Realizado</TD></TR>' )
         while ano <= _ANO_FIM_PEGASO_ do
            write( '<TR>' )
            write( '<TD>',ano,'</TD>' )
            if not custo_prev_ano[tab_projs.proj_cod] then
               custo_prev_ano[tab_projs.proj_cod] = {}
            end
            if not custo_prev_ano[tab_projs.proj_cod][ano] then
               custo_prev_ano[tab_projs.proj_cod][ano] = '0.00'
            end
            write( '<TD align="right">&nbsp;&nbsp;&nbsp;',ponto_centavo(formata_valor(custo_prev_ano[tab_projs.proj_cod][ano])),'</TD>\n' )
            if not custo_real_ano[tab_projs.proj_cod] then
            	  custo_real_ano[tab_projs.proj_cod] = {}
            end
            if not custo_real_ano[tab_projs.proj_cod][ano] then
            	  custo_real_ano[tab_projs.proj_cod][ano] = '0.00'
            end
            write( '<TD align="right">&nbsp;&nbsp;&nbsp;',ponto_centavo(formata_valor(custo_real_ano[tab_projs.proj_cod][ano])),'</TD>\n' )
            ano = ano + 1
         end
         write ( '</TABLE><TABLE border="0">')
      end
      ano_atual = date('%Y')

      if tab_info[k] == 'perc_financeiro' then
         local realizado = formata_valor(tab_projs.proj_perc_financeiro_realizado or 0)
         local esperado  = formata_valor(tab_projs.proj_perc_financeiro_esperado or 0)
         -- ----------------------------------------------------------------------------------------------------
         -- Quando o percentual FINANCEIRO ESPERADO nao existe (=0%) o valor do percentual FINANCEIRO REALIZADO
         -- nao pode ser calculado (pois ele eh funcao do percentual FINANCEIRO ESPERADO), recebendo o valor '-'
         -- ----------------------------------------------------------------------------------------------------
         if esperado == '0,00' then
            write('<TD><B>% Financeiro Previsto at ',ano_atual,': </B> - </TD><TD>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>' )
            write('<TD><B>% Financeiro Realizado at ',ano_atual,': </B> - </TD></TR>' )
         else
            write('<TD><B>% Financeiro Previsto at ',ano_atual,': </B>',esperado,'%</TD><TD>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>' )
            write('<TD><B>% Financeiro Realizado at ',ano_atual,': </B>',realizado,'%</TD></TR>' )
         end
      end
      
      if tab_info[k] == 'real_fisica' then
      	 if perc_planejado[tab_projs.proj_cod] then
            write('<TR><TD><B>% Fsico Previsto:</B> ',perc_planejado[tab_projs.proj_cod],'%</TD><TD>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>')
         else
            write('<TR><TD><B>% Fsico Previsto:</B> - </TD><TD>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>')
         end
         if perc_realizado[tab_projs.proj_cod] then
            write('<TD><B>% Fsico Realizado:</B> ',perc_realizado[tab_projs.proj_cod],'%</TD></TR>' )
         else
            write('<TD><B>% Fsico Realizado:</B> - </TD></TR>' )
         end
      end
      if tab_info[k] == 'desempenho' then
         write ( '<TR><TD colspan="3"><B>Desempenho do Projeto: </B>',tab_projs.desempenho_descr,'</TD></TR>\n' )
      end
      k = k + 1
   end
   write('</table><br>')

   if ESTADO_BD == 'aberto' then
      FechaBD()
   end
end


-- ----------------------------------------------------------------------------------------------------------
-- Nao eh usado em PROJETOS.LUA mas varios outros scripts a usam
-- Se o script que chama essa funo estiver no diretrio LUA, a varivel dir_img deve receber o valor '../'
-- antes da chamada da funo. Se o script estiver no diretrio HTML nenhuma atribuio precisa ser feita
-- ----------------------------------------------------------------------------------------------------------
-- tam_tab eh opcional e indica o tamanho da tabela, caso esse valor nao seja passado ele eh calculado
-- lista_proj_cod eh opcional e indica o codigo dos projetos selecionados
-- ----------------------------------------------------------------------------------------------------------
function listaProjsporOrgao( tab_projs, tam_tab, lista_proj_cod )
   local i
   if ( strfind(cgilua.script_vdir, '/lua') ) then
       reldir = '../'
   else
       reldir = './'
   end

   dofile ( reldir .. 'lua/orgaos.lua' )
   dofile ( reldir .. 'lua/constantes.lua')
   -- ---------------------------------------------------------------------
   -- esse valor estah associado a funcao listaProjsporOrgao() e indica em
   -- qual diretorio as imagens devem ser procuradas
   -- ---------------------------------------------------------------------
   if not( temConteudo(dir_img) ) then
      dir_img = reldir
   end

   if not( temConteudo(cgi.tipo_servico) ) then
      tipo_servico = 'person'
   else
      tipo_servico = cgi.tipo_servico
   end

   write ( '<TABLE BORDER = "0" WIDTH = "100%" cellspacing="0"><TR>\n' )
   write ( '<TD width="4%">&nbsp;</TD><TD>\n' )
   write ( '<TABLE BORDER = "0" WIDTH = "100%">\n' )

   -- ------------------------------------------------------------------------------------
   -- LISTA PROJETO ORDENADOS POR ORGAO E UNIDADE MOSTRANDO OS CAMPOS PEDIDOS PELO USURIO
   -- ------------------------------------------------------------------------------------
   if cgi.tipo_servico == 'relatorio' then
      dofile ( reldir..'ot.lua')
      dofile ( reldir..'acessabd.lua')

      i = 1
      while ( tab_projs[i] ) do
         cor, etiqueta = CorFase(tab_projs[i].proj_cod, tab_projs[i].stat_cod, tab_projs[i].proj_desempenho)
		     if not cgi.cons_cod then
		        cgi.cons_cod = ''
		     end
         if not cgi.acao then
         	 cgi.acao = ''
         end

         -- ---------------------------------------------------------------------------------------
         -- Se o projeto estah em edicao, nao eh linkada a ETIQUETA ao cronograma
         -- ---------------------------------------------------------------------------------------
         if ( strfind( cor, _IMG_EDICAO_ ) ) then
            write ( '<TR><TD width="20" valign="top"><img src='..cor..' alt="'..etiqueta..'" align = "top" border = "0"></TD><TD><A HREF="' .. reldir .. 'result_consulta.html?cod='.. tab_projs[i].proj_cod .. '&tipo_servico='..tipo_servico..'&cons_cod='..cgi.cons_cod..'&acao='..cgi.acao..'"> ' .. tab_projs[i].proj_nome .. '</A></TD></TR>\n')
         else
            write ( '<TR><TD width="20" valign="top"><A HREF="'..dir_img..'cronog/cron_proj.html?proj_cod='..tab_projs[i].proj_cod..'&pagina='..cgi.pagina..'&tipo_servico='..tipo_servico..'&cons_cod='..cgi.cons_cod..'&acao='..cgi.acao..'"><img src='..cor..' alt="'..etiqueta..'" align = "top" border = "0"></TD><TD><A HREF="' .. reldir .. 'result_consulta.html?cod='.. tab_projs[i].proj_cod .. '&tipo_servico='..tipo_servico..'&cons_cod='..cgi.cons_cod..'&acao='..cgi.acao..'"> ' .. tab_projs[i].proj_nome .. '</A></TD></TR>\n')
         end

         if temConteudo(cgi.recebe_informacoes) then
            write ( '<TR><TD>&nbsp;</TD><TD>\n' )
            ordenaCampos(tab_projs[i])
            write ( '</TD></TR>' )
         end

         write ( '<TR><TD colspan="2"></TD></TR>\n')

         i = i + 1
      end

   else     -- se nao for RELATORIO, trata CONSULTA

      i = 1
      while ( tab_projs[i] ) do
         if ( ( tab_projs[i].org_cod ) and ( tab_projs[i].org_cod ~= OrgAnt ) and
            ( tab_projs[i].org_cod ~= '' )) then
            OrgAnt = tab_projs[i].org_cod
            StatAnt = ''
            write('<TR><TD COLSPAN=3>&nbsp;</TD></TR><TR><TD COLSPAN=3><STRONG>' .. tab_projs[i].org_sigla )
            write(' - ' .. tab_projs[i].org_nome .. '</STRONG></TD></TR>\n')
         end
         if ( ( tab_projs[i].unid_cod ) and ( tab_projs[i].unid_cod ~= UniAnt ) and
            ( tab_projs[i].unid_cod ~= '' ) ) then
            UniAnt = tab_projs[i].unid_cod
            StatAnt = ''
            write('<TR><TD COLSPAN=3>&nbsp;</TD></TR><TR><TD COLSPAN=3>&nbsp;&nbsp;' .. tab_projs[i].unid_sigla )
            write(' - ' .. tab_projs[i].unid_nome .. '</TD></TR>\n')
         end
         if ( ( tab_projs[i].stat_cod ) and ( tab_projs[i].stat_cod ~= StatAnt ) and
            ( tab_projs[i].stat_cod ~= '' ) ) then
            StatAnt = tab_projs[i].stat_cod
            write('<TR><TD COLSPAN=3>&nbsp;</TD></TR><TR><TD COLSPAN=3><I><B>&nbsp;&nbsp;&nbsp;&nbsp;' .. tab_projs[i].stat_descr .. '</B></I></TD></TR>\n')
         end

         cor, etiqueta = CorFase(tab_projs[i].proj_cod, tab_projs[i].stat_cod, tab_projs[i].proj_desempenho)
		      if not cgi.cons_cod then
		   	     cgi.cons_cod = ''
		      end
         if not cgi.acao then
         	 cgi.acao = ''
         end

         write ( '<TR><TD width="25">&nbsp;</TD>\n')
         -- ---------------------------------------------------------------------------------------
         -- Se o projeto estah em edicao, nao eh linkada a ETIQUETA ao cronograma
         -- ---------------------------------------------------------------------------------------
         if strfind( cor, _IMG_EDICAO_ ) then
            write( '<TD width="20" valign="top"><img src='..cor..' alt="'..etiqueta..'" align = "top" border = "0"></TD><TD><A HREF="' .. reldir .. 'result_consulta.html?cod='.. tab_projs[i].proj_cod .. '&tipo_servico='..tipo_servico..'&cons_cod='..cgi.cons_cod..'&acao='..cgi.acao..'">' .. tab_projs[i].proj_nome .. '</A></TD></TR>\n')
         else
            write( '<TD width="20" valign="top"><A HREF="'..dir_img..'cronog/cron_proj.html?proj_cod='..tab_projs[i].proj_cod..'&pagina='..cgi.pagina..'&tipo_servico='..tipo_servico..'&cons_cod='..cgi.cons_cod..'&acao='..cgi.acao..'"><img src='..cor..' alt="'..etiqueta..'" align = "top" border = "0"></TD><TD><A HREF="' .. reldir .. 'result_consulta.html?cod='.. tab_projs[i].proj_cod .. '&tipo_servico='..tipo_servico..'&cons_cod='..cgi.cons_cod..'&acao='..cgi.acao..'">' .. tab_projs[i].proj_nome .. '</A></TD></TR>\n')
         end
         i = i + 1
      end

   end

   write ( '</TD></TR></TABLE>\n' )
   write ( '</TD><TD width="3%">&nbsp;</TD><TD>\n' )
   write ( '</TD></TR></TABLE>\n' )
end
-- -------------------------------------------------------------------------------------------------
-- FIM FUNCOES PARA LISTAGEM DE PROJETOS PARA CONSULTA E RELATORIO
-- -------------------------------------------------------------------------------------------------

-- Nao eh utilizada em PROJETOS.LUA mas os outros scripts que chamam a PROJETOS.LUA a usam
function listaFollowUp( cod, limite, titulo )
   if ( strfind(cgilua.script_vdir, '/lua') ) then
       reldir = '../'
   else
       reldir = './'
   end

   dofile( reldir..'acessabd.lua' )

   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end

   query = "SELECT fup_resp as resp, fup_data as data, fup_verificacao as verif, fup_descr as descr "..
           "FROM follow_up WHERE fup_proj_cod = " .. cod .. " ORDER BY fup_data DESC, fup_cod DESC "
   DBExec( query )
   fup = DBRow()

   if fup then
      write( '<TABLE WIDTH="80%" BORDER="0" ALIGN="CENTER">\n')
      if titulo then
         write( '<TR>\n' )
         write( '<TD COLSPAN=4 ALIGN=CENTER class=fieldLabel><B>'..titulo..'</B></TD>\n')
         write( '</TR>\n' )
         write( '<TR><TD COLSPAN=4>&nbsp;</TD></TR>\n' )
      end
      write( '<TR>\n' )
      write( '<TD><B>Responsvel</B></TD>\n' )
      write( '<TD><B>Data de Incluso</B></TD>\n' )
      write( '<TD><B>Verificao do Projeto</B></TD>\n' )
      write( '<TD><B>Descrio</B></TD>\n' )
      write( '</TR>\n' )
      tab = {}
      cont = 1
      sem_limite = 0
      if limite == 0 then
      	 limite = cont + 1
      	 sem_limite = 1
      end
      while fup and cont <= limite do
      	    tab[cont] = {}
      	    tab[cont].resp = fup.resp
            tab[cont].data = formataData2(fup.data)
            if fup.verif == 1 then
               tab[cont].verif = 'Ok'
            else
               tab[cont].verif = 'No Ok'
            end
            tab[cont].descr = fup.descr
            fup  = DBRow()
            cont = cont + 1
            if sem_limite == 1 then
               limite = limite + 1
            end
      end
      cor = "#CCCCCC"
      cont = cont - 1
      while tab[cont] and cont > 0 do
      	    cor = AlternaCorLinha(cor)
      	    write( '<TR BGCOLOR=',cor,'>\n' )
      	    write( '<TD>'..tab[cont].resp..'</TD>\n' )
            write( '<TD>'..tab[cont].data..'</TD>\n' )
            write( '<TD>'..tab[cont].verif..'</TD>\n' )
            write( '<TD>'..tab[cont].descr..'</TD>\n' )
            write( '</TR>\n' )
            cont = cont - 1
      end
      write( '</TABLE><BR>\n')
  else
    write( '<TABLE WIDTH="80%" BORDER="0" ALIGN="CENTER">\n')
       write( '<TR>\n' )
         write( '<TD ALIGN=CENTER class=fieldLabel><B>No h registro de Follow-Up para esse projeto.</B></TD>\n')
       write( '</TR>\n')
    write( '</TABLE>\n')
  end

  if ESTADO_BD == 'aberto' then
     FechaBD()
  end

end

-- Nao eh utilizada em PROJETOS.LUA mas os outros scripts que chamam a PROJETOS.LUA a usam
function listaAuditoria( cod, limite, titulo )
   if ( strfind(cgilua.script_vdir, '/lua') ) then
       reldir = '../'
   else
       reldir = './'
   end

   dofile( reldir..'acessabd.lua' )

   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end

   query = "SELECT aud_data, aud_obs FROM auditoria WHERE proj_cod = " .. cod .. " ORDER BY aud_data"
   DBExec( query )
   aud = DBRow()

   write( '<hr width="85%">\n')

   if aud then
      write( '<table width="80%" border="0" align="center">\n')
      if titulo then
         write( '<tr>\n' )
         write( '<td colspan="2" align="center" class="fieldLabel"><b>'..titulo..'</b></td>\n')
         write( '</tr>\n' )
         write( '<tr><td colspan="4">&nbsp;</td></tr>\n' )
      end
      write( '<tr>\n' )
      write( '<td><b>Data da Auditoria</b></td>\n' )
      write( '<td><b>Observaes</b></td>\n' )
      write( '</tr>\n' )
      tab = {}
      cont = 1
      sem_limite = 0
      if limite == 0 then
      	 limite = cont + 1
      	 sem_limite = 1
      end
      while aud and cont <= limite do
         tab[cont] = {}
         tab[cont].data = formataData(aud.aud_data)
         tab[cont].obs  = aud.aud_obs
         aud  = DBRow()
         cont = cont + 1
         if sem_limite == 1 then
            limite = limite + 1
         end
      end
      cor = "#CCCCCC"
      cont = cont - 1
      while tab[cont] and cont > 0 do
      	 cor = AlternaCorLinha(cor)
      	 write( '<tr bgcolor=',cor,'>\n' )
      	 write( '<td>'..tab[cont].data..'</td>\n' )
         if tab[cont].obs then
            write( '<td>'..tab[cont].obs..'</td>\n' )
         else
            write( '<td>&nbsp;</td>\n' )
         end
         write( '</tr>\n' )
         cont = cont - 1
      end
      write( '</table><br>\n')
  else
    write( '<table width="80%" border="0" align="center">\n')
       write( '<tr>\n' )
         write( '<td align="center" class="fieldlabel"><b>No h registro de Auditorias para esse projeto.</b></td>\n')
       write( '</tr>\n')
    write( '</table>\n')
  end

  if ESTADO_BD == 'aberto' then
     FechaBD()
  end

end

function EditaAuditoria()
   write( '<hr width="85%"><BR>\n')
   write( '<table width="80%" border="0" align="center">\n')
   write( '<tr><td><INPUT TYPE="hidden" NAME="auditar" VALUE="1"></td>\n')
    write( '<tr>\n' )
    write( '<td colspan="2" align="center" class="fieldLabel"><b>Auditoria de Projeto</b></td>\n')
    write( '</tr>\n' )
    write( '<tr><td colspan="2">&nbsp;</td></tr>\n' )


   write( '<tr>\n' )
   write( '<td><b>Data da Auditoria:</b>&nbsp;&nbsp;<INPUT TYPE="text" NAME="dt_audi" SIZE="10" MAXLENGTH="10"></td>\n')
   write( '<td>&nbsp;</td>\n' )
   write( '</tr>\n' )

   if cgi.msg_dt_audi then
      write( '<tr>\n' )
      write( '<td>'..cgi.msg_dt_audi..'</td>\n' )
      write( '</tr>\n' )
   end

   write( '<tr>\n' )
     write( '<table width="80%" border="0" align="center">\n')
      write( '<tr>\n' )
      write( '<td><b>Observaes:</b></td>\n' )
      write( '<td>&nbsp;</td>\n' )
      write( '</tr>\n')
      write( '<tr>\n' )
      write( '<td><textarea rows="5" cols="58" wrap="virtual" name="obs_audi"></textarea></td>\n')
      write( '<td>&nbsp;</td>\n' )
      write( '</tr>\n')

      if cgi.msg_obs_audi then
         write( '<tr>\n' )
         write( '<td>'..cgi.msg_obs_audi..'</td>\n' )
         write( '</tr>\n' )
      end

     write( '</table>\n')
    write( '</td>\n')
   write( '</tr>\n' )
   write( '</table>\n')

end