dofile ( "../validaform/validaform.lua" )
dofile ( "form_acompanha.lua" )
dofile ( "acessabd.lua" )
dofile ( "global.lua" )
 
-- -----------------------------------------------------------------------------
-- Se alguma alterao for efetuada no projeto, recebe a descricao da alteracao
-- -----------------------------------------------------------------------------   
   justificativa  = ''
   mensagem_ativ  = ''

-- --------------------------------
-- Inicializando mensagens de erro
-- --------------------------------    
   cgi.msg_topo   = ''
   cgi.msg_dt_ini = ''   
   cgi.msg_dt_fim = '' 

-- ----------------------------------------------------------
-- Description : converte em numero, retornando 0 se for Nil
-- Parameters  : valor
-- Return      : o numero
-- ----------------------------------------------------------
   function val(valor)
      local nVal = 0   
      nVal = tonumber(valor)   
      if nVal then
         return nVal
      end       
      return 0
   end 

-- --------------------------------------------------------------
-- description : adiciona uma tupla ao historico de atualizacoes
-- parameters  : cod_proj = codigo do projeto
--               cod_ativ = codigo da atividade
--               perc_real = percentual realizado
-- --------------------------------------------------------------
   function gravaHistorico(cod_proj, cod_ativ, perc_real)
      -- data('%c') : data do sistema no formato mm/dd/aa hh:mm:ss
      EscreveBD("perc_realizado", "ativ_cod, proj_cod, dt_atual, perc_real", tostring(cod_ativ) .. ","..cod_proj..",'"..date('%c').."',"..perc_real)   
   end
   
-- Funcao para eliminar redirecionamento de cgi's desnecessarios
   function LimpaCGI()      
      if not( temConteudo(cgi.msg) ) then
         cgi.msg = nil
      end
      if not( temConteudo(cgi.msg_topo) ) then 
         cgi.msg_topo = nil
      end   
      if not( temConteudo(cgi.msg_dt_ini) ) then 
         cgi.msg_dt_ini = nil  
      end   
      if not( temConteudo(cgi.msg_dt_fim) ) then 
         cgi.msg_dt_fim = nil
      end
      if tonumber(cgi.cont) > 1 then
         i = 1
         while (i < tonumber(cgi.cont)) do 
             cgi['msg_tarefa'..i] = nil                        
             i = i + 1
         end     
      end                        
      
      cgi.acao      = nil
      cgi.msg_dados = nil
       
   end

-- -------------------------------------------
-- VERIFICA A ACAO A SER EXECUTADA (cgi.acao)
-- -------------------------------------------
if cgi.acao == 'Volta' then
   LimpaCGI()
   cgilua.redirect( '../visualiza.html?'..cgilua.encodetable({tipo_servico = cgi.tipo_servico, cond_filtro = cgi.cond_filtro}) )
   
elseif cgi.acao == 'Obs' then
   cgilua.redirect( '../incl_obs.html?'..cgilua.encodetable({proj_cod = cgi.cod, tipo_servico = cgi.tipo_servico}) )	
   
elseif cgi.acao == 'Atualiza' then
   -- ----------------------------------------------------------------------------------------
   -- OBS: O tratamento das datas de inicio e fim REAL de PROJETO eh efetuado pelo VALIDAFORM
   -- ----------------------------------------------------------------------------------------
   cgi.msg = form_acompanha:critica()
   
   -- ---------------------------------------------------------------------------------
   -- Se ocorreu erro no VALIDAFORM mas as datas e percentuais de atividades ainda nao
   -- foram tratadas, pois esse tratamento eh feito nessa pagina por funcoes LUA
   -- --------------------------------------------------------------------------------- 
   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end

   -- -------------------------------------------------------
   -- Seleciona a DATA DE HOJE no formato AAAAMMDD
   -- -------------------------------------------------------  
   datahoje = date('%Y%m%d') 
     
   -- -------------------------------------------------------
   -- Trata as datas de inicio e fim REAL de PROJETO
   -- ------------------------------------------------------- 
   if temConteudo(cgi.DataInicioReal) and temConteudo(cgi.DataFimReal) and
      ( inclui_data(cgi.DataInicioReal) > inclui_data(cgi.DataFimReal) ) then
      cgi.msg_dt_ini = '<P CLASS=msgErro>Data de Incio Real no pode ser posterior a Data de Trmino Real!</P>'             	      
      flag_erro_proj = 1
      
   elseif temConteudo(cgi.DataInicioReal) and ( inclui_data(cgi.DataInicioReal) > datahoje ) then
      cgi.msg_dt_ini = '<P CLASS=msgErro>Data de Incio Real no pode ser posterior a de hoje!</P>'             	      
      flag_erro_proj = 1
 
   elseif temConteudo(cgi.DataFimReal) and (inclui_data(cgi.DataFimReal) > datahoje) then
      cgi.msg_dt_fim = '<P CLASS=msgErro>Data de Trmino Real no pode ser posteriores a de hoje!</P>'    
      flag_erro_proj = 1
   
   elseif not( temConteudo(cgi.msg) ) then  -- Se as datas estao coerentes salva em PROJETO
      sql_dt_proj = "SELECT proj_dt_ini_real, proj_dt_fim_real FROM projeto WHERE proj_cod = "..cgi.cod
      DBExec(sql_dt_proj)
      dt_proj = DBRow()
      
      if ( cgi.DataInicioReal ) and         
         ( not( temConteudo(dt_proj.proj_dt_ini_real) ) or ( temConteudo(dt_proj.proj_dt_ini_real) and 
         ( inclui_data(cgi.DataInicioReal) ~= dt_proj.proj_dt_ini_real  and temConteudo(dt_proj.proj_dt_ini_real)) ) ) then
         AlteraBD( "projeto", "proj_dt_ini_real = '"..inclui_data(cgi.DataInicioReal).."' ", " proj_cod = "..cgi.cod.." ")                                      
         -- JUSTIFICATIVA para ser gravada em FOLLOW-UP         
         if ( temConteudo(cgi.DataInicioReal) or temConteudo(dt_proj.proj_dt_ini_real) ) then         
            if not ( temConteudo(justificativa) ) then
               justificativa  = 'A Data de Incio Real do Projeto foi atualizada. '
            else
               justificativa  = justificativa .. 'A Data de Incio Real do Projeto foi atualizada. '
            end 
         end           
      end      
      
      if ( cgi.DataFimReal ) and          
         ( not( temConteudo(dt_proj.proj_dt_fim_real) ) or ( temConteudo(dt_proj.proj_dt_fim_real) and 
         ( inclui_data(cgi.DataFimReal) ~= dt_proj.proj_dt_fim_real and temConteudo(dt_proj.proj_dt_fim_real)) ) ) then   
      	if cgi.DataInicioReal then
           AlteraBD( "projeto", "proj_dt_fim_real = '"..inclui_data(cgi.DataFimReal).."' ", " proj_cod = "..cgi.cod.." ")                     
           -- JUSTIFICATIVA para ser gravada em FOLLOW-UP           
           if ( temConteudo(cgi.DataFimReal) or temConteudo(dt_proj.proj_dt_fim_real) ) then
              if not ( temConteudo(justificativa) ) then
                 justificativa  = 'A Data de Fim Real do Projeto foi atualizada. '           
              else
                 justificativa  = 'As Datas de Incio e Fim Real do Projeto foram atualizadas. '             
              end  
           end   
            
        else
           cgi.msg_dt_ini = '<P CLASS=msgErro>A Data de Incio Real deve ser preenchida!</P>'                                            
           flag_erro_proj = 1
        end                   
      end
   end   
   
   if not( temConteudo(cgi.msg) ) then
      -- --------------------------------------
      -- INCLUSAO DOS DADOS DE CUSTO REALIZADO
      -- --------------------------------------
      data_hoje  = inclui_data(strsub(date("%d/%m/%Y"),0,10))
      existe_seq = ConsultaBD2("custo_realizado","*","proj_cod = "..cgi.cod.." AND dt_realizacao = '"..tostring(inclui_data(cgi.data_inclusao)).."'","seq_real DESC")
      seq_atual  = 1
      if existe_seq[1].seq_real then
         seq_atual = existe_seq[1].seq_real + 1
      end
     
      ponto = strfind(cgi.custoatual, ',')
      if ponto then
         cgi.custoatual = gsub(cgi.custoatual,',','.')
      end
   
      if not( temConteudo(cgi.msg) ) and temConteudo(cgi.custoatual) and temConteudo(cgi.data_inclusao) then        
         insert = "INSERT INTO custo_realizado (proj_cod, dt_realizacao, dt_inclusao, valor_real, seq_real) VALUES ("..
                   cgi.cod..",'"..tostring(inclui_data(cgi.data_inclusao)).."','"..tostring(data_hoje).."',"..
                   cgi.custoatual..","..seq_atual..")"        
         DBExec(insert) 
        
         -- JUSTIFICATIVA para ser gravada em FOLLOW-UP       
         if justificativa then           
            justificativa  = justificativa .. 'O Custo Realizado foi atualizado. '         
         else
            justificativa  = 'O Custo Realizado foi atualizado. '         
         end
      end
   end
   
   -- ---------------------------------------------------------------------------------------------------
   -- ATUALIZACAO DAS DATAS DE CUSTO REALIZADO INCOERENTES COM AS DATAS DE INICIO E FIM REAIS DO PROJETO
   -- ---------------------------------------------------------------------------------------------------
   -- ATUALIZACAO DAS DATAS DE ATIVIDADE INCOERENTES COM AS DATAS DE INICIO E FIM REAIS DO PROJETO
   -- ---------------------------------------------------------------------------------------------------
   -- Caso a data de inicio e/ou fim real do projeto sejam alteradas, as datas em CUSTO REALIZADO e em
   -- ATIVIDADE que forem anterior e/ou posterior as datas reais do projeto serao corrigidas no banco pra  
   -- evitar inconsistencias e erros na curva s e na curva fisica
   -- ---------------------------------------------------------------------------------------------------
   if temConteudo( cgi.DataInicioReal ) then
      DBExec(" UPDATE custo_realizado SET dt_realizacao = '".. inclui_data(cgi.DataInicioReal) .."' WHERE proj_cod = "..cgi.cod.." AND dt_realizacao < '".. inclui_data(cgi.DataInicioReal) .."'" )                
      DBExec(" UPDATE atividade SET ativ_dt_ini_real = '".. inclui_data(cgi.DataInicioReal) .."' WHERE proj_cod = "..cgi.cod.." AND ativ_dt_ini_real < '".. inclui_data(cgi.DataInicioReal) .."'" )                
   end      
   if temConteudo( cgi.DataFimReal ) then
      DBExec(" UPDATE custo_realizado SET dt_realizacao = '".. inclui_data(cgi.DataFimReal) .."'WHERE proj_cod = "..cgi.cod.." AND dt_realizacao > '".. inclui_data(cgi.DataFimReal) .."'" )                           
      DBExec(" UPDATE atividade SET ativ_dt_fim_real = '".. inclui_data(cgi.DataFimReal) .."'WHERE proj_cod = "..cgi.cod.." AND ativ_dt_fim_real > '".. inclui_data(cgi.DataFimReal) .."'" )                           
   end     
      
   -- -------------------------------------------------------
   -- Trata as datas de inicio e fim REAL de ATIVIDADE
   -- -------------------------------------------------------    
   if tonumber(cgi.cont) > 1 then
      i = 1
      
      while (i < tonumber(cgi.cont)) do
       
         if temConteudo(cgi['dt_ini_real'..i]) or temConteudo(cgi['dt_fim_real'..i]) then   
            -- Procura por algum caracter diferente de numero nas datas de inicio e fim real da atividade
            dataIni = strfind(inclui_data(cgi['dt_ini_real'..i]), '%D') 
            lenIni  = strlen(inclui_data(cgi['dt_ini_real'..i]))
            dataFim = strfind(inclui_data(cgi['dt_fim_real'..i]), '%D') 
            lenFim  = strlen(inclui_data(cgi['dt_fim_real'..i]))          
                   
            if not( temConteudo(cgi["perc_real"..i]) ) then   
               cgi['msg_perc_real'..i] = '<P CLASS=msgErro><I>A Realizao Fsica deve ser preenchida!</P>'         	
               flag_erro_ativ = 1
            end
                                                  
            if dataIni then
               cgi['msg_dt_ini_real'..i] = '<P CLASS=msgErro>Preencha o campo com uma data no formato "dd/mm/aaaa".</P>'          	        
          
            elseif dataFim then
               cgi['msg_dt_fim_real'..i] = '<P CLASS=msgErro>Preencha o campo com uma data no formato "dd/mm/aaaa".</P>'                 
        
            elseif not dataIni and not dataFim and temConteudo(cgi['dt_ini_real'..i]) and temConteudo(cgi['dt_fim_real'..i]) 
                   and ( inclui_data(cgi['dt_ini_real'..i]) > inclui_data(cgi['dt_fim_real'..i]) ) then          
               cgi['msg_dt_ini_real'..i] = '<P CLASS=msgErro>A Data de Incio Real da atividade no pode ser posterior a Data de Trmino Real da atividade! Altere uma das datas!</P>'    
               flag_erro_ativ = 1 
   
            elseif not dataIni and (inclui_data(cgi['dt_ini_real'..i])) and (inclui_data(cgi['dt_ini_real'..i]) > datahoje) then
               cgi['msg_dt_ini_real'..i] = '<P CLASS=msgErro>A Data de Incio Real no pode ser posterior a data de hoje!</P>'              
               flag_erro_ativ = 1           
   
            elseif not dataIni and not dataFim and (inclui_data(cgi['dt_ini_real'..i])) and 
                   ( inclui_data(cgi['dt_fim_real'..i]) and inclui_data(cgi['dt_fim_real'..i]) > datahoje ) then
               cgi['msg_dt_fim_real'..i] = '<P CLASS=msgErro><I>A Data de Fim Real no pode ser posterior a data de hoje!</P>'    
               flag_erro_ativ = 1 
             
            elseif not dataIni and not dataFim and (inclui_data(cgi['dt_fim_real'..i])) and
                   not ( cgi['dt_ini_real'..i] and cgi['dt_ini_real'..i] ~= '' ) then
               cgi['msg_dt_ini_real'..i] = '<P CLASS=msgErro><I>A Data de Incio Real deve ser preenchida!</P>'    
               flag_erro_ativ = 1
               
            elseif not dataIni and not dataFim and temConteudo(cgi['dt_ini_real'..i]) 
                   and not temConteudo(cgi.DataInicioReal) then
               cgi['msg_dt_ini_real'..i] = '<P CLASS = msgErro><I>A Data de Incio Real do Projeto deve ser preenchida!</P>'
               flag_erro_ativ = 1
               
            elseif not dataIni and ( temConteudo( inclui_data(cgi['dt_ini_real'..i]) ) ) and ( temConteudo(inclui_data(cgi.DataInicioReal)) )
                   and ( inclui_data(cgi['dt_ini_real'..i]) < inclui_data(cgi.DataInicioReal) ) then
               cgi['msg_dt_ini_real'..i] = '<P CLASS = msgErro><I>A Data de Incio Real da Atividade deve ser igual ou posterior a data de Incio do Projeto!</P>'
               flag_erro_ativ = 1
               
            elseif not dataIni and ( temConteudo(inclui_data(cgi.DataFimReal) ) ) and ( temConteudo( inclui_data(cgi['dt_ini_real'..i]) ) )
                   and ( inclui_data(cgi['dt_ini_real'..i]) > inclui_data(cgi.DataFimReal) ) then
               cgi['msg_dt_ini_real'..i] = '<P CLASS = msgErro><I>A Data de Incio Real da Atividade deve ser anterior ou igual a data de Fim do Projeto!</P>'
               flag_erro_ativ = 1
            
            elseif not dataFim and (temConteudo(inclui_data(cgi['dt_fim_real'..i]))) and temConteudo(inclui_data(cgi.DataFimReal))
                   and ( inclui_data(cgi['dt_fim_real'..i]) > inclui_data(cgi.DataFimReal) ) then
               cgi['msg_dt_fim_real'..i] = '<P CLASS = msgErro><I>A Data de Fim Real da Atividade deve ser igual ou anterior a data de Fim do Projeto!</P>'
               flag_erro_ativ = 1
          
            elseif not( temConteudo(cgi.msg) ) then -- se as datas e o percentual estao coerentes salva em ATIVIDADES
               -- ------------------------------------------------------------------------------------------------
               -- Se a atividade eh atualizada com SUCESSO o flag para o calculo do percentual eh entao levantado
               -- ------------------------------------------------------------------------------------------------
                  flag_calcula_perc = 1
               -- data inicial, data final e percentual realizado
               if (cgi['dt_ini_real'..i]) and (cgi['dt_fim_real'..i]) and (cgi["perc_real"..i]) then                  
                  ativ = ConsultaBD("atividade", " ativ_nome, ativ_perc_real, ativ_peso_rel_proj, ativ_dt_ini_real, ativ_dt_fim_real ","ativ_cod = "..cgi['ativ_cod'..i].." AND proj_cod = "..cgi.cod.." ", nil )                                   
                  -- -------------------------------------------------------------------------------------------
                  -- Faz um tratamento do tamanho do nome da atividade para evitar que nomes muito longos sejam 
                  -- gravados em follow_up
                  -- Se o tamanho da string ultrapassa 50, se existirem mais de 40, a partir do caracter 41, os
                  -- demais sao omitidos e substituidos por '...' (toma-se o cuidado de que uma palavra nao
                  -- seja quebrada ao meio - variavel VAZIO)
                  -- -------------------------------------------------------------------------------------------
                  len_ativ_nome = strlen(ativ.ativ_nome)
                  if len_ativ_nome > 50 then
                     vazio = strfind(ativ.ativ_nome,' ',41)
                     if vazio then
                        ativ_nome = strsub(ativ.ativ_nome,1,vazio-1)
                        continua  = strsub(ativ.ativ_nome,vazio)   
                     else
                        ativ_nome = ativ.ativ_nome                          
                     end                  
                     if temConteudo( continua ) then
                        ativ.ativ_nome = ativ_nome..'...'
                     else   
                        ativ.ativ_nome = ativ_nome
                     end                    
                  end
                  
                  -- percentual de REALIZACAO da atividade em funcao do total do PROJETO                 
                  perc = ativ.ativ_perc_real
                  peso = ativ.ativ_peso_rel_proj
                  
                  if cgi["perc_real"..i] == '' then
                     cgi["perc_real"..i] = 0
                  end
                  if cgi['dt_ini_real'..i] == '' then
                     cgi["perc_real"..i] = 0
                     cgi['dt_fim_real'..i] = ''
                  end   
                  -- verifica se houve modificacao no percentual de REALIZACAO da atividade
                  -- converte o percentual atraves da formula (CGI.perc_real/100)*peso
                  perc_real_fisica = (val(cgi["perc_real"..i])/100 * peso)             
                  porcentagem = tostring(tonumber(cgi["perc_real"..i])/100 * tonumber(cgi["peso_rel_proj"..i]))               
                  
                  if porcentagem ~= '0' and temConteudo(cgi['dt_ini_real'..i]) and temConteudo(cgi['dt_fim_real'..i]) then
                     AlteraBD( "atividade", "ativ_dt_ini_real = '"..inclui_data(cgi['dt_ini_real'..i]).."', ativ_dt_fim_real = '"..
                                inclui_data(cgi['dt_fim_real'..i]).."',ativ_perc_real = "..format("%.2f",porcentagem)..
                                "" , "proj_cod = "..cgi.cod.." AND ativ_cod="..cgi['ativ_cod'..i].."")                  
                     -- -------------------------------------------------------------------------------------------
                     -- Soh grava o historico se a atividade for alterada
                     -- -------------------------------------------------------------------------------------------                    
                     if (cgi['ativ_cod'..i] and cgi["perc_real"..i]) and ( formata_valor(perc) ~= formata_valor(perc_real_fisica) ) then
                         gravaHistorico(cgi.cod,cgi['ativ_cod'..i],cgi["perc_real"..i])
                         flag_gravaHistorico = 1
                     end
                                                                                           
                     -- JUSTIFICATIVA para ser gravada em FOLLOW-UP                                        
                     if ( inclui_data(cgi['dt_ini_real'..i]) ~= ativ.ativ_dt_ini_real ) and
                        ( inclui_data(cgi['dt_fim_real'..i]) ~= ativ.ativ_dt_fim_real ) then         
                         mensagem_ativ = 'A Realizao Fsica e as datas de Incio e Fim Real da Atividade <b>'..ativ.ativ_nome..'</b> foram atualizadas. '                      
                     elseif ( inclui_data(cgi['dt_ini_real'..i]) == ativ.ativ_dt_ini_real ) and
                            ( inclui_data(cgi['dt_fim_real'..i]) ~= ativ.ativ_dt_fim_real ) then         
                         mensagem_ativ = 'A Realizao Fsica e a data de Fim Real da Atividade <b>'..ativ.ativ_nome..'</b> foram atualizadas. '                       
                     elseif flag_gravaHistorico == 1 then
                         mensagem_ativ = 'A Realizao Fsica da Atividade <b>'..ativ.ativ_nome..'</b> foi atualizada. '                                                               	 
                     end                      
                     if not( temConteudo(justificativa) ) then 
                        justificativa = mensagem_ativ                      
                     elseif not( strfind(justificativa,mensagem_ativ) ) then
                        justificativa = justificativa .. mensagem_ativ
                     end                          
                                                                             
                  elseif porcentagem ~= '0' and temConteudo(cgi['dt_ini_real'..i]) then                   
                     AlteraBD( "atividade", "ativ_dt_ini_real = '"..inclui_data(cgi['dt_ini_real'..i]).."', ativ_dt_fim_real = '', ativ_perc_real = "..format("%.2f",porcentagem).."" , "proj_cod = "..cgi.cod.." AND ativ_cod="..cgi['ativ_cod'..i].."")
                     -- -------------------------------------------------------------------------------------------
                     -- Soh grava o historico se a atividade for alterada
                     -- -------------------------------------------------------------------------------------------
                     if (cgi['ativ_cod'..i] and cgi["perc_real"..i]) and ( formata_valor(perc) ~= formata_valor(perc_real_fisica) ) then
                        gravaHistorico(cgi.cod,cgi['ativ_cod'..i],cgi["perc_real"..i])
                        flag_gravaHistorico = 1
                     end 
                   
                     -- JUSTIFICATIVA para ser gravada em FOLLOW-UP
                     if (inclui_data(cgi['dt_ini_real'..i]) ~= ativ.ativ_dt_ini_real) and ( formata_valor(porcentagem) ~= formata_valor(perc) ) then 
                        if temConteudo(ativ.ativ_dt_fim_real) then
                           mensagem_ativ = 'A Realizao Fsica e as datas de Incio e Fim Real da Atividade <b>'..ativ.ativ_nome..'</b> foram atualizadas. '
                        else
                           mensagem_ativ = 'A Realizao Fsica e a data de Incio Real da Atividade <b>'..ativ.ativ_nome..'</b> foram atualizadas. '
                        end   
                     elseif (inclui_data(cgi['dt_ini_real'..i])  ~= ativ.ativ_dt_ini_real) then    
                        if temConteudo(ativ.ativ_dt_fim_real) then
                           mensagem_ativ = 'As datas de Incio e Fim Real da Atividade <b>'..ativ.ativ_nome..'</b> foram atualizadas. '
                        else
                           mensagem_ativ = 'A data de Incio Real da Atividade <b>'..ativ.ativ_nome..'</b> foi atualizada. '
                        end                      
                     elseif flag_gravaHistorico == 1 then
                        if temConteudo(ativ.ativ_dt_fim_real) then
                           mensagem_ativ = 'A Realizao Fsica e a data de Fim Real da Atividade <b>'..ativ.ativ_nome..'</b> foram atualizadas. ' 
                        else
                           mensagem_ativ = 'A Realizao Fsica da Atividade <b>'..ativ.ativ_nome..'</b> foi atualizada. ' 
                        end                                                              
                     elseif temConteudo(ativ.ativ_dt_fim_real) then
                        mensagem_ativ = 'A data de Fim Real da Atividade <b>'..ativ.ativ_nome..'</b> foi deletada. '                                                            
                     end                                                                                
                     if not( temConteudo(justificativa) ) then 
                        justificativa = mensagem_ativ                      
                     elseif not( strfind(justificativa,mensagem_ativ) ) then
                        justificativa = justificativa .. mensagem_ativ
                     end  
                    
                  end -- if porcentagem ~= '0' and temConteudo(cgi['dt_ini_real'..i]) and temConteudo(cgi['dt_fim_real'..i])
               end -- if (cgi['dt_ini_real'..i]) and (cgi['dt_fim_real'..i]) and (cgi["perc_real"..i])        
            end -- if das validaes   
      
         -- ------------------------------------------------------------------------------------------------------
         -- "se no existem datas" -> if temConteudo(cgi['dt_ini_real'..i]) or temConteudo(cgi['dt_fim_real'..i])   
         -- ------------------------------------------------------------------------------------------------------
         elseif not( temConteudo(cgi.msg) ) then 
            ativ = ConsultaBD("atividade", "ativ_dt_ini_real, ativ_dt_fim_real, ativ_cod, ativ_nome ","ativ_cod = "..cgi['ativ_cod'..i].." AND proj_cod = "..cgi.cod.." ", nil )    
            if temConteudo(ativ.ativ_dt_ini_real) or temConteudo(ativ.ativ_dt_fim_real) then
               AlteraBD( "atividade", "ativ_dt_ini_real = '', ativ_dt_fim_real = '', ativ_perc_real = '' ", " proj_cod = "..cgi.cod.." AND ativ_cod = "..ativ.ativ_cod.." ")                  
            
               -- JUSTIFICATIVA para ser gravada em FOLLOW-UP
               mensagem_ativ = 'As informaes referentes a Realizao Fsica e as datas de Incio e Fim Real da Atividade <b>'..ativ.ativ_nome..'</b> foram deletadas. '
               if not( temConteudo(justificativa) ) then 
                  justificativa = mensagem_ativ                      
               elseif not( strfind(justificativa,mensagem_ativ) ) then
                  justificativa = justificativa .. mensagem_ativ
               end   
            end            
         end -- if "se existem datas"                  
   
         i = i + 1 
         flag_calcula_perc = 0  
         flag_gravaHistorico = 0         
                
      end -- WHILE 
      
      -- --------------------------------------------------------------------------------------------
      -- SE ocorreram erros quando se tentava gravar alguma atividade (datas ou percentual) entao
      -- o erro eh redirecionado para o usuario.
      -- --------------------------------------------------------------------------------------------      
      if flag_erro_ativ == 1 or flag_erro_proj == 1 or cgi.msg then
         if not(cgi.msg) then
            cgi.msg_topo = 'O formulrio foi preenchido incorretamente. Siga as instrues junto aos campos que devem ser revistos.'	
         end
         LimpaCGI()   
         cgilua.redirect('../exibe_dados_projeto.html?'..cgilua.encodecgi()) -- VOLTA PARA A PGINA html
      end     	

   end -- if tonumber(cgi.cont) > 1 
  
   DBExec("SELECT proj_nome FROM projeto WHERE proj_cod = "..cgi.cod)
   temp = DBRow()
    
   -- Soh grava JUSTIFICATIVA se algum valor foi gravado no banco de dados 
   if temConteudo(justificativa) then
      if not( temConteudo(cgi.msg) ) and cgi.msg_topo == '' then
         -- ---------------------------------------------------------------------------------------         
         -- Atualizao da tabela de FOLLOW_UP quando so gravadas alteraes no projeto pela 
         -- funo de ACOMPANHAMENTO
         -- ---------------------------------------------------------------------------------------                                       
            atualizaFollowUp(cgi.cod,1,justificativa)
           
         -- ---------------------------------------------------------------------------------------         
         -- Atualizao do campo PROJ_DESEMPENHO na tabela PROJETO quando so gravadas alteraes
         -- no projeto pela funo de ACOMPANHAMENTO (ativ_perc_real)
         -- ---------------------------------------------------------------------------------------                                                  
            atualizaProjDesempenho(cgi.cod)                 
      
         msgsuc = "O Projeto <b>"..temp.proj_nome.."</b> foi alterado com sucesso!"
      end      
   else
      msgerro = "Nenhuma alterao foi efetuada no projeto <b>"..temp.proj_nome.."</b>!"
   end   
    
   if ESTADO_BD == 'aberto' then
      FechaBD()
   end
     
   LimpaCGI()   

   cgilua.redirect('../exibe_dados_projeto.html?'..cgilua.encodetable( { tipo_servico = cgi.tipo_servico, cond_filtro = cgi.cond_filtro, cod = cgi.cod, msgsuc = msgsuc, msgerro = msgerro})) -- VOLTA PARA A PAGINA de visualizacao

end  -- if cgi.acao