-- -------------------------------------------------------------------------------------------
-- ATIVIDADES.LUA
-- -------------------------------------------------------------------------------------------
   assert(dofile( "global.lua" ))
   assert(dofile( "func_atualiza_proj_dt_prev_ativ.lua" ))

-- -------------------------------------------------------------------------------------------
-- Verifica se foi digitada alguma data em formato invlido ( ~= DD/MM/AAAA )
-- Utiliza a varivel ERRO_DATA para fazer o controle
-- Se um dos formatos for invlido, no faz as verificaes dos campos de data
-- -------------------------------------------------------------------------------------------  
   dt_ini     = tonumber(inclui_data(cgi.dt_ini_prevista_ativ))
   dt_fim     = tonumber(inclui_data(cgi.dt_fim_prevista_ativ))
   erro_data  = 'no'   
      
-- --------------------------------------------------------------------------------------------
-- Eh inicializada com zero indicando que nenhuma alteracao foi efetuada, seu valor passa para 
-- '1' quando a atividade eh alterada.
-- Dessa forma se faz o controle da atualizacao da tabela de FOLLOW-UP ( se o flag for 1 
-- indica que a atividade foi ALTERADA, se for 0 indica que ou ocorreu algum erro ou que uma
-- nova atividade foi inserida.
-- --------------------------------------------------------------------------------------------   
   flag_update   = 0
   
   if type(dt_ini) ~= 'number' or type(dt_fim) ~= 'number'then
   	  erro_data = 'yes'
   end


   if not cgi.proj_dt_fim_prev then
      cgi.proj_dt_fim_prev = ""
   end

-- --------------------------------------------------------------------------------------------
-- Calcula novo percentual realizado para projetos revisados que tenham o peso das suas 
-- atividades alterados
-- --------------------------------------------------------------------------------------------
function verifica_ativ_perc_real(perc_real,peso_rel,novo_peso)
   novo_perc = ''
   if perc_real and peso_rel ~= novo_peso then
      novo_perc = (perc_real*novo_peso)/peso_rel
      return ', ativ_perc_real = '..novo_perc
   else
      return novo_perc
   end
end

-- -------------------------------------------------------------------------------------------
-- Faz a diferena entre as datas de trmino e incio no formato dd/mm/aaaa se essas datas
-- existirem
-- DiasEntre() (GLOBAL.LUA) retorna o numero de dias entre as datas passadas, e nao a 
-- diferenca entre elas, por isso eh que limite_alerta recebe DiasEntre() - 1
-- -------------------------------------------------------------------------------------------  
   function alerta()
      limite_alerta = 0      
      if erro_data == 'no' and temConteudo(cgi.dt_fim_prevista_ativ) and temConteudo(cgi.dt_ini_prevista_ativ) then    
         limite_alerta = DiasEntre(cgi.dt_ini_prevista_ativ, cgi.dt_fim_prevista_ativ) - 1                             
      end
      if tonumber(cgi.alerta) > limite_alerta and limite_alerta > 0 then
         return 'Preencha o campo com um nmero inteiro menor ou igual ao nmero de dias previstos para a atividade, ou seja, (Data de Trmino Previsto - Data de Incio Previsto).'
      else
         return nil
      end      
   end     

-- ---------------------------------------------------------------------------------------------
-- Funes internas para validao do formulrio de atividades
-- [ limpaCampos() e verifica_peso() ]
-- ---------------------------------------------------------------------------------------------
   function limpaCampos()
        cgi.descricao_ativ       = nil
        cgi.dt_ini_prevista_ativ = nil
        cgi.dt_fim_prevista_ativ = nil
        cgi.alerta               = nil
        cgi.peso                 = nil   
        cgi.ativ_cod             = nil
        cgi.areas                = nil
        cgi.dep_descr            = nil
        cgi.ativ_default         = nil
   end   

   function verifica_peso()      
        sql1 = "SELECT SUM(ativ_peso_rel_proj) as valor FROM atividade WHERE proj_cod = "..cgi.proj_cod
        DBExec(sql1)
        tmp = DBRow()
        if tmp.valor ~= null then
           tmp = tmp.valor + tonumber(cgi.peso)
        else
           tmp = tonumber(cgi.peso)        
        end
        
        -- ---------------------------------------------------------------------------------------------
        -- Verifica se o somatrio dos pesos no  maior que 100
        -- ---------------------------------------------------------------------------------------------
        if cgi.peso_antigo then
           tmp = tmp - tonumber(cgi.peso_antigo)
        end
        if tmp > 100 then
           msg_temp = 'O somatrio dos pesos das atividades no pode ser maior que 100.'	
        else
           msg_temp = nil
        end
        return msg_temp   
   end

-- -----------------------------------------------
-- Altera a data de termino previsto do projeto --
-- -----------------------------------------------
   function AtualizaDataPrev(proj, data)
      local data_ini, dados, i, j, tab
      AlteraBD( "projeto", "proj_dt_fim_prev = '"..data.."'", "proj_cod = "..proj ) 

      ------------------------------------------------
      --Altera o custo para o ano na tabela de custo--
      ------------------------------------------------
      dados = ConsultaBD2("custo","*","proj_cod = "..proj.."","custo_ano")
      i=1
      while dados[i] and dados[i].custo_ano do
      	 if tonumber(dados[i].custo_ano) > tonumber(strsub(data,1,4)) then
      	    AlteraBD("custo","custo_prev_ano = 0","custo_cod = "..dados[i].custo_cod.." AND proj_cod = "..proj.."")
      	 end
         i = i + 1
      end

      ---------------------------------------------------------
      --Remove o custo para o ano na tabela de custo_previsto--
      ---------------------------------------------------------
      sql="select year(dt_prevista) as data from custo_previsto where proj_cod = "..proj.." "
      DBExec(sql)
      tmp = DBRow()
      if tmp then
         j = 1
         tab = {}
         while tmp do
            tab[j] = tmp
            j = j + 1
            tmp = DBRow()
         end

         j=1
         while tab[j] do
            if tab[j].data > tonumber(strsub(data,1,4)) then
               ApagaBD("custo_previsto","year(dt_prevista) = "..tab[j].data.." AND proj_cod = "..proj.."")
            end
            j = j + 1
         end

      end


      ------------------------------------------------
      --Remove o custo para o ano na tabela de custo_realizado--
      ------------------------------------------------
      custo_real = ConsultaBD2("custo_realizado","year(dt_realizacao) as data","proj_cod = "..proj.." ","dt_realizacao")
      if custo_real then
         j=1
         while custo_real[j] and custo_real[j].data do
            if custo_real[j].data > tonumber(strsub(data,1,4)) then
               ApagaBD("custo_realizado","year(dt_realizacao) = "..custo_real[j].data.." AND proj_cod = "..proj.."")
            end
         
            j = j + 1
         end
      end
      return dados
   end


-- ----------------------------------------------------------------------------------------------
-- Verifica qual opo foi selecionada no arquivo de edio de atividades
-- [ 'Grava' ou 'Limpa Campos' ]
-- ----------------------------------------------------------------------------------------------   
if cgi.botao == 'Limpa' then
   limpaCampos()
   
-- ---------------------------------------------------------------------------------------------
-- VOLTA PARA A PGINA html carregando os valores de proj_ccod, tipo_servio e tipo_edi
-- ---------------------------------------------------------------------------------------------    
   cgilua.redirect('../atividades.html?'..cgilua.encodetable({proj_cod=cgi.proj_cod, tipo_servico=cgi.tipo_servico, tipo_edi=cgi.tipo_edi, cond_filtro=cgi.cond_filtro, revisao=cgi.revisao}))

elseif cgi.botao == 'Grava' then


  -- ---------------------------------------------------------------------------------------------	
  -- CARREGA A BIBLIOTECA VALIDAFORM 
  -- ---------------------------------------------------------------------------------------------
     assert(dofile("constantes.lua"))
     assert(dofile("../validaform/validaform.lua"))
     assert(dofile("form_atividades.lua"))
     assert(dofile( "acessabd.lua" ))
   
     if ESTADO_BD ~= 'aberto' then
        AbreBD()
     end

  -- ---------------------------------------------------------------------------------------------	
  -- ---------------------------------------------------------------------------------------------	
  -- Faz a validao do formulrio com o FORM_ATIVIDADES.LUA
  -- ---------------------------------------------------------------------------------------------
  -- ---------------------------------------------------------------------------------------------	
     cgi.msg = form_atividades:critica()   
 


   dt_proj = tonumber(inclui_data(cgi.proj_dt_fim_prev))
   dt_proj_old = tonumber(inclui_data(cgi.proj_dt_fim_prev_old))

   if not cgi.msg_proj_dt_fim_prev and dt_proj and dt_proj ~= dt_proj_old then
      custo = AtualizaDataPrev(cgi.proj_cod, dt_proj)
      --Verifica se novo ano esta entre 01/04/2000 e 31/12/2003, --
      --se tiver deve-se incluir custo previsto para o mesmo
      custo_prev = ConsultaBD2("custo_previsto","*","proj_cod = "..cgi.proj_cod.." ")
      dt_fim_proj = ConsultaBD2("projeto", "proj_dt_ini_prev", "proj_cod = "..cgi.proj_cod.."")
      cgi.dt_fim_prevista = cgi.proj_dt_fim_prev
      cgi.dt_ini_prevista = formataData(dt_fim_proj[1].proj_dt_ini_prev)
      local i = 1
      while custo[i] and custo[i].custo_ano do
         if custo[i].proj_cod and (tonumber(custo[i].custo_prev_ano) == 0 or not custo[i].custo_prev_ano) then
            if custo_prev[1] and custo_prev[1].proj_cod then
               red_custo = 1
            elseif tonumber(strsub(dt_proj,1,4)) >= tonumber(custo[i].custo_ano) then
               if not cgi.ano_ini then
                  cgi.ano_ini= custo[i].custo_ano
                  cgi.ano_fim= custo[i].custo_ano
               else
                  cgi.ano_fim= custo[i].custo_ano
               end
               red_custo = 2
            end
         end
         i = i + 1
      end
      if erro_data == 'yes' then
         cgi.msg = nil
         cgi.msg_descricao_ativ = nil
         cgi.msg_dt_ini_prevista_ativ = nil
         cgi.msg_dt_fim_prevista_ativ = nil
         cgi.msg_alerta = nil
         cgi.msg_peso = nil
         cgi.form_rev = nil --Se este flag for igual a 1 o botao de "formalizar" nao aparece.

         if ESTADO_BD == 'aberto' then
            FechaBD()
         end

         if red_custo and red_custo==1 then
         	  cgi.atividades=1
            cgilua.redirect('../custo_previsto.html?'.. cgilua.encodecgi())
         elseif red_custo and red_custo==2 then
            cgilua.redirect('../incl_custo_proj.html?'.. cgilua.encodecgi())
         else
            cgilua.redirect('../atividades.html?'.. cgilua.encodecgi())
         end
         exit()
      end
   end


  -- ---------------------------------------------------------------------------------------------	
  -- ---------------------------------------------------------------------------------------------	
  -- Complementa a validao do formulrio com o ATIVIDADES.LUA
  -- ---------------------------------------------------------------------------------------------
  -- ---------------------------------------------------------------------------------------------	
          
  -- ---------------------------------------------------------------------------------------------
  -- S verifica o PESO se o campo foi preenchido
  -- ---------------------------------------------------------------------------------------------
     if temConteudo(cgi.peso) and not temConteudo(cgi.msg ) then
        cgi.msg_tmp = verifica_peso()
        if temConteudo(cgi.msg_tmp) then
           cgi.msg = 'O formulrio foi preenchido incorretamente. Siga as instrues junto aos campos que devem ser revistos.'
        end   
     end   

  -- ---------------------------------------------------------------------------------------------
  -- Verifica o campo ALERTA
  -- ---------------------------------------------------------------------------------------------
     if temConteudo(cgi.alerta) and not temConteudo(cgi.msg) then        
        cgi.msg_alerta = alerta()
        if temConteudo(cgi.msg_alerta) then
           cgi.msg = 'O formulrio foi preenchido incorretamente. Siga as instrues junto aos campos que devem ser revistos.'
        end   
     end
       
  -- ---------------------------------------------------------------------------------------------
  -- S verifica as datas se os dois campos foram preenchidos no formato DD/MM/AAAA
  -- ---------------------------------------------------------------------------------------------
     if erro_data == 'no' and not temConteudo(cgi.msg) then          
        data1 = strsub(cgi.dt_ini_prevista_ativ,7)..strsub(cgi.dt_ini_prevista_ativ,4,5)..strsub(cgi.dt_ini_prevista_ativ,1,2)
        data2 = strsub(cgi.dt_fim_prevista_ativ,7)..strsub(cgi.dt_fim_prevista_ativ,4,5)..strsub(cgi.dt_fim_prevista_ativ,1,2)              
             
        sql_result = "select proj_dt_ini_prev, proj_dt_fim_prev from projeto where proj_cod = "..cgi.proj_cod
        DBExec(sql_result)
        result = DBRow()        
     
        data3 = inclui_data(result.proj_dt_ini_prev)
        data4 = inclui_data(result.proj_dt_fim_prev)        

        -- -------------------------------------------------------------------------------------------- 
        -- As criticas das datas previstas e reais das atividades em relacao as datas previstas e 
        -- reais do projeto estao sendo feitas apenas na pagina de exibicao, o usuario passou a ser 
        -- apenas avisado da situacao, o bloqueio eh feito somente na formalizacao para evitar que o
        -- usuario fique preso entre as paginas de projeto e atividade por causa das datas
        -- BLOQUEIO: forcar com que se tenha pelo menos uma atividade com data de inicio 
        -- prevista igual a data de inicio prevista do projeto e uma atividade com data de fim 
        -- prevista igual a data de fim prevista do projeto.
        -- -------------------------------------------------------------------------------------------- 
              	          	    
        if (tonumber (data1) < tonumber(data3) or tonumber(data1) > tonumber(data4)) 
            or (tonumber(data2) < tonumber(data3) or tonumber(data2) > tonumber(data4)) then 
            cgi.msg = 'O formulrio foi preenchido incorretamente. Siga as instrues junto aos campos que devem ser revistos.'   
            cgi.msg_data = 'As Datas Previstas para a Atividade devem estar entre '..formataData(result.proj_dt_ini_prev)..' e '..formataData(result.proj_dt_fim_prev)..', que correspondem as datas de incio e fim previsto do Projeto.'  
            erro_data = 'yes'
        elseif tonumber(data1) > tonumber(data2) then
            cgi.msg = 'O formulrio foi preenchido incorretamente. Siga as instrues junto aos campos que devem ser revistos.'   
            cgi.msg_data = 'A Data de Incio Previsto no pode ser maior que a Data de Fim Previsto.'
            erro_data = 'yes'       
        end         
     end -- if erro_data == 'no' and not temConteudo(cgi.msg) then  
     
     -- ---------------------------------------------------------------------------------------------		      
     -- Verifica se  atualizao
     -- ---------------------------------------------------------------------------------------------	
     if cgi.ativ_cod then 
   	    cgi.descricao_ativ = forca_plic(cgi.descricao_ativ)        
        sql_verifica = "select ativ_cod, ativ_peso_rel_proj, ativ_perc_real from atividade where ativ_nome = '"..cgi.descricao_ativ.."' AND proj_cod = "..cgi.proj_cod
        DBExec(sql_verifica)
        verifica = DBRow()
        -- ---------------------------------------------------------------------------------------------	
        -- Verifica se o nome da atividade foi alterado
        -- ---------------------------------------------------------------------------------------------	
        if verifica then
           -- ---------------------------------------------------------------------------------------------	
           -- Verifica se o novo nome existe para outra atividade
           -- ---------------------------------------------------------------------------------------------	
           if verifica.ativ_cod ~= tonumber(cgi.ativ_cod) then
       	      cgi.msg_verifica     ="Esta atividade j existe"  
       	      cgi.msg_verificadesc ="Fornea uma descrio que ainda no tenha sido cadastrada"
           else
              cgi.descricao_ativ = forca_plic(cgi.descricao_ativ)
              -- ---------------------------------------------------------------------------------------------	
              -- S faz a atualizao no banco de dados se no houver problemas com os formatos das datas
              -- ---------------------------------------------------------------------------------------------	
              if erro_data == 'no' and not temConteudo(cgi.msg) then
        	       novo_perc_rel = verifica_ativ_perc_real(verifica.ativ_perc_real,verifica.ativ_peso_rel_proj,tonumber(cgi.peso))        
                 sql = "UPDATE atividade SET proj_cod="..cgi.proj_cod..",ativ_nome='"..cgi.descricao_ativ.."', ativ_dt_ini_prev='"..data1.."', ativ_dt_fim_prev='"..data2.."',ativ_peso_rel_proj='"..cgi.peso.."',ativ_alerta='"..cgi.alerta.."' "..novo_perc_rel.." where ativ_cod = "..cgi.ativ_cod
                 flag_update = 1                
              end   
           end              
        else
           sql_verifica2 = "select ativ_cod, ativ_peso_rel_proj, ativ_perc_real from atividade where ativ_cod = '"..cgi.ativ_cod.."' AND proj_cod = "..cgi.proj_cod
           print(sql_verifica2) exit()
           DBExec(sql_verifica2)
           verifica2 = DBRow()           
        	 novo_perc_rel = verifica_ativ_perc_real(verifica2.ativ_perc_real,verifica2.ativ_peso_rel_proj,tonumber(cgi.peso))
           cgi.descricao_ativ = forca_plic(cgi.descricao_ativ)           
           sql = "UPDATE atividade SET proj_cod="..cgi.proj_cod..",ativ_nome='"..cgi.descricao_ativ.."', ativ_dt_ini_prev='"..data1.."', ativ_dt_fim_prev='"..data2.."',ativ_peso_rel_proj="..cgi.peso..",ativ_alerta="..cgi.alerta.." "..novo_perc_rel.." where ativ_cod = "..cgi.ativ_cod
           flag_update = 1
        end
        
     else  -- No  atualizao
        -- ---------------------------------------------------------------------------------------------	
        -- Verifica se a atividade j existe
        -- ---------------------------------------------------------------------------------------------	
        sql_verifica = "select * from atividade where ativ_nome = '"..cgi.descricao_ativ.."' AND proj_cod = "..cgi.proj_cod
        DBExec(sql_verifica)
        verifica = DBRow()
        if verifica and verifica.ativ_nome then
           cgi.msg_verifica      ="Esta atividade j existe."
           cgi.msg_verifica_desc ="Fornea uma descrio que ainda no tenha sido cadastrada."
        else
           cgi.descricao_ativ = forca_plic(cgi.descricao_ativ)           	   
           -- ---------------------------------------------------------------------------------------------	
           -- S faz a atualizao no banco de dados se no houver problemas com os formatos das datas
           -- ---------------------------------------------------------------------------------------------	
           if erro_data == 'no' and not temConteudo(cgi.msg) then        
              sql  = "INSERT INTO atividade (proj_cod,ativ_nome, ativ_dt_ini_prev, ativ_dt_fim_prev,ativ_peso_rel_proj,ativ_alerta) "..
                     "values ("..cgi.proj_cod..",'"..cgi.descricao_ativ.."','"..data1.."','"..data2.."','"..cgi.peso.."','"..cgi.alerta.."')"
                
           end   
        end    
     end 
     
  if cgi.msg or cgi.msg_verifica or cgi.msg_tmp or cgi.msg_data then
     cgi.voltou = 1     
     -- ---------------------------------------------------------------------------------------------
     -- VOLTA PARA A PGINA html
     -- ---------------------------------------------------------------------------------------------
     if ESTADO_BD == 'aberto' then
        FechaBD()
     end
     cgilua.redirect('../atividades.html?'.. cgilua.encodecgi())    
     exit()  -- Evita que o restante do cdigo seja executado
  end                   
	       	
  if sql then
     DBExec(sql)
     -- ---------------------------------------------------------------------------------------------
     -- Mantm a consistncia do campo proj_soma_ativ da tabela projeto
     -- ---------------------------------------------------------------------------------------------        
     DBExec([[UPDATE projeto
              SET projeto.proj_soma_ativ = (select sum(atividade.ativ_peso_rel_proj) from atividade 
                                            where atividade.proj_cod = ]]..cgi.proj_cod..[[)
              FROM projeto, atividade
              WHERE projeto.proj_cod = ]]..cgi.proj_cod)
     
     -- ---------------------------------------------------------------------------------------         
     -- Atualizao do campo PROJ_DESEMPENHO na tabela PROJETO quando so gravadas alteraes
     -- no projeto pela funo de CADASTRO/EDICAO DE ATIVIDADES
     -- ---------------------------------------------------------------------------------------                                                  
        atualizaProjDesempenho(cgi.proj_cod)  
                
     -- -------------------------------------------------------------------------------------------- 
     -- Atualizar o FLAG referente as datas previstas e reais das atividades em relacao as datas 
     -- previstas e reais do projeto (proj_dt_prev_ativ - tabela PROJETO): forcar com que se tenha 
     -- pelo menos uma atividade com data de inicio prevista igual a data de inicio prevista do 
     -- projeto e uma atividade com data de fim prevista igual a data de fim prevista do projeto.
     -- --------------------------------------------------------------------------------------------           
        atualizaDatasPrevistas(cgi.proj_cod) 
             
     -- ---------------------------------------------------------------------------------------------
     -- Se a atividade acabou de ser criada (flag_update == 0) recupera o valor de ativ_cod
     -- ---------------------------------------------------------------------------------------------        
     if flag_update == 0 then
     	ativ_query = " SELECT ativ_cod AS cod FROM atividade WHERE proj_cod = "..cgi.proj_cod.." AND ativ_nome = '"..cgi.descricao_ativ.."'"
     	DBExec(ativ_query)
     	ativ_cod = DBRow()
     	ativ_cod = ativ_cod.cod    
     end 	
          
     -- INSERO DE UMA DEPENDNCIA
     if not cgi.dep_descr then
        cgi.dep_descr = ''
     else
        cgi.dep_descr = forca_plic(cgi.dep_descr)   
     end    

     -- ---------------------------------------------------------------------------------------                                       
     -- SE FOR ATUALIZAO DE DADOS NA ATIVIDADE, NO INSERE NADA NA TABELA DE DEPENDENCIA
     -- ---------------------------------------------------------------------------------------                                           
     -- Insere dependencia pela primeira vez
     -- ---------------------------------------------------------------------------------------                                           
        if ativ_cod and cgi.areas and cgi.areas ~= '' then
           campos  = "dep_proj_cod, dep_ativ_cod, dep_area_cod, dep_descr"
           valores =  cgi.proj_cod..", "..ativ_cod..", "..cgi.areas                 
           if cgi.dep_descr ~= '' then 	              
              valores = valores..", '"..cgi.dep_descr.."'"
           else
              valores = valores..", ''"                          
           end
           inclusao_dependencia = "INSERT INTO dependencia ("..campos..") VALUES ("..valores..")"                                                               
           DBExec(inclusao_dependencia)
               
      -- ---------------------------------------------------------------------------------------                                           
      -- Altera dependencia jah cadastrada
      -- ---------------------------------------------------------------------------------------                                           
        elseif cgi.ativ_cod then           
           local select = "SELECT dep_cod FROM dependencia WHERE dep_ativ_cod = " .. tonumber(cgi.ativ_cod)
           DBExec(select)
           local resultado = DBRow()
           if resultado and resultado.dep_cod then
              if not cgi.areas or cgi.areas == '' then
                 local delete = "DELETE FROM dependencia WHERE dep_cod = " .. tonumber(resultado.dep_cod)           	
                 DBExec(delete)
              else
                 if cgi.dep_descr ~= '' then  	
                    alteracao_dependencia = "UPDATE dependencia SET dep_area_cod = "..cgi.areas..", dep_descr = '"..cgi.dep_descr.."' WHERE dep_ativ_cod = "..cgi.ativ_cod..""        
                 else
                    alteracao_dependencia = "UPDATE dependencia SET dep_area_cod = "..cgi.areas..", dep_descr = '' WHERE dep_ativ_cod = "..cgi.ativ_cod..""        
                 end
                 DBExec(alteracao_dependencia)     
              end
           elseif cgi.areas and cgi.areas ~= '' then
              campos  = "dep_proj_cod, dep_ativ_cod, dep_area_cod, dep_descr"
              valores =  cgi.proj_cod..", "..cgi.ativ_cod..", "..cgi.areas                 
              if cgi.dep_descr ~= '' then 	              
                 valores = valores..", '"..cgi.dep_descr.."'"
              else
                 valores = valores..", ''"                          
              end
              inclusao_dependencia = "INSERT INTO dependencia ("..campos..") VALUES ("..valores..")"                                                               
              DBExec(inclusao_dependencia)
           end               
        end                
        
        limpaCampos()      
  end
    
  if ESTADO_BD == 'aberto' then
     FechaBD()
  end
  cgi.form_rev = nil --Se este flag for igual a 1 o botao de "formalizar" nao aparece.
  cgilua.redirect('../atividades.html?'.. cgilua.encodecgi())

else -- Ocorre quando cgi.botao = 'DEPENDENCIA'
  -- Evita que os valores que venham apos plics na string sejam omitidos na pagina HTML
  cgi.descricao_ativ = forca_plic(cgi.descricao_ativ)
  if ESTADO_BD == 'aberto' then
     FechaBD()
  end
  cgilua.redirect('../atividades.html?'.. cgilua.encodecgi())       
end 
