-- ---------------------------------------------------------------------------------------------------------------------
-- ATUALIZA_DT_PREV_ATIV.LUA
-- ---------------------------------------------------------------------------------------------------------------------
   cgilua.htmlheader()
   dofile( "acessabd.lua" )
   dofile( "global.lua" )
   dofile( "func_atualiza_proj_dt_prev_ativ.lua" )
 
   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end   
   
   DBExec("SELECT p.proj_cod, p.proj_dt_ini_prev as dt_ini_prev, p.proj_dt_fim_prev as dt_fim_prev FROM projeto p "..
          "WHERE p.last_versao = 's' and p.stat_cod = 2 and ((p.proj_dt_ini_prev <> (select min(a.ativ_dt_ini_prev) "..
          "from atividade a where a.proj_cod = p.proj_cod)) or (p.proj_dt_fim_prev <> (select max(a.ativ_dt_fim_prev) "..
          "from atividade a where a.proj_cod = p.proj_cod))) ORDER BY proj_cod")
   resultado = DBRow()
      
   print('<BR>Procurando pelos projetos em andamento com ATIVIDADES que no tenham nenhuma das suas datas de '..
         'incio e fim iguais as datas de incio e fim previsto para o PROJETO.<BR>') 
    
   i = 1
   projeto = {}
   while resultado do
   	  projeto[i] = {}
   	  projeto[i].cod =  resultado.proj_cod
   	  projeto[i].ini =  inclui_data(resultado.dt_ini_prev)
   	  projeto[i].fim =  inclui_data(resultado.dt_fim_prev)   	  
   	  
   	  resultado = DBRow()  
   	  i = i + 1  	     	  
   end      
      
   print(i-1 ,' projetos encontrados.<BR>')     
   
   print('<BR>Atualizando a tabela de atividades.<BR>')  
   
   i = 1   
   while projeto[i] do
   	  update_dt_ini = "update atividade set ativ_dt_ini_prev = '"..projeto[i].ini.."' where ativ_cod in (select "..
   	                  "ativ_cod from atividade where proj_cod = "..projeto[i].cod.." and (ativ_dt_ini_prev = ".. 
   	                  "(select min(ativ_dt_ini_prev) from atividade where proj_cod = "..projeto[i].cod..") or "..
   	                  "ativ_dt_ini_prev < "..tonumber(projeto[i].ini).."))"
   	  DBExec(update_dt_ini)   	  

      update_dt_fim = "update atividade set ativ_dt_fim_prev = '"..projeto[i].fim.."' where ativ_cod in (select "..
                      "ativ_cod from atividade where proj_cod = "..projeto[i].cod.." and (ativ_dt_fim_prev = "..
                      "(select max(ativ_dt_fim_prev) from atividade where proj_cod = "..projeto[i].cod..") or "..
   	                  "ativ_dt_fim_prev > "..tonumber(projeto[i].fim).."))"
   	  DBExec(update_dt_fim)   	 
   	  
   	  -- ---------------------------------------------------------------------------------------         
      -- Atualizao do campo PROJ_DESEMPENHO na tabela PROJETO quando so gravadas alteraes
      -- no projeto pela funo de CADASTRO/EDICAO DE ATIVIDADES
      -- ---------------------------------------------------------------------------------------                                                  
         atualizaProjDesempenho(projeto[i].cod)  
                 
      -- -------------------------------------------------------------------------------------------- 
      -- Atualizar o FLAG referente as datas previstas e reais das atividades em relacao as datas 
      -- previstas e reais do projeto (proj_dt_prev_ativ - tabela PROJETO): forcar com que se tenha 
      -- pelo menos uma atividade com data de inicio prevista igual a data de inicio prevista do 
      -- projeto e uma atividade com data de fim prevista igual a data de fim prevista do projeto.
      -- --------------------------------------------------------------------------------------------           
        atualizaDatasPrevistas(projeto[i].cod) 

      -- ---------------------------------------------------------------------------------------         
      -- Atualizao da tabela de FOLLOW_UP quando so gravadas alteraes no projeto pela 
      -- funo de ACOMPANHAMENTO
      -- ---------------------------------------------------------------------------------------
         justificativa = 'Ajuste automtico das datas de incio e fim previsto das atividades de acordo com as datas correspondentes do projeto.'                                       
         atualizaFollowUp(projeto[i].cod,0,justificativa)   	  	 
   	     	  
   	  i = i + 1   	     	  
   end
  
   print(i-1 ,' projetos tiveram as datas de incio e fim previsto de suas atividades atualizadas.<BR>')  
  
   if ESTADO_BD == 'aberto' then
      FechaBD()
   end   