-- -------------------------------------------------------------------------------------------------
-- CALCULOFINANCEIRO.LUA
-- -------------------------------------------------------------------------------------------------
-- $Revision:$
--
-- $Update Date:$ $NoKeywords:$
-- 
-- Copyright by TeCGraf (PUC-RIO)
-- -------------------------------------------------------------------------------------------------  
     
-- -------------------------------------------------------------------------------------------------
-- Abre conexao com o Banco de Dados
-- -------------------------------------------------------------------------------------------------   
   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end   

-- ---------------------------------------------------------------------------------------------
-- Atualizacao ANUAL dos campos PROJ_PERC_FINANCEIRO_REALIZADO e PROJ_PERC_FINANCEIRO_ESPERADO 
-- de todos os projetos
-- Essa atualizacao deve ser feita diariamente para os projetos em EDICAO e em ANDAMENTO atraves 
-- dos modulos de CADASTRAMENTO/EDICAO e de ACOMPANHAMENTO
-- ---------------------------------------------------------------------------------------------    
   ano_atual = date('%Y')
   
   DBExec('SELECT ano_base FROM calculo_financeiro')
   ano_calculo = DBRow()
   
   if ano_calculo and ano_calculo.ano_base and ano_calculo.ano_base == tonumber(ano_atual) then
      write('A atualizao dos valores financeiros realizado e esperado j havia sido realizada para o ano de '.. 
             ano_atual..'.<br><br>Nenhum clculo foi efetuado.')
   -- -------------------------------------------------------------------------------------------
   -- Efetua o calculo dos valores financeiros para a ultima versao de todos os projetos da base 
   -- -------------------------------------------------------------------------------------------
   else   
      -- -----------------------------------------------------------------------------------------------------
      -- 1.1 - Para obtermos o Percentual ESPERADO de Realizacao Financeira , devera ser obtido o valor total 
      --       planejado ateh o ano corrente.
      --
      -- Ex: Usando um Projeto X, cujas suas datas de inicio  e termino previsto sejam 01/07/2000 e 31/12/2003, 
      --     respectivamente e onde suas previsoes financeiras, sejam :
      --     2000 - R$ 200.000,00
      --     2001 - R$ 700.000,00
      --     2002 - R$ 500.000,00
      --     2003 - R$ 300.000,00
      --
      -- Se levarmos em consideracao a data atual 22/07/2002 teremos a indicacao de que o ano que nos interessa 
      -- eh o de 2002, nesse caso obteremos o valor total planejado do projeto ateh 2002 ( R$ 200.000,00 + 
      -- R$ 700.000,00 + R$ 500.000,00 = R$ 1.400.000,00 )                  
      -- -----------------------------------------------------------------------------------------------------
      -- 1.2 - O proximo passo serah obter "quantos %" representa o valor obtido no item 1.1 em relacao ao 
      --       custo total do projeto (R$ 200.000,00 + R$ 700.000,00 + R$ 500.000,00 + R$ 300.000,00 = 
      --       R$ 1.700.000,00), assim teremos a seguinte relacao:
      --
      --       R$ 1.700.000,00   -   100 %
      --       R$ 1.400.000,00   -     X % 
      --
      -- O que nos d o precentual esperado ateh o momento de 82,35%         
      -- -----------------------------------------------------------------------------------------------------
      perc = {}  
      
      -- Armazena inicialmente o somatorio de custo ESPERADO, passando a armazenar o PERCENTUAL ESPERADO
      -- perc[codigo].Etotal
      
      -- Armazena o somatorio de custo ESPERADO parcial para ser usado no calculo do PERCENTUAL REALIZADO
      -- perc[codigo].Eparcial
      
      -- Armazena o PERCENTUAL REALIZADO
      -- perc[codigo].Rtotal
      
      queryTotal   = [[SELECT proj_cod, SUM(custo_prev_ano) AS soma FROM custo WHERE proj_cod IN (select proj_cod ]]..
                     [[from projeto where last_versao = 's') GROUP BY proj_cod ORDER BY proj_cod]]
      queryParcial = [[SELECT proj_cod, SUM(custo_prev_ano) AS soma FROM custo WHERE proj_cod IN (select proj_cod ]]..
                     [[from projeto where last_versao = 's') AND custo_ano <=]]..ano_atual..[[ ]]..
                     [[GROUP BY proj_cod ORDER BY proj_cod]]
      
      DBExec(queryTotal)
      total = DBRow()
      
      while total and total.proj_cod do
         -- armazena inicialmente o somatorio de custo PREVISTO (esperado)
         perc[total.proj_cod] = {}
         perc[total.proj_cod].Etotal = total.soma
         perc[total.proj_cod].Rtotal = 0
         total = DBRow()
      end  
      
      DBExec(queryParcial)
      parcial = DBRow()
            
      while parcial and parcial.proj_cod do
         perc[parcial.proj_cod].Eparcial = parcial.soma
         -- passa a armazenar o PERCENTUAL ESPERADO
         if tonumber(perc[parcial.proj_cod].Etotal) ~= 0 then
            perc[parcial.proj_cod].Etotal = format( '%.2f',(perc[parcial.proj_cod].Eparcial/perc[parcial.proj_cod].Etotal)*100 )
         end      
         parcial = DBRow()
      end  
      
      -- -----------------------------------------------------------------------------------------------------
      -- 1.3 - Agora que jah temos o % Esperado Financeiro, vamos obter o % de REALIZACAO FINANCEIRA, da 
      --       seguinte maneira:
      --
      -- Consideramos o valor total financeiro ateh a data atual como sendo os 100 % Esperado, conforme 
      -- detalhamos no item 1.1 e que ateh a data atual tenhamos acumulado um valor total financeiro realizado, 
      -- informado pelo usuario de R$ 1.100.000,00 , teremos a relacao mostrada abaixo:
      --
      -- R$ 1.400.000,00    -    100 %
      -- R$ 1.100.000,00    -      X %
      --
      -- O que nos dah o percentual de realizacao financeira ateh o momento de 78,57%
      -- -----------------------------------------------------------------------------------------------------                
      queryRealizado = [[SELECT proj_cod, SUM(valor_real) AS soma FROM custo_realizado WHERE proj_cod IN (select ]]..
                       [[proj_cod from projeto where last_versao = 's') GROUP BY proj_cod ORDER BY proj_cod]]              
      DBExec(queryRealizado)            
      total = DBRow()
      
      while total and total.proj_cod do
         if perc[total.proj_cod] and perc[total.proj_cod].Eparcial and tonumber(perc[total.proj_cod].Eparcial) ~= 0 then          
            perc[total.proj_cod].Rtotal = format( '%.2f',(total.soma/perc[total.proj_cod].Eparcial)*100 )
         elseif perc[total.proj_cod] and perc[total.proj_cod].Eparcial and tonumber(perc[total.proj_cod].Eparcial) == 0 then          
            perc[total.proj_cod].Rtotal = 0
         end      
         total = DBRow()
      end  
      
      -- -----------------------------------------------------------------------------------------------------      
      -- 1.4 - Feito esses calculos, os percetuais financeiros esperados e realizados, deverao ser armazenados
      --       em uma tabela no Banco de Dados e inseridos nos relatorios extraidos do Sistema na listbox de 
      --       "Informacoes" disponivel nos opcao "relatorio" no menu do Sistema Carteira de Projetos.
      -- -----------------------------------------------------------------------------------------------------  
      -- Soh sao inseridos valores para custo realizado para datas menores ou iguais a do dia da insercao 
      -- -----------------------------------------------------------------------------------------------------  
      count = 0
      if perc then       
         campo = next( perc, nil )           -- captura primeiro campo da tabela      
         while campo do 
            -- Para reduzir o numero de projetos consultados verifico somente a ULTIMA VERSAO (last_versao='s')            
            atualiza = 'UPDATE projeto SET proj_perc_financeiro_esperado = '.. perc[campo].Etotal ..', '..
                       'proj_perc_financeiro_realizado = '.. perc[campo].Rtotal ..' WHERE proj_cod = '.. campo                 
            DBExec(atualiza)    
            count = count + 1  
                                  
            campo = next( perc, campo )       -- captura proximo campo da tabela            
         end
      end
      
      write('<br><br><font color="blue"><i>Os valores referentes ao % Financeiro Realizado e ao % Financeiro esperado foram atualizados para '..
            count..' projeto(s).</i>')
      
      -- --------------------------------------------------------------------------------------------------------
      -- A tabela CALCULO_FINANCEIRO eh apenas uma tabela auxiliar para garantir que o clculo financeiro ANUAL
      -- soh serah efetuado uma vez por ano
      -- A cada atualizacao de custo em CADASTRAMENTO/EDICAO e ACOMPANHAMENTO esse calculo eh refeito
      -- --------------------------------------------------------------------------------------------------------      
      DBExec('DELETE FROM calculo_financeiro')
      DBExec('INSERT INTO calculo_financeiro (ano_base) VALUES ('..ano_atual..')')
      
   end 
      