-- -----------------------------------------------------------------------------------------------------------
-- CONS_PERSO.LUA
-- -----------------------------------------------------------------------------------------------------------

-- -----------------------------------------------------------------------------------------------------------
-- Caso os codigos de projeto passados para a funcao de gravacao sejam maiores que o limite suportado pelo 
-- banco, esses valores serao quebrados
-- -----------------------------------------------------------------------------------------------------------
-- cod_projetos > codigos de projetos a ser inserido no banco
-- -----------------------------------------------------------------------------------------------------------
-- Atualmente essa funcao nao estah sendo utilizada pois fizemos testes no banco e vimos que o campo que 
-- armazena a lista de codigos de projetos suporta ateh 50000 caracteres(valor limite do nosso teste)
-- A partir de 900 caracteres o valor nao eh mais exibido no banco, aparece a expressao <Long Text>, 
-- entretanto esse valor eh exibido quando tratado por LUA, tanto para gravar no banco quanto para consultar
-- -----------------------------------------------------------------------------------------------------------
function quebraLinhasBD(cod_projetos)
   -- Mantem o valor de _TAM_CAMPO_LISTA_ (tamanho do campo no banco que eh um TEXT de 16 (=380 caracteres))
      dofile( 'constantes.lua' )
    
   -- tamanho da string que armazena os codigos de projeto
      local tamanho = strlen(cod_projetos) 
                    
   linhas = floor(tamanho / _TAM_CAMPO_LISTA_)  -- retorna o quociente da divisao inteira
   quebra = mod(tamanho,_TAM_CAMPO_LISTA_)      -- retorna o resto da divisao inteira           

   var_projetos = {}
   local i      = 1
   local ini    = 1
   local fim    = _TAM_CAMPO_LISTA_
   
   while i <= linhas do          
      pini = strfind(cod_projetos,',', fim)    
      while pini > fim do
         fim = fim - 1
         pini = strfind(cod_projetos,',', fim)           
      end       
      var_projetos[i] = strsub(cod_projetos, ini, pini)      -- captura ateh a virgula                      
      ini = pini + 1
      fim = pini + _TAM_CAMPO_LISTA_      
      i   = i + 1
   end  
   if fim > tamanho and ini < tamanho then      
      pini = strfind(cod_projetos,',', tamanho)              
      if pini then
         var_projetos[i] = strsub(cod_projetos, ini, pini)   -- captura ateh a virgula         
         ini = pini + 1
      else   
         var_projetos[i] = strsub(cod_projetos, ini,tamanho)
         ini = tamanho + 1
      end                     
      i = i + 1      
   end 
   
   if ini <= tamanho then
      var_projetos[i] = strsub(cod_projetos, ini, tamanho)     
   end 
   return (var_projetos)   
end   

-- -----------------------------------------------------------------------------------------------------------
-- Lista todas as consultas personalizadas do usuario atual como links
-- -----------------------------------------------------------------------------------------------------------
function listaConsultasPersonalizadas( chave )
   local i
   local tab_cons
   local reldir
      
   if ( strfind( cgilua.script_vdir, '/lua') ) then
      reldir = ''
   else
      reldir = 'lua/'
   end
   
   dofile( reldir .. "GLOBAL.LUA" )
   dofile( reldir .. "ACESSABD.LUA" )
   dofile( reldir .. "ALGORITMOS.LUA" )
   
   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end
   
   -- ---------------------------------------------------------------------------
   -- LISTA RELATORIO (tabelas: relat_personalizado e lista_relat_personalizado) 
   -- ---------------------------------------------------------------------------  
   if tipo == 'relatorio' then         
      tab_relat = ConsultaBD2( "relat_personalizado", " relat_nome, relat_cod", "pes_cod = " .. retornaPessoaCod(chave), "relat_nome" )
      write('<font class=fieldLabel>Relatrios Personalizados</font><br><br>')
      if ( tab_relat[1].relat_cod ) then
         tab_relat = removeDuplicadas( tab_relat, "relat_nome" )
         write( '<TABLE BORDER="0" WIDTH="80%">\n' )
         
         inicializaCor()
         i = 1
         while ( tab_relat[i] ) do
            write( '<TR bgcolor='..cor..'><TD width="90%"><A HREF="filtro_personalizados.html?relat_cod=' .. tab_relat[i].relat_cod .. '&tipo_servico='..cgi.tipo_servico..'">' .. tab_relat[i].relat_nome .. '</A></TD>\n' )
            write( '<TD><A HREF="lua/del_personalizado.lua?relat_cod=' .. tab_relat[i].relat_cod ..'&tipo_servico='..cgi.tipo_servico..'" TARGET="princ" onMouseOver=MM_swapImage("exclui_rel'..i..'","","'..imagem2..'",1); onMouseOut=MM_swapImgRestore();><IMG SRC="'..imagem..'" BORDER=0 NAME="exclui_rel'..i..'"></A></TD></TR>' )                                                                                                     
            mudaCor()
            i = i + 1
         end
         j = i
         write( '</TABLE>\n' )
      else
         write( 'No existem relatrios personalizados.' )
      end
      
      tab_lista_relat = ConsultaBD2( "lista_relat_personalizado", " lista_relat_nome, lista_relat_cod", "pes_cod = " .. retornaPessoaCod(chave), "lista_relat_nome" )
      write('<br><br><font class=fieldLabel>Lista de Relatrios Personalizados</font><br><br>')
      if ( tab_lista_relat[1].lista_relat_cod ) then
         tab_lista_relat = removeDuplicadas( tab_lista_relat, "lista_relat_nome" )
         write( '<TABLE BORDER="0" WIDTH="80%">\n' )
         
         inicializaCor()
         i = 1         
         while ( tab_lista_relat[i] ) do            
            write( '<TR bgcolor='..cor..'><TD width="90%"><A HREF="lista_perso.html?lista_relat_cod=' .. tab_lista_relat[i].lista_relat_cod .. '&tipo_servico='..cgi.tipo_servico..'">' .. tab_lista_relat[i].lista_relat_nome .. '</A></TD>\n' )
            write( '<TD><A HREF="lua/del_lista_perso.lua?lista_relat_cod=' .. tab_lista_relat[i].lista_relat_cod .. '&tipo_servico='..cgi.tipo_servico..'" TARGET="princ" onMouseOver=MM_swapImage("exclui_rel_lista'..i..'","","'..imagem2..'",1); onMouseOut=MM_swapImgRestore();><IMG SRC="'..imagem..'" BORDER=0 NAME="exclui_rel_lista'..i..'"></A></TD></TR>' )
            mudaCor()
            i = i + 1           
         end
   
         write( '</TABLE>\n' )
      else
         write( 'No existem listas personalizadas.' )
      end  
        
   -- -------------------------------------------------------------------
   -- LISTA CONSULTA (tabelas: cons_personalizada e lista_personalizada) 
   -- -------------------------------------------------------------------           
   else         
      tab_cons = ConsultaBD2( "cons_personalizada", " cons_nome, cons_cod", "pes_cod = " .. retornaPessoaCod(chave), "cons_nome" )
      write('<font class=fieldLabel>Consultas Personalizadas</font><br><br>')
      if ( tab_cons[1].cons_cod ) then
         tab_cons = removeDuplicadas( tab_cons, "cons_nome" )
         write( '<TABLE BORDER="0" WIDTH="80%">\n' )
         
         inicializaCor()
         i = 1
         while ( tab_cons[i] ) do
            write( '<TR bgcolor='..cor..'><TD width="90%"><A HREF="filtro_personalizados.html?cons_cod=' .. tab_cons[i].cons_cod .. '&tipo_servico='..cgi.tipo_servico..'">' .. tab_cons[i].cons_nome .. '</A></TD>\n' )
            write( '<TD><A HREF="lua/del_personalizado.lua?cons_cod=' .. tab_cons[i].cons_cod .. '&tipo_servico='..cgi.tipo_servico..'" TARGET="princ" onMouseOver=MM_swapImage("exclui_cons'..i..'","","'..imagem2..'",1); onMouseOut=MM_swapImgRestore();><IMG SRC="'..imagem..'" BORDER=0 NAME="exclui_cons'..i..'"></A></TD></TR>' )
            mudaCor()
            i = i + 1
         end
         j = i
         write( '</TABLE>\n' )
      else
         write( 'No existem consultas personalizadas.' )
      end
      
      tab_lista = ConsultaBD2( "lista_personalizada", " lista_nome, lista_cod", "pes_cod = " .. retornaPessoaCod(chave), "lista_nome" )
      write('<br><br><font class=fieldLabel>Listas Personalizadas</font><br><br>')
      if ( tab_lista[1].lista_cod ) then
         tab_lista = removeDuplicadas( tab_lista, "lista_nome" )
         write( '<TABLE BORDER="0" WIDTH="80%">\n' )
         
         inicializaCor()
         i = 1         
         while ( tab_lista[i] ) do
            write( '<TR bgcolor='..cor..'><TD width="90%"><A HREF="lista_perso.html?lista_cod=' .. tab_lista[i].lista_cod .. '&tipo_servico='..cgi.tipo_servico..'">' .. tab_lista[i].lista_nome .. '</A></TD>\n' )
            write( '<TD><A HREF="lua/del_lista_perso.lua?lista_cod=' .. tab_lista[i].lista_cod .. '&tipo_servico='..cgi.tipo_servico..'" TARGET="princ" onMouseOver=MM_swapImage("exclui_cons_lista'..i..'","","'..imagem2..'",1); onMouseOut=MM_swapImgRestore();><IMG SRC="'..imagem..'" BORDER=0 NAME="exclui_cons_lista'..i..'"></A></TD></TR>' )
            mudaCor()
            i = i + 1            
         end
   
         write( '</TABLE>\n' )
      else
         write( 'No existem listas personalizadas.' )
      end   
   end   

   if ESTADO_BD == 'aberto' then
      FechaBD()
   end   
      
end

-------------------------------------------------------------------------------------------------------------------------
-- Grava uma consulta personalizada
-------------------------------------------------------------------------------------------------------------------------
-- dados                = tabela bidimensional ix2 contendo dados da consulta
-- dados[i].campo       = string contendo o campo ( ex. 'unidade' )
-- dados[i].valores     = string contendo valores do respectivo campo separados por virgula ( ex. 'RECAP,REDUC' )
function gravaConsultaPersonalizada( nome_cons, dados )
   
   -- ---------------------------------------------------------------------------
   -- GRAVA RELATORIO (tabelas: relat_personalizado e lista_relat_personalizado) 
   -- ---------------------------------------------------------------------------  
   if tipo_gravacao == 'relatorio' then
      local i
      local usuario
      local reldir
      local temp = {}
      
      if ( strfind( cgilua.script_vdir, '/lua') ) then
         reldir = ''
      else
         reldir = 'lua/'
      end
   
      dofile( reldir .. "GLOBAL.LUA" )
      dofile( reldir .. "ACESSABD.LUA" )
      
      if ESTADO_BD ~= 'aberto' then
         AbreBD()
      end
   
      usuario = retornaPessoaCod( getuser() )
      if temConteudo( cgi.nome_lista_perso ) then
         if temConteudo(cgi.var_proj_query) then           
            cgi.var_proj_cod = ''   
            DBExec(cgi.var_proj_query)      
            local temp = DBRow()
 
            while ( temp and temp.proj_cod ) do                          
               if cgi.var_proj_cod ~= '' then 
                  cgi.var_proj_cod = cgi.var_proj_cod..','
               end
               cgi.var_proj_cod = cgi.var_proj_cod..temp.proj_cod   
                  
               temp = DBRow()               
            end
         end     
       
         temp = ConsultaBD2( 'lista_relat_personalizado', 'lista_relat_nome', 'lista_relat_nome = \'' .. cgi.nome_lista_perso .. '\' AND pes_cod = ' .. usuario , nil )   
         if ( not temp[1].lista_relat_nome ) then
            if not( temConteudo(flag_loop) ) then 
               valores = "'"..usuario.."', '"..cgi.nome_lista_perso.."', '"..cgi.var_proj_cod.."'"
               campos  = "pes_cod, lista_relat_nome, lista_relat_proj_cod"
               if cgi.informacoes and cgi.informacoes ~= '' then
                  campos = campos .. ", lista_relat_ordem"
                  valores = valores .. ", '"..cgi.informacoes.."'"
               end 
               insert_lista_relat_personalizado = "INSERT INTO lista_relat_personalizado ("..campos..") VALUES ("..valores..")"                        
               DBExec(insert_lista_relat_personalizado)              
            elseif flag_loop == 1 then  
               i = 1
               while projetos[i] do 
                  valores = "'"..usuario.."', '"..cgi.nome_lista_perso.."', '"..projetos[i].."'"
                  campos  = "pes_cod, lista_relat_nome, lista_relat_proj_cod"
                  if cgi.informacoes and cgi.informacoes ~= '' then
                     campos = campos .. ", lista_relat_ordem"
                     valores = valores .. ", '"..cgi.informacoes.."'"
                  end 
                  insert_lista_relat_personalizado = "INSERT INTO lista_relat_personalizado ("..campos..") VALUES ("..valores..")"                                          
                  DBExec(insert_lista_relat_personalizado)                                           
                  i = i + 1
               end               
               flag_loop = ''             
            end
            
            flag_existe_lista = 1 
         end
      end   
      
      if temConteudo( cgi.nome_cons_perso ) then
         temp = ConsultaBD2( 'relat_personalizado', 'relat_nome', 'relat_nome = \'' .. nome_cons .. '\' AND pes_cod = ' .. usuario , nil )   
         
         i = 1
         if ( not temp[1].relat_nome ) and dados[i] then 	            
            -- -------------------------------------------------------
            -- DADOS vem de GRAVA_CONS_PERSO.LUA
            -- -------------------------------------------------------
            tab_proj_cod = {}
            while ( dados[i] ) do
               -- ---------------------------------------------------------------------------------------------------
               -- Verifica se existem vrios valores para um mesmo campo, caso exista, ser necesrio utilizar IN
               -- EX: INSERT INTO cons_personalizada (pes_cod,cons_nome,cons_nome_campo,cons_valor_campo) 
               --            VALUES (100,'teste','org_cod,proj_sigla','IN( 5,8,9,3,7,6,4,1,2,11)')
               -- ---------------------------------------------------------------------------------------------------
               --  Uso do comando STRFIND para descobrir se o campo assumiu mais de um valor
               -- ---------------------------------------------------------------------------------------------------
            	 ini_val, fim_val = strfind(dados[i].valores,',')
            	 if ini_val and fim_val and dados[i].campo ~= 'informacoes' and dados[i].campo ~= 'ordem' then
            	    dados[i].valores = 'IN ('..dados[i].valores..')'
            	 end 
            	 -- ---------------------------------------------------------------------------------------------------
            	 -- No banco de dados uma mesma consulta  salva tantas vezes quantos forem os nmeros dos campos
            	 -- EX: cons_cod pes_cod cons_nome  cons_nome_campo    cons_valor_campo                                                                                     
               --     -------- ------- ---------  ------------------ ------------------------------------------------ 
               --     54       119     cons123    org_cod            IN(5,8,9,3,7,6,4,1,2,11)
               --     55       119     nadinha    clas_cod           IN(13,3,21,1,2,4,5,7,24,18,6)
               --     56       119     nadinha    proj_ot_subcl_cod  IN(19,20,11,10,9,12,8,23,22,16,15,14)
               --     57       119     nadinha    proj_dt_ini_prev   >= 01/04/2001   	  
            	 -- ---------------------------------------------------------------------------------------------------      	  
   
               EscreveBD( 'relat_personalizado', 'pes_cod,relat_nome,relat_nome_campo,relat_valor_campo', ' \'' .. usuario .. '\', \'' .. cgi.nome_cons_perso .. '\', \'' .. dados[i].campo .. '\', \'' .. dados[i].valores .. '\' ')
               
               i = i + 1
            end
            return 1
         else
            return 0
         end 
      elseif flag_existe_lista then 
         return 1
      else
         return 2
      end
   
   -- -------------------------------------------------------------------
   -- GRAVA CONSULTA (tabelas: cons_personalizada e lista_personalizada)  
   -- -------------------------------------------------------------------           
   else  
      local i
      local usuario
      local reldir
      local temp = {}
      
      if ( strfind( cgilua.script_vdir, '/lua') ) then
         reldir = ''
      else
         reldir = 'lua/'
      end
   
      dofile( reldir .. "GLOBAL.LUA" )
      dofile( reldir .. "ACESSABD.LUA" )
            
      if ESTADO_BD ~= 'aberto' then
         AbreBD()
      end      
   
      usuario = retornaPessoaCod( getuser() )
      if temConteudo( cgi.nome_lista_perso ) then
         if temConteudo(cgi.var_proj_query) then           
            cgi.var_proj_cod = ''   
            DBExec(cgi.var_proj_query)      
            local temp = DBRow()
 
            while ( temp and temp.proj_cod ) do                          
               if cgi.var_proj_cod ~= '' then 
                  cgi.var_proj_cod = cgi.var_proj_cod..','
               end
               cgi.var_proj_cod = cgi.var_proj_cod..temp.proj_cod   
                  
               temp = DBRow()               
            end                                    
         end
          
         temp = ConsultaBD2( 'lista_personalizada', 'lista_nome', 'lista_nome = \'' .. cgi.nome_lista_perso .. '\' AND pes_cod = ' .. usuario , nil )   
         if ( not temp[1].lista_nome ) then
            if not( temConteudo(flag_loop) ) then        
               insert_lista_personalizada = "INSERT INTO lista_personalizada (pes_cod, lista_nome, lista_proj_cod) VALUES "..
                                            "('"..usuario.."', '"..cgi.nome_lista_perso.."', '"..cgi.var_proj_cod.."')"            
               DBExec(insert_lista_personalizada)
            elseif flag_loop == 1 then
               i = 1
               while projetos[i] do
                  insert_lista_personalizada = "INSERT INTO lista_personalizada (pes_cod, lista_nome, lista_proj_cod) VALUES "..
                                               "('"..usuario.."', '"..cgi.nome_lista_perso.."', '"..projetos[i].."')"            
                  DBExec(insert_lista_personalizada)
                  i = i + 1                  
               end 
               flag_loop = '' 
            end   
            flag_existe_lista = 1 
         end
      end   
      
      if temConteudo( cgi.nome_cons_perso ) then
         temp = ConsultaBD2( 'cons_personalizada', 'cons_nome', 'cons_nome = \'' .. nome_cons .. '\' AND pes_cod = ' .. usuario , nil )   
         
         i = 1
         if ( not temp[1].cons_nome ) and dados[i] then 	
            -- -------------------------------------------------------
            -- DADOS vem de GRAVA_CONS_PERSO.LUA
            -- -------------------------------------------------------
            tab_proj_cod = {}                         
            while ( dados[i] ) do
               -- ---------------------------------------------------------------------------------------------------
               -- Verifica se existem vrios valores para um mesmo campo, caso exista, ser necesrio utilizar IN
               -- EX: INSERT INTO cons_personalizada (pes_cod,cons_nome,cons_nome_campo,cons_valor_campo) 
               --            VALUES (100,'teste','org_cod,proj_sigla','IN( 5,8,9,3,7,6,4,1,2,11)')
               -- ---------------------------------------------------------------------------------------------------
               --  Uso do comando STRFIND para descobrir se o campo assumiu mais de um valor
               -- ---------------------------------------------------------------------------------------------------
            	 ini_val, fim_val = strfind(dados[i].valores,',')
            	 if ini_val and fim_val then
            	    dados[i].valores = 'IN ('..dados[i].valores..')'
            	 end 
            	 -- ---------------------------------------------------------------------------------------------------
            	 -- No banco de dadps uma mesma consulta  salva tantas vezes quantos forem os nmeros dos campos
            	 -- EX: cons_cod pes_cod cons_nome  cons_nome_campo    cons_valor_campo                                                                                     
               --     -------- ------- ---------  ------------------ ------------------------------------------------ 
               --     54       119     cons123    org_cod            IN(5,8,9,3,7,6,4,1,2,11)
               --     55       119     nadinha    clas_cod           IN(13,3,21,1,2,4,5,7,24,18,6)
               --     56       119     nadinha    proj_ot_subcl_cod  IN(19,20,11,10,9,12,8,23,22,16,15,14)
               --     57       119     nadinha    proj_dt_ini_prev   >= 01/04/2001   	  
            	 -- ---------------------------------------------------------------------------------------------------      	  
              
               EscreveBD( 'cons_personalizada', 'pes_cod,cons_nome,cons_nome_campo,cons_valor_campo', ' \'' .. usuario .. '\', \'' .. nome_cons .. '\', \'' .. dados[i].campo .. '\', \'' .. dados[i].valores .. '\' ')
               
               i = i + 1
            end            
            return 1
         else
            return 0
         end
      elseif flag_existe_lista then
         return 1
      else
         return 2
      end
   end
   
   if ESTADO_BD == 'aberto' then
      FechaBD()
   end   
      
end

function inicializaCor()
   -- Inicializa em cinza claro
   imagem  = 'imagens/excluir_ec.gif'
   imagem2 = 'imagens/excluir_ec2.gif'
   cor     = '#ECECEC'   
end

function mudaCor()
   if cor == '#CCCCCC' then       -- Cinza mdio
      imagem  = 'imagens/excluir_ec.gif'
      imagem2 = 'imagens/excluir_ec2.gif'
      cor     = '#ECECEC'
   elseif cor == '#ECECEC' then    -- Cinza claro
      imagem  = 'imagens/excluir_cc.gif'
      imagem2 = 'imagens/excluir_cc2.gif'
      cor     = '#CCCCCC'
   end       
end
