-- -------------------------------------------------------------------------------------------------
-- $Revision:$ 
--
-- $Update Date:$ $NoKeywords:$
-- 
-- Copyright by TeCGraf (PUC-RIO)
-- -------------------------------------------------------------------------------------------------
-- Esse SCRIPT deve ser executado no servidor atraves do WINAT nos dias 05 e 10 de cada ms
-- -------------------------------------------------------------------------------------------------
-- Varre a tabela de projetos procurando os usuarios ligados a projetos CLASSE I e envia e-mail 
-- lembrando a necessidade de se atualizar os projetos CLASSE I
-- -------------------------------------------------------------------------------------------------    
   
-- -------------------------------------------------------------------------------------------------
-- Abre conexao com o Banco de Dados se ela jah nao estiver aberta
-- -------------------------------------------------------------------------------------------------
   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end
   
-- -------------------------------------------------------------------------------------------------
-- DEFININDO VALORES
-- -------------------------------------------------------------------------------------------------
-- -------------------------------------------------------------------------------------------------
-- Descobre o e-mail do responsavel pelos projetos CLASSE I
-- -------------------------------------------------------------------------------------------------
   local sql_origem = "SELECT pes_email FROM pessoal WHERE pes_chave = '".._CHAVE_PROJ_CLASSE_I_.."'"
   DBExec(sql_origem)  
   origem = DBRow().pes_email  
   
-- -------------------------------------------------------------------------------------------------
-- DEFININDO DATAS
-- -------------------------------------------------------------------------------------------------   
   dia_num = date('%d')
   mes_ano = date('%m/%Y')   -- retorna mes e ano atual           
   
   titulo   = 'Acompanhamento do PEGASO'    
   mensagem = "Senhores,\n\n"..
                    "Gostaramos de relembr-los que, segundo os procedimentos e fluxo de "..
                    "comunicao definidos para controle e acompanhamento do PEGASO, no prximo "..
                    "dia 15/" ..mes_ano..", realizaremos a emisso do relatrio de acompanhamento "..
                    "mensal do programa para em seguida, iniciarmos as anlises sobre os "..
                    "resultados obtidos. Os resultados das anlises estaro disponveis e sero "..
                    "divulgados a partir do dia 26/" ..mes_ano..".\n\n"..

                    "Em face do exposto, ressaltamos que  de suma importncia que os projetos "..
                    "Classe I cadastrados no sistema Carteira de Projetos, o qual est "..
                    "disponvel no site da rea de SMS na Intranet, sejam adequadamente "..
                    "atualizados at o dia 14/" ..mes_ano.. ".\n\n"..

                    "Assim, aproveitamos a oportunidade para reforar que estamos a sua "..
                    "disposio para esclarecer dvidas quanto  utilizao do sistema ou no "..
                    "entendimento dos procedimentos,\n".. 
                    
                    	"\n\t\tGrupo de Gesto do Pegaso."    
   
   -- -------------------------------------------------------------------------------------------------
   -- Se estamos nos dias 05 ou 10 do mes entao
   -- -------------------------------------------------------------------------------------------------   
      if tonumber(dia_num) == 5 or tonumber(dia_num) == 10 then 
         
         write('<br><b><font color="blue">O envio de e-mail para todos os usurios ligados a projetos de CLASSE I foi efetuado em '..
                date("%d/%m/%Y")..'.</b></font>')  
         
         -- ----------------------------------------------------------------------------------------------------------------------------
         -- Procura por todos os envolvidos com projetos CLASSE I sem armazenar codigos de pessoal repetido
         -- ----------------------------------------------------------------------------------------------------------------------------
            proj  = ''
            colab = ''
            -- Procura todos os projetos em ACOMPANHAMENTO (stat_cod = 2), ULTIMA VERSAO (last_versao = 's') e CLASSE I,
            -- retornando o cdigo do projeto
            sql_proj = " SELECT proj_cod FROM projeto "..
                       " WHERE proj_class = 1 AND stat_cod = 2 AND last_versao = 's' ORDER BY proj_cod "
            DBExec(sql_proj)
            tab_proj = DBRow()
            
            -- Armazena todos os dados dos projeto na variavel proj separando os codigos dos projetos por virgula
            if tab_proj and tab_proj.proj_cod then
               proj = tab_proj.proj_cod
               tab_proj = DBRow()
               while tab_proj and tab_proj.proj_cod do
                  proj = proj..", "..tab_proj.proj_cod
                  tab_proj  = DBRow()
               end
            end
            
            -- Seleciona todos os COLABORADORES e COORDENADORES da tabela PROJETO ligados aos projetos CLASSE I
            sql = " SELECT pes.pes_cod AS cod FROM projeto as proj, pessoal as pes "..
                  " WHERE (proj.proj_colab = pes.pes_chave OR proj.proj_coord = pes.pes_chave) AND "..
                  " proj_cod IN ("..proj..") GROUP BY pes.pes_cod ORDER BY pes.pes_cod "
            DBExec(sql)
            tab = DBRow()
            
            -- Armazena todos os COLABORADORES e COORDENADORES
            if tab and tab.cod then
               colab = tab.cod
               tab = DBRow()
               while tab and tab.cod do
                  colab = colab..", "..tab.cod
                  tab   = DBRow()
               end
            end
            
            -- Seleciona todos os OUTROS COLABORADORES dos projetos CLASSE I
            -- que ainda no foram selecionados como colaboradores ou como coordenadores
            sql = " SELECT DISTINCT colaborador AS cod FROM colaboradores WHERE proj_cod IN ("..proj..") AND "..
                  " colaborador NOT IN ("..colab..") ORDER BY colaborador "
            DBExec(sql)
            tab = DBRow()
            
            -- Armazena todos os OUTROS COLABORADORES
            if tab then
               while tab and tab.cod do
                  colab = colab..", "..tab.cod
                  tab   = DBRow()
               end
            end
            
            -- Seleciona todos os GERENTE DE AN dos projetos CLASSE I
            -- que ainda no foram selecionados como coordenadores, colaboradores e outros colaboradores
            sql = " SELECT DISTINCT pes_cod_resp AS cod FROM orgao "..
                  " WHERE org_cod IN (SELECT DISTINCT org_cod FROM projeto WHERE proj_cod IN ("..proj..")) "..
                  " AND pes_cod_resp NOT IN ("..colab..") ORDER BY pes_cod_resp "
            DBExec(sql)
            tab = DBRow()
            
            -- Armazena todos os GERENTES DE AN
            if tab then
               while tab and tab.cod do
                  colab = colab..", "..tab.cod
                  tab   = DBRow()
               end
            end
            
            -- Seleciona todos os SUB-GERENTES DE AN dos projetos CLASSE I
            -- que ainda no foram selecionados como coordenadores, colaboradores, outros colaboradores e gerente de an
            sql = " SELECT DISTINCT pes_cod_sub AS cod FROM orgao ".. 
                  " WHERE org_cod IN (SELECT DISTINCT org_cod FROM projeto WHERE proj_cod IN ("..proj..")) "..
                  " AND pes_cod_sub NOT IN ("..colab..") ORDER BY pes_cod_sub "
            DBExec(sql)
            tab = DBRow()
            
            -- Armazena todos os SUB-GERENTES DE AN
            if tab then
               while tab and tab.cod do
                  colab = colab..", "..tab.cod
                  tab   = DBRow()
               end
            end
            
            -- Seleciona todos os GERENTES DE UN dos projetos CLASSE I
            -- que ainda no foram selecionados como coordenadores, colaboradores, outros colaboradores, gerente e sub-gerente de an
            sql = " SELECT DISTINCT pes_cod_resp AS cod FROM unidade "..
                  " WHERE unid_cod IN (SELECT DISTINCT unid_cod FROM projeto WHERE proj_cod IN ("..proj..")) "..
                  " AND pes_cod_resp NOT IN ("..colab..") ORDER BY pes_cod_resp "
            DBExec(sql)
            tab = DBRow()
            
            -- Armazena todos os GERENTES DE UN
            if tab then
               while tab and tab.cod do
                  colab = colab..", "..tab.cod
                  tab   = DBRow()
               end
            end
            
            -- Seleciona todos os SUB-GERENTES DE UN dos projetos CLASSE I
            -- que ainda no foram selecionados como coordenadores, colaboradores, outros colaboradores,
            -- gerente e sub-gerente de an e gerente de un
            sql = " SELECT DISTINCT pes_cod_sub AS cod FROM unidade "..
                  " WHERE unid_cod IN (SELECT DISTINCT unid_cod FROM projeto WHERE proj_cod IN ("..proj..")) "..
                  " AND pes_cod_sub NOT IN ("..colab..") ORDER BY pes_cod_sub "
            DBExec(sql)
            tab = DBRow()
            
            -- Armazena todos os SUB-GERENTES DE UN
            if tab then
               while tab and tab.cod do
                  colab = colab..", "..tab.cod
                  tab   = DBRow()
               end
            end
         -- ------------------------------------------------------------------
         -- Fim da procura pelos envolvidos nos projetos CLASSE I
         -- ------------------------------------------------------------------
                     
         -- -------------------------------------------------------------------------------------------------
         -- ENVIANDO E-MAILs ...
         -- -------------------------------------------------------------------------------------------------
         sql_mail = " SELECT pes_email AS email FROM pessoal WHERE pes_cod IN ("..colab..") "
         DBExec(sql_mail)
         email = DBRow()
         
         if email then
            while email and email.email do
               local destino = email.email
               
               -- Chama a funo de envio de e-mail (envia_mail()) atraves da funo ENVIA_EMAIL definida em CONSTANTES.LUA
               local ok, msgerr = ENVIA_EMAIL(destino, origem, titulo, mensagem, '')
            
               if not ok then
                  write('<br><br><font color="red"><i>O(s) e-mail de notificao no pode ser enviado (email: <b>'..
                         email.email..'</b>)</i>')
                  if msgerr then
                     write('(erro: <b>'..msgerr..'</b>).')
                  end
               else
                  write('<br><br><font color="blue"><i>O e-mail de notificao foi enviado com sucesso! (email: <b>'..
                         email.email..'</b>)</i>')
               end

               email = DBRow()
            end  -- while tiver linha na tabela
         end
     
     else  -- (se nao estamos nos dias 05 ou 10)                                    
        
        write('<br><font color="red"><b>O envio de e-mail para todos os usurios ligados a projetos de CLASSE I '..
              's pode ser efetuado nos dias 05 e 10 de cada ms,<BR> hoje estamos no dia '..date("%d/%m/%Y")..'.</b></font>')  
        
     end