-- -----------------------------------------------------------------------------------------------------------------
-- FILTRO_PROJETOS.LUA
-- -----------------------------------------------------------------------------------------------------------------
assert(dofile( 'global.lua' ))
assert(dofile( 'desempenho.lua' ))
assert(dofile( 'constantes.lua' ))

-- Inicializando o valor que irah armazenar o filtro selecionado pelo usuario para exibicao
filtro_usuario = ''

function Concatena(lista, valor, campo, filtro)
   if not( temConteudo(campo) ) then
      campo = ''
   end
   if temConteudo(valor) and temConteudo(filtro) then
      filtro_usuario = filtro_usuario..'<tr valign="top"><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td class="fieldLabel">'..filtro..'</td><td>&nbsp;&nbsp;</td><td>'..valor..'</td></tr>'
   end
   if temConteudo(lista) and temConteudo(valor) then
      lista = lista .. ' AND ' .. campo .. valor
   elseif temConteudo(valor) then
      lista = campo .. valor
   end
   return lista
end

function montaLista(lista, valor)
   if temConteudo(lista) and temConteudo(valor) then
   	  lista = lista..','..valor
   elseif temConteudo(valor) then
   	  lista = valor
   else
      lista = ''
   end
   return lista
end

-- ------------------------------------------------------------------------------------------------------------------
-- LIMPA CAMPOS DO FORMULRIO
-- ------------------------------------------------------------------------------------------------------------------
   if ( cgi.acao == "Limpa Campos" ) then
       cgilua.redirect( "../filtro_projetos.html?tipo_servico="..troca_nil_por_vazio(cgi.tipo_servico)..
                        "&campo_status="..troca_nil_por_vazio(cgi.campo_status).."&campo_desempenho="..
                        troca_nil_por_vazio(cgi.campo_desempenho).."&campo_consolidado="..
                        troca_nil_por_vazio(cgi.campo_consolidado).."&campo_informacoes="..
                        troca_nil_por_vazio(cgi.campo_informacoes) )
       exit()
   end

-- ------------------------------------------------------------------------------------------------------------------
-- CARREGA A BIBLIOTECA VALIDAFORM
-- ------------------------------------------------------------------------------------------------------------------
   assert(dofile("../validaform/validaform.lua"))
   assert(dofile("form_filtro_projetos.lua"))

   cgi.msg = form_filtro_projetos:critica()

-- ------------------------------------------------------------------------------------------------------------------
-- HOUVE ERRO NO PREENCHIMENTO
-- ------------------------------------------------------------------------------------------------------------------
if ( cgi.msg ) then
   cgilua.redirect('../filtro_projetos.html?'..cgilua.encodecgi()) -- VOLTA PARA A PGINA html
   exit()
else
   assert(dofile( 'projetos.lua' ))
   assert(dofile( 'cores.lua' ))
   assert(dofile( 'acessabd.lua' ))
   assert(dofile( 'permissao_acesso.lua' ))

   cond = ''

   -- ----------------------------------------------------------------------------------------
   -- verifica permissao de acesso do usuario retornando os flags necessarios
   -- ----------------------------------------------------------------------------------------
   flag_org, flag_unid, org_cod, org_sigla, unid_cod, unid_sigla, associacao = validaAcesso()

   -- ----------------------------------------------------------------------------------------
   -- Usado em CONSULTAS (o usuario soh tem permissao de acesso as ANs e/ou UNs nas quais foi
   -- cadastrado nas tabelas de PESSOAL, ORGAO e UNIDADE)
   -- ----------------------------------------------------------------------------------------
   if associacao then
      cond_org_unid = montaCondicao( associacao, flag_org, flag_unid, org_cod, unid_cod, 'a', cgi.recebe_orgao, cgi.recebe_unidade )
   end

   -- ----------------------------------------------------------------------------------------
   -- Usado quando o usuario tiver ACESSO COMPLETO ou a acao nao for CONSULTA (cancelamento,
   -- formalizacao, conclusao etc )
   -- O usuario tem permissao de acesso as ANs e/ou UNs que ele selecionou
   -- ----------------------------------------------------------------------------------------
   if temConteudo(cgi.recebe_orgao) then
      cond_org  = ' a.org_cod IN (' .. cgi.recebe_orgao .. ') '
      ans = retornaSiglaOrgao (cgi.recebe_orgao)
      filtro_usuario = filtro_usuario..'<tr valign="top"><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td class="fieldLabel">rea de Negcio: </td><td>&nbsp;&nbsp;</td><td>'..ans..'</td></tr>'
   end


   if temConteudo(cgi.recebe_unidade) then
      cond_unid = ' a.unid_cod IN (' .. cgi.recebe_unidade .. ') '
      uns = retornaSiglaUnid (cgi.recebe_unidade)
      filtro_usuario = filtro_usuario..'<tr valign="top"><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td nowrap class="fieldLabel">Unidade de Negcio: </td><td>&nbsp;&nbsp;</td><td>'..uns..'</td></tr>'
   end

   if temConteudo( cgi.recebe_gerencia ) then
      cond_ger = ' a.ger_cod IN (' .. cgi.recebe_gerencia .. ') '
      gers = retornaSiglaGer (cgi.recebe_gerencia)
      filtro_usuario = filtro_usuario..'<tr valign="top"><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td class="fieldLabel">Gerncia: </td><td>&nbsp;&nbsp;</td><td>'..gers..'</td></tr>'
   end

   -- O JOIN entre as tabelas PROJETO e PROJ_OT soh eh feito se alguma classificacao/sub eh selecionada
   if temConteudo( cgi.recebe_classificacao ) then
      cond_class = ' f.clas_cod IN (' .. cgi.recebe_classificacao .. ') AND a.proj_cod = f.proj_cod '
      class = retornaClassificacao (cgi.recebe_classificacao)
      filtro_usuario = filtro_usuario..'<tr valign="top"><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td class="fieldLabel">Classificao: </td><td>&nbsp;&nbsp;</td><td>'..class..'</td></tr>'
   end
   if temConteudo( cgi.recebe_subclassificacao ) then
      cond_subclass = ' f.proj_ot_subcl_cod IN (' .. cgi.recebe_subclassificacao .. ') AND a.proj_cod = f.proj_cod '
      subclass = retornaClassificacao (cgi.recebe_subclassificacao)
      filtro_usuario = filtro_usuario..'<tr valign="top"><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td nowrap class="fieldLabel">Sub-classificao: </td><td>&nbsp;&nbsp;</td><td>'..subclass..'</td></tr>'
   end

   if temConteudo( cgi.class_acompanhamento ) then
      cond_class_acomp = ' a.proj_class IN (' .. cgi.class_acompanhamento .. ') '
      class_acompanhamento = gsub(cgi.class_acompanhamento, '1', 'I')
      class_acompanhamento = gsub(class_acompanhamento, '2', 'II')
      class_acompanhamento = gsub(class_acompanhamento, '3', 'III')
      filtro_usuario = filtro_usuario..'<tr valign="top"><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td class="fieldLabel">Classificao do Acompanhamento: </td><td>&nbsp;&nbsp;</td><td>'..class_acompanhamento..'</td></tr>'
   end

   cond = Concatena( cond, cond_ger )
   cond = Concatena( cond, cond_class )
   cond = Concatena( cond, cond_subclass )
   cond = Concatena( cond, cond_class_acomp )
   cond = Concatena( cond, cgi.status, ' a.stat_cod = ')
   if temConteudo(cgi.status) then
   	  status = retornaDescrStat ( cgi.status )
      filtro_usuario = filtro_usuario..'<tr valign="top"><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td class="fieldLabel">Situao: </td><td>&nbsp;&nbsp;</td><td>'..status..'</td></tr>'
   end
   cond = Concatena( cond, cgi.desempenho, ' a.proj_desempenho = ' )
   if temConteudo(cgi.desempenho) then
   	  desempenho = retornaDesempenho ( cgi.desempenho )
      filtro_usuario = filtro_usuario..'<tr valign="top"><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td class="fieldLabel">Desempenho: </td><td>&nbsp;&nbsp;</td><td>'..desempenho..'</td></tr>'
   end
   cond = Concatena( cond, cgi.prioridade, ' a.proj_prior = ', 'Prioridade: ' )
   cond = Concatena( cond, cgi.plano_rec, ' a.proj_plano_rec = ' )
   if temConteudo(cgi.plano_rec) then
      if tonumber(cgi.plano_rec) == 1 then
         filtro_usuario = filtro_usuario..'<tr valign="top"><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td class="fieldLabel">Plano de Recuperao: </td><td>&nbsp;&nbsp;</td><td>sim</td></tr>'
      else
         filtro_usuario = filtro_usuario..'<tr valign="top"><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td class="fieldLabel">Plano de Recuperao: </td><td>&nbsp;&nbsp;</td><td>no</td></tr>'
      end
   end
   cond = Concatena( cond, cgi.metas, ' a.proj_meta = ' )
   if temConteudo(cgi.metas) then
   	  metas = retornaMetasDescr ( cgi.metas )
      filtro_usuario = filtro_usuario..'<tr valign="top"><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td class="fieldLabel">Metas: </td><td>&nbsp;&nbsp;</td><td>'..metas..'</td></tr>'
   end

   if temConteudo( cgi.plano_dut ) then
      if tonumber(cgi.plano_dut) == 1 then
         cond_plano_dut = 'a.proj_paeid = 1'
         filtro_usuario = filtro_usuario..'<tr valign="top"><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td class="fieldLabel">Plano Emergencial de Integridade de Dutos: </td><td>&nbsp;&nbsp;</td><td>sim</td></tr>'
      elseif tonumber(cgi.plano_dut) == 0 then
         cond_plano_dut = '(a.proj_paeid = 0 OR a.proj_paeid IS NULL)'
         filtro_usuario = filtro_usuario..'<tr valign="top"><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td class="fieldLabel">Plano Emergencial de Integridade de Dutos: </td><td>&nbsp;&nbsp;</td><td>no</td></tr>'
      end
      cond = Concatena( cond, cond_plano_dut )
   end

   if temConteudo( cgi.cod_usuario ) then
      if ( cond ~= '' ) then
      	 cond = cond .. " AND a.proj_cod_usuario like '%" .. cgi.cod_usuario .. "%'"
      else
         cond = " a.proj_cod_usuario like '%" .. cgi.cod_usuario .. "%'"
      end
      filtro_usuario = filtro_usuario..'<tr valign="top"><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td class="fieldLabel">Cdigo do Projeto: </td><td>&nbsp;&nbsp;</td><td>'..cgi.cod_usuario..'</td></tr>'
   end

   if temConteudo( cgi.proj_nome ) then
      if ( cond ~= '' ) then
      	 cond = cond .. " AND a.proj_nome like '%" .. cgi.proj_nome .. "%'"
      else
         cond = " a.proj_nome like '%" .. cgi.proj_nome .. "%'"
      end
      filtro_usuario = filtro_usuario..'<tr valign="top"><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td class="fieldLabel">Projeto: </td><td>&nbsp;&nbsp;</td><td>'..cgi.proj_nome..'</td></tr>'
   end

   if temConteudo( cgi.proj_auditoria ) then
      if ( cond ~= '' ) then
      	 cond = cond .. " AND a.proj_aud = "..tonumber(cgi.proj_auditoria).." "
      else
         cond = " a.proj_aud = "..tonumber(cgi.proj_auditoria).." "
      end
      paud = {}
      paud['1'] = "Sim"
      paud['0'] = "No"
      filtro_usuario = filtro_usuario..'<tr valign="top"><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td class="fieldLabel">Projetos a serem auditatos: </td><td>&nbsp;&nbsp;</td><td>'..paud[cgi.proj_auditoria]..'</td></tr>'
   end

   dataip  = inclui_data(cgi.data_inicio_previsto)
   datatp  = inclui_data(cgi.data_termino_previsto)
   datair  = inclui_data(cgi.data_inicio_real)
   datatr  = inclui_data(cgi.data_termino_real)
   datafup = inclui_data(cgi.data_ultimo_followup)
   dataaud = inclui_data(cgi.data_auditoria)

   dataop1 = cgi.data_inicio_prev
   dataop2 = cgi.data_termino_prev
   dataop3 = cgi.data_in_real
   dataop4 = cgi.data_term_real
   dataop5 = cgi.data_ultimo_fup
   dataop6 = cgi.data_audi

   if temConteudo( dataip ) then
      if ( cond ~= '' ) then
         cond = cond .. ' AND a.proj_dt_ini_prev ' .. dataop1 .. ' \'' .. dataip .. '\''
      else
         cond = ' a.proj_dt_ini_prev ' .. dataop1 .. ' \'' .. dataip .. '\''
      end
      filtro_usuario = filtro_usuario..'<tr valign="top"><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td class="fieldLabel">Data de Incio Previsto: </td><td>&nbsp;&nbsp;</td><td>'..dataop1..' '..cgi.data_inicio_previsto..'</td></tr>'
   end
   if temConteudo( datatp ) then
      if ( cond ~= '' ) then
         cond = cond .. ' AND a.proj_dt_fim_prev ' .. dataop2 .. ' \'' ..  datatp .. '\''
      else
         cond = ' a.proj_dt_fim_prev ' .. dataop2 .. ' \'' .. datatp .. '\''
      end
      filtro_usuario = filtro_usuario..'<tr valign="top"><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td class="fieldLabel">Data de Trmino Previsto: </td><td>&nbsp;&nbsp;</td><td>'..dataop2..' '..cgi.data_termino_previsto..'</td></tr>'
   end
   if temConteudo( datair ) then
      if ( cond ~= '' ) then
         cond = cond .. ' AND a.proj_dt_ini_real ' .. dataop3 .. '\'' .. datair .. '\''
      else
         cond = ' a.proj_dt_ini_real ' .. dataop3 .. ' \'' ..  datair .. '\''
      end
      filtro_usuario = filtro_usuario..'<tr valign="top"><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td class="fieldLabel">Data de Incio Realizado: </td><td>&nbsp;&nbsp;</td><td>'..dataop3..' '..cgi.data_inicio_real..'</td></tr>'
   end
   if temConteudo( datatr ) then
      if ( cond ~= '' ) then
         cond = cond .. ' AND a.proj_dt_fim_real ' .. dataop4 .. ' \'' .. datatr .. '\''
      else
         cond = ' a.proj_dt_fim_real ' .. dataop4 .. ' \'' .. datatr .. '\''
      end
      filtro_usuario = filtro_usuario..'<tr valign="top"><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td class="fieldLabel">Data de Trmino Realizado: </td><td>&nbsp;&nbsp;</td><td>'..dataop4..' '..cgi.data_termino_real..'</td></tr>'
   end
   -- -------------------------------------------------------------------------------------------------------
   -- Se alguma data foi informada pelo usuario como FILTRO para o ultimo FOLLOW-UP, entao soh devem entrar
   -- projetos com entradas para FOLLOW-UP (a.proj_cod = fup_proj_cod)
   -- -------------------------------------------------------------------------------------------------------
   if temConteudo( datafup ) then
      if ( cond ~= '' ) then
         cond = cond .. ' AND fup_data ' .. dataop5 .. ' \'' .. datafup .. '\' AND a.proj_cod = fup_proj_cod '
      else
         cond = ' fup_data ' .. dataop5 .. ' \'' .. datafup .. '\' AND a.proj_cod = fup_proj_cod '
      end
      filtro_usuario = filtro_usuario..'<tr valign="top"><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td class="fieldLabel">Data do ltimo Follow-up: </td><td>&nbsp;&nbsp;</td><td>'..dataop5..' '..cgi.data_ultimo_followup..'</td></tr>'
   end

   if temConteudo( dataaud ) then
      if ( cond ~= '' ) then
         cond = cond .. ' AND au.aud_data ' .. dataop6 .. ' \'' .. dataaud .. '\' AND a.proj_cod = au.proj_cod '
      else
         cond = ' au.aud_data ' .. dataop6 .. ' \'' .. dataaud .. '\' AND a.proj_cod = au.proj_cod '
      end
      filtro_usuario = filtro_usuario..'<tr valign="top"><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td class="fieldLabel">Data de Auditoria: </td><td>&nbsp;&nbsp;</td><td>'..dataop6..' '..cgi.data_auditoria..'</td></tr>'
   end

   if temConteudo( cgi.estado_un ) then
      cond_est = "a.proj_est_un = '"..cgi.estado_un.."'"
      filtro_usuario = filtro_usuario..'<tr valign="top"><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td class="fieldLabel">Estado: </td><td>&nbsp;&nbsp;</td><td>'..cgi.estado_un..'</td></tr>'
      cond = Concatena( cond, cond_est )
   end

   if temConteudo( cgi.funcao_un ) then
      cond_funcao = "a.proj_funcao_un = '"..cgi.funcao_un.."'"
      if cgi.funcao_un == "s" then
         funcao = "Segurana "
      else
         funcao = "Meio Ambiente "
      end
      filtro_usuario = filtro_usuario..'<tr valign="top"><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td class="fieldLabel">Natureza do Projeto: </td><td>&nbsp;&nbsp;</td><td>'..funcao..'</td></tr>'
      cond = Concatena( cond, cond_funcao )
   end

   if temConteudo( cgi.tipo_un ) then
       cond_tipo = "a.proj_tipo_un = '"..cgi.tipo_un.."'"
       if cgi.tipo_un == "p" then
          tip = "Preventiva"
       else
          tip = "Corretiva"
       end
       filtro_usuario = filtro_usuario..'<tr valign="top"><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td class="fieldLabel">Tipo de Ao: </td><td>&nbsp;&nbsp;</td><td>'..tip..'</td></tr>'
       cond = Concatena( cond, cond_tipo )

   end

   -- ---------------------------------------------------------------------------------------
   -- Monta QUERY para consulta/relatorio
   -- ---------------------------------------------------------------------------------------
   if ( ( cgi.acao == "Consulta" ) or ( cgi.acao == "Grava Consulta" ) ) then
      cgilua.htmlheader()

      -- Recebe 1 se COND tiver algum valor ou se for selecionado CONSOLIDACAO
      flag_grava = 0

      -- ------------------------------------------------------------------------------------
      -- Soh soh faz sentido se estiver em consulta, as restricoes de PERMISSAO DE ACESSO
      -- devem ser respeitadas quando se estah nos modulos de consulta
      -- ------------------------------------------------------------------------------------
      if temConteudo( associacao ) then
         cond = Concatena(cond, cond_org_unid)
      elseif not(temConteudo( associacao ) ) then
         cond = Concatena(cond, cond_org)
         cond = Concatena(cond, cond_unid)
      end

      if temConteudo(cond) then
         flag_grava = 1
      end

      titulo = {}
      titulo['relatorio'] = 'Relatrio de Projetos - Resultado'
      titulo['consulta']  = 'Consulta de Projetos - Resultado'

      nome = {}
      nome['relatorio'] = 'Nome do Relatrio: '
      nome['consulta']  = 'Nome da Consulta: '

      msg_sucesso = {}
      msg_sucesso['relatorio'] = 'Relatrio Gravado.'
      msg_sucesso['consulta']  = 'Consulta Gravada.'

      msg_repetida = {}
      msg_repetida['relatorio'] = 'Voc j possui um relatrio com este nome.'
      msg_repetida['consulta']  = 'Voc j possui uma consulta com este nome.'

      msg_condicao = {}
      msg_condicao['relatorio'] = 'No  possvel gravar o relatrio pois nenhuma condio foi definida.'
      msg_condicao['consulta']  = 'No  possvel gravar a consulta pois nenhuma condio foi definida.'

      write('<HTML>\n')
      write('<HEAD>\n')
      write('<LINK REL="stylesheet" HREF="../pegaso.css" TYPE="text/css">\n')
      write('<TITLE>Resultado do Relatrio</TITLE>\n')

      write('<SCRIPT LANGUAGE="JavaScript">\n')
      write('var alerta = window.open("../aviso_carregando.html?acao=Filtro","aviso_carregando","toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=no,width=600,height=10");')
      write('var selecionado = null;\n')
      write('function Over(nome)\n')
      write('{\n')
      write('   if (selecionado != null)\n')
      write('   {\n')
      write('      Out(selecionado);\n')
      write('   }\n')
      write('   document[nome].src="../imagens/" + nome + "2.gif";\n')
      write('}\n')
      write('function Out(nome)\n')
      write('{\n')
      write('   if (nome != selecionado)\n')
      write('   {\n')
      write('      document[nome].src="../imagens/" + nome + ".gif";\n')
      write('   }\n')
      write('}\n')
      write('</SCRIPT>\n')

      write('</HEAD>\n')
      write('<BODY BACKGROUND="../imagens/moldura_princ.gif" onLoad="alerta.close();">\n')
      write('<FORM NAME="form1" ACTION="grava_filtro_projetos.lua">\n\n')

      if ( cgi.acao == "Grava Consulta" ) then
         dofile( 'grava_cons_perso.lua' )
         cons_gravada = grava_cons_perso()
      end
      campo, valor = next( cgi, nil )
      while campo do
         if ( campo ~= 'nome_cons_perso' ) then
            write('<INPUT TYPE="HIDDEN" NAME="' .. campo .. '" VALUE="' .. valor .. '">\n')
         end
         campo, valor = next( cgi, campo )
      end

      cgi.pagina = 'result_consulta.html'
      temp = {}

      campos  = "SELECT DISTINCT a.proj_cod, a.proj_nome, a.proj_class, a.org_cod, a.unid_cod, a.ger_cod, a.stat_cod, "..
                "a.proj_prior, a.proj_plano_rec, a.proj_cod_usuario, a.proj_dt_ini_prev, a.proj_dt_fim_prev, "..
                "a.proj_dt_ini_real, a.proj_dt_fim_real, a.proj_desempenho, a.proj_perc_financeiro_realizado, "..
                "a.proj_perc_financeiro_esperado, a.last_fup_cod, "..
                "b.org_sigla, b.org_nome, c.unid_sigla, c.unid_nome, d.desempenho_descr, e.stat_descr "
      tabelas = "FROM projeto a, orgao b, unidade c, desempenho d, status e "

      if temConteudo( datafup ) then
      	 tabelas = tabelas .. ", follow_up "
      end
      if temConteudo( cgi.recebe_classificacao ) or temConteudo( cgi.recebe_subclassificacao ) then
      	 tabelas = tabelas .. ", proj_ot f "
      end

      if temConteudo( dataaud ) then
      	 tabelas = tabelas .. ", auditoria au "
      end
      -- ----------------------------------------------------------------------------------------------
      -- O JOIN entre as tabelas PROJETO e DESEMPENHO eh feito com '*=' mas nao haveria problema se
      -- fosse utilizado '=' pois o valor default para PROJ_DESEMPENHO na tabela PROJETO eh '0', ou
      -- seja, todos os projetos apresentam algum valor (pelo menos 0) no campo PROJ_DESEMPENHO
      -- ----------------------------------------------------------------------------------------------
      cond_fixa  = "WHERE a.last_versao = 's' AND a.org_cod = b.org_cod AND a.unid_cod *= c.unid_cod AND "..
                   "a.proj_desempenho *= d.desempenho_cod AND a.stat_cod = e.stat_cod "

      -- --------------------------------------------------------------------------------------------------------
      -- Verificacoes necessarias para saber se o projeto foi CONSOLIDADO ou NAO
      -- --------------------------------------------------------------------------------------------------------
      if temConteudo(cgi.consolidado) then
      	 flag_grava = 1
      	 DBExec(" SELECT MAX(cons_cod) as cons_cod FROM consolidacao ")
         aux = DBRow()
         if aux and aux.cons_cod then
      	    -- projetos CONSOLIDADOS
      	    -- projetos que tiveram as informacoes APROVADAS pelas ANs e ESTAO na tabela de consolidacaoProjeto
            if tonumber(cgi.consolidado) == 1 then
               tabelas   = tabelas .. ",  consolidacaoUnidade g, consolidacaoProjeto h "
               cond_fixa = cond_fixa .. " AND g.cons_cod = "..aux.cons_cod.." AND h.cons_cod = "..aux.cons_cod..
                                        " AND g.aprovada = 1 AND h.unid_cod = g.unid_cod AND a.proj_sigla = h.proj_sigla"..
                                        " AND g.seqTentativa = (select max(seqTentativa) from consolidacaoUnidade where"..
                                        " cons_cod = "..aux.cons_cod.." and unid_cod = g.unid_cod) "

            -- projetos NOVOS (segundo a matriz IV)
            -- projeto que tem a data de inclusao maior que a data da consolidacao da AN e que nao seja versao de nenhum outro projeto
            -- ------------------------------------------------------------------------------------------------------------------------
            -- se a UN do projeto nao entrou ainda na consolidacao, mesmo q o projeto seja novo (proj_versao = 0 e last_versao = 's'),
            -- ele nao seria recuperado pela QUERY, por isso foi incluida a clausula contida depois do OR.
            -- ------------------------------------------------------------------------------------------------------------------------
            elseif tonumber(cgi.consolidado) == 0 then
               tabelas   = tabelas .. ",  consolidacaoUnidade g "
               cond_fixa = cond_fixa .. " AND a.proj_versao = 0 AND ( (a.unid_cod = g.unid_cod AND g.cons_cod = "..
                                        aux.cons_cod.." AND a.proj_dt_incl > g.cons_dt_real AND g.aprovada = 1 "..
                                        "AND g.seqTentativa = (select max(seqTentativa) from consolidacaoUnidade where "..
                                        "cons_cod = "..aux.cons_cod.." and unid_cod = g.unid_cod)) OR (a.unid_cod not in "..
                                        "(select unid_cod from consolidacaoUnidade where cons_cod = "..aux.cons_cod..")) ) "

            end
         end
         if tonumber(cgi.consolidado) == 1 then
            filtro_usuario = filtro_usuario..'<tr valign="top"><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td class="fieldLabel">Projeto Consolidado: </td><td>&nbsp;&nbsp;</td><td>sim</td></tr>'
         else
            filtro_usuario = filtro_usuario..'<tr valign="top"><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td class="fieldLabel">Projeto Consolidado: </td><td>&nbsp;&nbsp;</td><td>no</td></tr>'
         end
      end

      if cgi.tipo_servico == 'consulta' then
         ordem = " ORDER BY  b.org_sigla, c.unid_sigla , e.stat_descr , a.proj_nome "
      elseif cgi.tipo_servico == 'relatorio' then
         ordem = " ORDER BY a.proj_nome, b.org_sigla, c.unid_sigla, e.stat_descr "
      end

      cond_fixa = Concatena(cond_fixa, cond)

      str = campos..tabelas..cond_fixa..ordem

      if ESTADO_BD ~= 'aberto' then
         AbreBD()
      end
      proj_inter = {}
      var_proj_cod = ''
      DBExec(str)
      temp = DBRow()

      i = 1
      while ( temp and temp.proj_cod ) do
         proj_inter[i] = temp
         if var_proj_cod ~= '' then
            var_proj_cod = var_proj_cod..','
         end
         var_proj_cod = var_proj_cod..temp.proj_cod

         temp = DBRow()
         i = i + 1
     end
     cont_proj = i - 1

      -- -------------------------------------------------------------------------------------------
      -- Se var_proj_cod for um valor muito grande, ocorrerao erros na passagem de CGI e pra gravar
      -- no banco, portanto, se isso acontecer o que eh passado pro script de gravacao eh a query
      -- -------------------------------------------------------------------------------------------
      -- Se o usuario tiver selecionado
      -- -------------------------------------------------------------------------------------------
      if flag_grava == 1 then
         -- tamanho da string que armazena os codigos de projeto
         tamanho = strlen(var_proj_cod)
         -- O elemento da comparacao diz respeito ao tamanho do CGI passado por parametro
         if tamanho > _TAM_CGI_ then
            write('<INPUT TYPE="hidden" NAME="var_proj_query" VALUE="',str,'">')
         else
            write('<INPUT TYPE="hidden" NAME="var_proj_cod" VALUE="',var_proj_cod,'">')
         end
      end

      if temConteudo(cgi.recebe_informacoes) then
         write('<INPUT TYPE="hidden" NAME="informacoes" VALUE="',cgi.recebe_informacoes,'">')
      end
      write('<FONT class=pageTitle><center>'..titulo[cgi.tipo_servico]..'</center></FONT>\n')

      if temConteudo(filtro_usuario) then
      	 filtro_usuario = '<table border="0"><caption align="top" class="tableHeader">Filtro do Usurio</caption>'..filtro_usuario..'</table>\n<hr width=98%><br>\n'
      end

      if ( not( temConteudo(var_proj_cod) ) ) then
         write('<HR WIDTH=98%><BR>\n')
         write(filtro_usuario)
         write('<FONT class=fieldLabel><center> Nenhum projeto satisfaz tais condies.</center></FONT><BR><BR>' )

      else

         -- Imprime o resultado da consulta/relatorio
         listaResultado( proj_inter, var_proj_cod, cont_proj, 30, filtro_usuario )
         write('<BR><CENTER>')
         if ( cons_gravada ~= 1 ) and
            ( flag_grava == 1 and ( cond ~= cond_org or (cond == cond_org and temConteudo(cgi.recebe_orgao)) ) ) then
            write('<HR WIDTH=98%><BR>\n')
            write('<TABLE border="0"><TR><TD><B>'..nome[cgi.tipo_servico]..'</B></TD><td><INPUT TYPE="TEXT" NAME="nome_cons_perso"></td></TR><TR><TD colspan="2">&nbsp;</TD></TR>\n')
            write('<TR><TD><B>Nome da Lista: </B></TD><td><INPUT TYPE="TEXT" NAME="nome_lista_perso"></TD></TR>\n')
            write('<TR><TD colspan="2">&nbsp;</TD></TR></TABLE>\n')
            write([[<A HREF="javascript:document.form1.acao.value='Grava Consulta'; javascript:document.form1.submit();" OnMouseOver="Over('bot-grav');" OnMouseOut="Out('bot-grav');" ONCLICK="document.form1.acao.value='Grava Consulta';"><IMG SRC="../imagens/bot-grav.gif" BORDER="0" NAME="bot-grav"></A>]])
         elseif (not( temConteudo(cond) ) or ( cond == cond_org )) then
            if cgi.tipo_servico == 'consulta' then
               write('<HR WIDTH=98%><BR>\n')
            end
            write('<BR><FONT class=fieldLabel><center>'..msg_condicao[cgi.tipo_servico]..'</center></FONT><BR><BR>' )
         end

         write('</FORM>\n')
         write('<FORM NAME="FORM2" ACTION="../filtro_projetos.html">\n')
      end

      if ( cons_gravada == 0 )then
         write('<FONT class=msgErro><CENTER>'..msg_repetida[cgi.tipo_servico]..'</FONT><BR>\n')
         write('<BR>')
      elseif ( cons_gravada == 1 ) then
         write('<FONT class=fieldLabel><CENTER>'..msg_sucesso[cgi.tipo_servico]..'</FONT><BR>\n')
         write('<BR>')
      elseif ( cons_gravada == 2 )then
         write('<FONT class=msgErro><CENTER>No foi informado nenhum nome para gravar.</FONT><BR>\n')
         write('<BR>')
      end

      write([[<center><A HREF="javascript:history.back();" OnMouseOver="Over('bot-voltar');" OnMouseOut="Out('bot-voltar');"><IMG SRC="../imagens/bot-voltar.gif" BORDER="0" NAME="bot-voltar"></A></center>]])
      write('</FORM>\n</CENTER>\n')
      write('</BODY>\n')
      write('</HTML>\n')
      if ESTADO_BD == 'aberto' then
         FechaBD()
      end

   -- ---------------------------------------------------------------------------------------
   -- Se a ACAO nao corresponder a uma consulta/relatorio, redireciona para VISUALIZA.HTML
   -- ---------------------------------------------------------------------------------------
   else
      if ESTADO_BD == 'aberto' then
         FechaBD()
      end

      -- ------------------------------------------------------------------------------------------
      -- Evita que as restricoes impostas pela PERMISSAO DE ACESSO do usuario nao permitam com que
      -- ele nao acesse todos os projetos que ele cadastrou ou nos quais consta como colaborador
      -- quando sua permissao de acesso a AN/UN tiver sido alterada
      -- Soh soh faz sentido se nao for CONSULTA (formalizacao, cancelamento, conclusao etc)
      -- ------------------------------------------------------------------------------------------
      cond = Concatena(cond, cond_org)
      cond = Concatena(cond, cond_unid)

      if not( temConteudo(cgi.tipo_edi) ) then
         parametro = cgilua.encodetable({cond_filtro=cond, tipo_servico=cgi.tipo_servico})
      else
         parametro = cgilua.encodetable({cond_filtro=cond, tipo_servico=cgi.tipo_servico, tipo_edi=cgi.tipo_edi})
      end

      if cgi.tipo_servico == "auditoria" then
         cgilua.redirect('../auditoria.html?'..parametro)
      else
         cgilua.redirect('../visualiza.html?'..parametro) -- VOLTA PARA A PGINA html
      end
   end

end