-- -------------------------------------------------------------------------------------------------
-- FOLLOW_UP_OFFLINE.LUA
-- -------------------------------------------------------------------------------------------------
-- Todos os dias o sistema irah consultar os projetos em ACOMPANHAMENTO e com frequencia de follow
-- up cadastrada (proj_freq <> 0) e verificar se o numero de dias (proj_cont_fup) que o projeto nao 
-- foi "acompanhado" ultrapassa o valor permitido (proj_freq), enviando e-mails para os usuarios
-- interessados
-- -------------------------------------------------------------------------------------------------
-- A cada nova atualizacao do projeto, o campo proj_cont_fup eh zerado
-- O campo proj_cont_fup contabiliza o numero de dias que o projeto nao foi "acompanhado"
-- -------------------------------------------------------------------------------------------------
-- $Revision:$
--
-- $Update Date:$ $NoKeywords:$
-- 
-- Copyright by TeCGraf (PUC-RIO)
-- -------------------------------------------------------------------------------------------------  
 --  assert( dofile( 'global.lua' ) ) 
 --  assert( dofile( 'constantes.lua' ) )
 --  assert( dofile( 'acessabd.lua' ) )
   
-- -------------------------------------------------------------------------------------------------
-- Abre conexao com o Banco de Dados
-- -------------------------------------------------------------------------------------------------   
   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end   

-- -------------------------------------------------------------------------------------------------
-- Funcao pra retornar o e-mail do usuario, dado a sua chave na tabela de pessoal (pes_chave)
-- -------------------------------------------------------------------------------------------------      
   function retornaEmail(chave)      
      DBExec(" SELECT pes_email FROM pessoal WHERE pes_chave = '"..chave.."' ")
      local temp = DBRow()
      if temp and temp.pes_email then
         return temp.pes_email   
      else
         return nil   
      end
   end
   
-- -------------------------------------------------------------------------------------------------
-- Funcao pra retornar os e-mails relacionados as chaves definidas em uma tabela LUA (constantes.lua)
-- a partir da tabela de pessoal (pes_chave)
-- -------------------------------------------------------------------------------------------------      
   function retornaEmails(chaves)      
      local campo = next(chaves, nil)                       -- captura primeiro campo da tabela
      while campo do
         local valor = retornaEmail(campo)
         if temConteudo (valor) then                        -- enquanto existir campo...      
            if temConteudo(emails_gestao) then
               emails_gestao = emails_gestao..', '..valor  
            else
               emails_gestao = valor   
            end 
         end     
         campo = next(chaves, campo)                        -- captura proximo campo da tabela
      end 
      if temConteudo(emails_gestao) then
         return emails_gestao   
      else
         return nil   
      end       
   end
   
-- -------------------------------------------------------------------------------------------------
-- DEFININDO VALORES
-- -------------------------------------------------------------------------------------------------    
   programa    = {}
   programa[0] = 'PEGASO'   
   programa[1] = 'Emergencial de Integridade de Dutos'  
   
   telefone    = {}
   telefone[0] = '(21) 2534 - 7814'        -- Grupo de Gestao do Programa PEGASO
   telefone[1] = '(21) 2534 - 4115 / 6036' -- Programa Emergencial de Integridade de Dutos   

-- -------------------------------------------------------------------------------------------------
-- DEFININDO DATAS
-- -------------------------------------------------------------------------------------------------
-- Retorna o dia da semana a partir da data de hoje.
-- Domingo = 0, Segunda = 1, Tera = 2, Quarta = 3, Quinta = 4, Sexta = 5 e Sbado = 6   
-- -------------------------------------------------------------------------------------------------         
   dia  = date('%w')
   
-- -------------------------------------------------------------------------------------------------
-- Retorna o dia de hoje no formato AAAAMMDD 
-- -------------------------------------------------------------------------------------------------            
   hoje = date('%Y%m%d')

-- -------------------------------------------------------------------------------------------------
-- Descobre o e-mail do Coordenador do PEGASO
-- -------------------------------------------------------------------------------------------------
   coord_pegaso = retornaEmail(_CHAVE_COORDENADOR_PEGASO_)
           
-- -------------------------------------------------------------------------------------------------
-- Descobre os e-mails associados ao Grupo de Gestao do PEGASO
-- -------------------------------------------------------------------------------------------------
   gestao_pegaso = retornaEmails(_CHAVES_GESTAO_PEGASO_)
   
-- -------------------------------------------------------------------------------------------------
-- Descobre o e-mail do Grupo de Gestao do PEGASO que serah a origem dos e-mails
-- -------------------------------------------------------------------------------------------------    
   origem_gestao_pegaso = retornaEmail(_CHAVE_RESP_GESTAO_PEGASO_)  
   
-- -------------------------------------------------------------------------------------------------
-- Descobre o e-mail do Grupo de Gestao do Programa Emergencial de Integridade de Dutos
-- -------------------------------------------------------------------------------------------------
   gestao_paeid = retornaEmails(_CHAVES_GESTAO_PAEID_)  
  
-- -------------------------------------------------------------------------------------------------
-- Descobre o e-mail do Grupo de Gestao do Programa Emergencial de Integridade de Dutos que serah 
-- a origem dos e-mails
-- -------------------------------------------------------------------------------------------------    
   origem_gestao_paeid = retornaEmail(_CHAVE_RESP_GESTAO_PAEID_) 
     
-- -------------------------------------------------------------------------------------------------
-- Atualiza para 0 (zero) o campo PROJ_CONT_FUP de todos os projetos onde for NULL
-- -------------------------------------------------------------------------------------------------      
   sql = ' UPDATE projeto set proj_cont_fup = 0 WHERE proj_cont_fup IS NULL '
   DBExec(sql)
   
-- -------------------------------------------------------------------------------------------------
-- Atualiza para 0 (zero) o campo PROJ_PAEID de todos os projetos onde for NULL
-- -------------------------------------------------------------------------------------------------      
   sql = ' UPDATE projeto set proj_paeid = 0 WHERE proj_paeid IS NULL '
   DBExec(sql)   


-- -------------------------------------------------------------------------------------------------
-- Se nao eh SABADO (6) nem DOMINGO (0)
-- -------------------------------------------------------------------------------------------------
   if tonumber(dia) ~= 0 and tonumber(dia) ~= 6 then   
      -- ----------------------------------------------------------------------------------------------
      -- Seleciona todas os projetos cujo STAT_COD seja 2 (ANDAMENTO) e a frequencia de FOLLOW-UP seja
      -- diferente de 0.
      -- ----------------------------------------------------------------------------------------------
         sql_select = [[ 
                         SELECT proj_cod AS cod, proj_nome AS nome, proj_freq AS freq, proj_cont_fup AS cont_fup,
                         proj_paeid AS paeid, proj_coord AS coord, pes_email AS email FROM projeto, pessoal  
                         WHERE last_versao ='s' AND proj_freq <> 0 AND stat_cod = 2 AND pes_chave = proj_coord
                         ORDER BY proj_cod 
                      ]]
         
      DBExec(sql_select)
           
      proj = DBRow()            
   
      write('<font color="blue"><b>A verificao do acompanhamento (<i>follow-up</i>) dos projetos foi efetuada com sucesso em '..formataData2( hoje )..'.</b></font><br>')      
      
      -- -------------------------------------------------------------------------------------
      -- ENVIANDO E-MAILs ...
      -- -------------------------------------------------------------------------------------          
      while proj do
      -- -------------------------------------------------------------------------------------
      -- Atualiza o campo PROJ_CONT_FUP para fazer as comparacoes (o valor desse campo serah 
      -- atualizado na tabela de PROJETOS posteriormente)
      -- -------------------------------------------------------------------------------------                     
         proj.cont_fup = proj.cont_fup + 1
             
      -- -------------------------------------------------------------------------------------
      -- Envia o e-mail tendo como endereco de destino o COORDENADOR do projeto
      -- -------------------------------------------------------------------------------------         
         if temConteudo(proj.email) then          
            destino = proj.email           -- responsvel pelo projeto            
         end 
       
         titulo   = 'Notificacao de Acompanhamento de Follow-Up: projeto '.. proj.nome ..' ['..formataData2( hoje )..']' 
         mensagem = [[
                        Srs,
                        
                        Solicitamos que os dados de acompanhamento do projeto "]]..proj.nome..[["
                        referente ao Programa ]]..programa[proj.paeid]..[[, sejam atualizados 
                        com a finalidade de dar andamento  consolidao dos resultados do programa.
                        
                        Em caso de dvidas, entrar em contato com o grupo de gesto no 
                        telefone ]]..telefone[proj.paeid]..[[.
                    ]]            
            
      -- --------------------------------------------------------------------------------------
      -- Se o contador de FOLLOW-UP (proj_cont_fup) for maior do que a frequencia de FOLLOW-UP
      -- e menor ou igual do que duas vezes o valor da frequencia, enviar a seguinte mensagem:
      -- --------------------------------------------------------------------------------------    	           
         if proj.cont_fup > proj.freq and proj.cont_fup <= (2 * proj.freq) then
         -- se pertence ao PROGRAMA EMERGENCIAL DE INTEGRIDADE DE DUTOS (paeid = 1)                    	           	  
            if proj.paeid == 1 then 
            -- grupo de gesto do PROGRAMA EMERGENCIAL DE INTEGRIDADE DE DUTOS                  	           
               copia  = gestao_paeid       
               origem = origem_gestao_paeid       
            else 
            -- grupo de gesto do PEGASO          
               copia  = gestao_pegaso                                 
               origem = origem_gestao_pegaso                        
            end  
            
            -- Chama a funo de envio de e-mail (envia_mail()) atraves da funo ENVIA_EMAIL definida
            -- em CONSTANTES.LUA
            local ok, msgerr =  ENVIA_EMAIL(destino, origem, titulo, mensagem, copia)
            
            if not ok then      
               if msgerr then	
                  if temConteudo(destino) then 	
                     write('<br><br><font color="red"><i>Os e-mails de notificao referentes ao projeto <b>'..proj.nome..'</b> (coordenador: '..proj.coord..') no puderam ser enviados (<b>'..msgerr..'</b>).</i>,</font>')
                  else
                     write('<br><br><font color="red"><i>Os e-mails de notificao referentes ao projeto <b>'..proj.nome..'</b> (coordenador: '..proj.coord..') no puderam ser enviados. O e-mail do coordenador do projeto no consta na base de dados.</i></font>')   
                  end   
               end   
            else 
               write('<br><br><font color="blue"><i>Os e-mails de notificao referentes ao projeto <b>'..proj.nome..'</b> (coordenador: '..proj.coord..') foram enviados com sucesso!</i></font>')
            end                                  
   
      -- --------------------------------------------------------------------------------------
      -- Se o contador de FOLLOW-UP (proj_cont_fup) for maior do que duas vezes o valor da 
      -- frequencia, enviar a seguinte mensagem:
      -- --------------------------------------------------------------------------------------    	           
         elseif proj.cont_fup > (2 * proj.freq) then		  	        	  
         -- se pertence ao PROGRAMA EMERGENCIAL DE INTEGRIDADE DE DUTOS (paeid = 1)       	            
            if proj.paeid == 1 then   
               -- grupo de gesto do PROGRAMA EMERGENCIAL DE INTEGRIDADE DE DUTOS
                  copia  = gestao_paeid
                  origem = origem_gestao_paeid
            else 
               -- grupo de gesto e o coordenador do PEGASO
                  copia  = gestao_pegaso .. ', ' ..  coord_pegaso
                  origem = origem_gestao_pegaso      
            end	
            
            -- Chama a funo de envio de e-mail (envia_mail()) atraves da funo ENVIA_EMAIL definida
            -- em CONSTANTES.LUA
            local ok, msgerr =  ENVIA_EMAIL(destino, origem, titulo, mensagem, copia)
               
            if not ok then      
               if msgerr then	
                  if temConteudo(destino) then 	
                     write('<br><br><font color="red"><i>Os e-mails de notificao referentes ao projeto <b>'..proj.nome..'</b> (coordenador: '..proj.coord..') no puderam ser enviados (<b>'..msgerr..'</b>).</i></font>')
                  else
                     write('<br><br><font color="red"><i>Os e-mails de notificao referentes ao projeto <b>'..proj.nome..'</b> (coordenador: '..proj.coord..') no puderam ser enviados. O e-mail do coordenador do projeto no consta na base de dados.</i></font>')   
                  end   
               end   
            else 
               write('<br><br><font color="blue"><i>Os e-mails de notificao referentes ao projeto <b>'..proj.nome..'</b> (coordenador: '..proj.coord..') foram enviados com sucesso!</i></font>')
            end                                                                        
         	         	   	           	      	         	     	     
      -- --------------------------------------------------------------------------------------
      -- Se o contador de FOLLOW-UP (proj_cont_fup) for menor do que o valor da frequencia, 
      -- nenhuma mensagem dever ser enviada.
      -- --------------------------------------------------------------------------------------       	                        
         end                    	         	         	                                                 
         
         if temConteudo(projetos) then 
            projetos = projetos..','..proj.cod 
         else
            projetos = proj.cod 
         end
                  
         proj = DBRow()                  
                            
      end  -- WHILE proj
      
      -- ---------------------------------------------------------------------------------------------
      -- Atualiza o campo PROJ_CONT_FUP de todos os projetos (0 - domingo, 6 - sabado)
      -- ---------------------------------------------------------------------------------------------     
         if temConteudo(projetos) then         
            DBExec(' UPDATE projeto set proj_cont_fup = proj_cont_fup + 1 WHERE proj_cod IN ('..projetos..') ')             
         end
         
end   -- IF dia da semana