-- ---------------------------------------------------------------------------------------
-- FORM_ACOMPANHA.LUA
-- ---------------------------------------------------------------------------------------
assert(dofile("global.lua"))

if temConteudo(cgi.DataInicioReal) then
   dt_proj_ini = inclui_data(cgi.DataInicioReal)
   mensagem = 'data de incio real do projeto ('..cgi.DataInicioReal..')'
else   
   dt_proj_ini = _DATA_INI_PEGASO_
   mensagem    = _DATA_INI_PEGASO_DESC_
end   

-- --------------------------------------------------------------------------------------------
-- MONTANDO A ESTRUTURA DE UM CAMPO VETOR ATRAVS DE SEUS ELEMENTOS
-- --------------------------------------------------------------------------------------------
elementos =
{
       CampoData:new 
       {
          'Data prevista para o Inicio', "dt_ini_real", nil,
          { 
             limite = 
             { 
                ['>='] = 
                { 
                   valor = _DATA_INI_PEGASO_, nome = _DATA_INI_PEGASO_DESC_
                },

                ['<='] = 
                { 
                   valor = _DATA_FIM_PEGASO_, nome = _DATA_FIM_PEGASO_DESC_
                } 
             } 
          }, nil, cgi.dt_ini_real, "texto" 
	     }, 
	    
       CampoData:new 
       {
          'Data prevista para o fim', "dt_fim_real", nil,
          { 
             limite = 
             { 
                ['>='] = 
                { 
                   nome = _DATA_INI_PEGASO_DESC_, valor = _DATA_INI_PEGASO_
                },

                ['<='] = 
                { 
                   nome = _DATA_FIM_PEGASO_DESC_, valor = _DATA_FIM_PEGASO_
                } 
             } 
          }, nil, cgi.dt_fim_real, "texto" 
	    }, 	    
	    
      CampoInteiro:new 
      {
         'Percentual Real', "perc_real",nil,
         {
            limite = 
            {
               ['>='] = {valor = 0}, ['<='] = {valor = 100}
            },
         },nil,nil,cgi.perc_real	    
      }  
}

--Representao do campo insumo como um campo composto
valores = CampoComposto:new { 'Tarefa', "tarefa", nil, 
{ subconjunto = "#indeterminado", 
  tamanho = { ['>='] = 0} }, 
  'local', 2, 
  elementos 
}

-- --------------------------------------------------------------------------------------------
-- FORMULARIO
-- --------------------------------------------------------------------------------------------
form_acompanha = Formulario:new
{{  

   CampoData:new 
   {
      'Data Incio Real','DataInicioReal',nil,
      { 
         limite = 
         { 
            ['<='] = 
            { 
               nome = 'data de hoje', valor = date("%Y%m%d"),            
            }, 
            ['>='] = 
            {
               nome = 'data de Incio do Pegaso('.._DATA_INI_PREV_PEGASO_..')', valor = _DATA_INI_PEGASO_
            }  
          } 
       },nil,
       cgi.DataInicioReal,"texto"
    },

   CampoData:new 
   {
      'Data Fim Real','DataFimReal',nil,
      { 
         limite = 
         { 
            ['<='] = 
            { 
               nome = 'data de hoje', valor = date("%Y%m%d"),
            },
            ['>='] = 
            { 
               nome = mensagem, valor = dt_proj_ini,
            },            
          } 
       },nil,
       cgi.DataFimReal,"texto"
    },   
    
   -- Data de inclusao do CUSTO REALIZADO 
   CampoData:new 
   {
      'Data Incluso','data_inclusao',nil,
      { 
         limite = 
         { 
            ['<='] = 
            { 
               nome = 'data de hoje', valor = date("%Y%m%d"),
            
            }, 
            ['>='] = 
            {               
               nome = _DATA_INI_PEGASO_DESC_, valor = _DATA_INI_PEGASO_
            }  
          } 
       },nil,
       cgi.data_inclusao,"texto"
    },     
         	   	
    CampoReal:new 
    {
        'Custo realizado', 'custoReal', nil
           -- O campo passou a permitir valores negativos (nao ha restricoes)
           , nil  
           , nil, cgi.custoatual
     },    

    CampoCaracter:new 
    {
        'Justificativa para custo negativo', 'custo_just', nil, 
        { 
            tamanho = 
            { 
               ['<='] = 150               
            } 
         }, nil, cgi.custo_just
    }, 
     
    CampoVetor:new 
    { 
       'Dados', 'dados',nil, 
       { 
          subconjunto = "#indeterminado", 
          tamanho = 
          { 
             ['=='] = cgi.cont-1 
          } 
       }, 'global_local', cgi.cont-1, valores, dados 
    },

}}