-- --------------------------------------------------------------------------------------   
-- FORM_CUSTO_PREVISTO
-- --------------------------------------------------------------------------------------
-- Valida o preenchimento do custo previsto mensal
-- --------------------------------------------------------------------------------------
   assert( dofile ( "../validaform/validaform.lua" ) )   

-- --------------------------------------------------------------------------------------   
   desc = {'jan','fev','mar','abr','mai','jun','jul','ago','set','out','nov','dez'}            
-- --------------------------------------------------------------------------------------

function trataValor(valor) 
   assert( dofile ( "global.lua" ) )  
   if temConteudo(valor) then
      valor = gsub(valor, ',', '%.')
   end
   return valor   
end
   
-- --------------------------------------------------------------------------------------
-- Cria os CGIs dos meses anteriores a DATA INICIAL e posteriores a DATA FINAL
-- --------------------------------------------------------------------------------------   
-- O formulario HTML eh criado de acordo com as datas de inicio e fim previstos para o
-- projeto, esse valor pertence ao intervalo 01/04/2000 <= DATAS <= 31/12/2003, dessa
-- forma, alguns CGIs simplesmente nao sao definidos no FORM, sendo necessario cria-los
-- com valor NIL no VALIDA FORM
-- --------------------------------------------------------------------------------------   
   ano = 0
   mes = 4
   
   while ( ano <= 3 ) do
      while ( mes <= 12 ) do
      	 if ( ano == tonumber(cgi.ult_dig_ano_ini) and mes == tonumber(cgi.mes_ini) ) then
      	     ano = tonumber(cgi.ult_dig_ano_fim) 	
      	     if ( tonumber(cgi.mes_fim) ~= 12 ) then	
      	     	mes = tonumber(cgi.mes_fim) + 1
      	     elseif ( ano ~= 3 ) then	
      	     	ano = ano + 1
      	     	mes = 1
      	     else
      	        ano = 4
      	        mes = 12 	
      	     end
      	 end 
      	 if ( ano ~= 4 ) then
      	    cgi['custo_prev_'..desc[mes]..ano] = '' 	       	          	    
      	 end 	
      	 mes = mes + 1
      end	
      mes = 1
      ano = ano + 1
   end 	  
-- --------------------------------------------------------------------------------------

-- --------------------------------------------------------------------------------------
-- Criacao do FORM de VALIDACAO
-- --------------------------------------------------------------------------------------
   form_custo_previsto = Formulario:new
   {{
         	   	
        CampoReal:new 
        {
            'Custo previsto para abril', 'custo_prev_abr0', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_abr0)
         },
         	
        CampoReal:new 
        {
            'Custo previsto para maio', 'custo_prev_mai0', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_mai0)
         },
         
        CampoReal:new 
        {
            'Custo previsto para junho', 'custo_prev_jun0', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_jun0)
         },
         	
        CampoReal:new 
        {
            'Custo previsto para julho', 'custo_prev_jul0', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_jul0)
         },
         	
        CampoReal:new 
        {
            'Custo previsto para agosto', 'custo_prev_ago0', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_ago0) 
         },
         	
        CampoReal:new 
        {
            'Custo previsto para setembro', 'custo_prev_set0', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_set0) 
         },
         	
        CampoReal:new 
        {
            'Custo previsto para outubro', 'custo_prev_out0', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_out0) 
         },
         	
        CampoReal:new 
        {
            'Custo previsto para novembro', 'custo_prev_nov0', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_nov0)
         },
         	
        CampoReal:new 
        {
            'Custo previsto para dezembro', 'custo_prev_dez0', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_dez0)
         },   		 	 	 	 	 	 	 	 	
          	
          	
          	
        CampoReal:new 
        {
            'Custo previsto para janeiro', 'custo_prev_jan1', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_jan1)
         },
         
        CampoReal:new 
        {
            'Custo previsto para fevereiro', 'custo_prev_fev1', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_fev1)
         },
         	
        CampoReal:new 
        {
            'Custo previsto para maro', 'custo_prev_mar1', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_mar1)
         },
         	   	
        CampoReal:new 
        {
            'Custo previsto para abril', 'custo_prev_abr1', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_abr1)
         },
         	
        CampoReal:new 
        {
            'Custo previsto para maio', 'custo_prev_mai1', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_mai1)
         },
         
        CampoReal:new 
        {
            'Custo previsto para junho', 'custo_prev_jun1', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_jun1)
         },
         	
        CampoReal:new 
        {
            'Custo previsto para julho', 'custo_prev_jul1', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_jul1) 
         },
         	
        CampoReal:new 
        {
            'Custo previsto para agosto', 'custo_prev_ago1', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_ago1)
         },
         	
        CampoReal:new 
        {
            'Custo previsto para setembro', 'custo_prev_set1', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_set1)
         },
         	
        CampoReal:new 
        {
            'Custo previsto para outubro', 'custo_prev_out1', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_out1) 
         },
         	
        CampoReal:new 
        {
            'Custo previsto para novembro', 'custo_prev_nov1', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_nov1)
         },
         	
        CampoReal:new 
        {
            'Custo previsto para dezembro', 'custo_prev_dez1', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_dez1)
         },   
         
         
         
         
        CampoReal:new 
        {
            'Custo previsto para janeiro', 'custo_prev_jan2', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_jan2)
         },
         
        CampoReal:new 
        {
            'Custo previsto para fevereiro', 'custo_prev_fev2', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_fev2)
         },
         	
        CampoReal:new 
        {
            'Custo previsto para maro', 'custo_prev_mar2', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_mar2)
         },
         	   	
        CampoReal:new 
        {
            'Custo previsto para abril', 'custo_prev_abr2', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_abr2) 
         },
         	
        CampoReal:new 
        {
            'Custo previsto para maio', 'custo_prev_mai2', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_mai2) 
         },
         
        CampoReal:new 
        {
            'Custo previsto para junho', 'custo_prev_jun2', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_jun2)
         },
         	
        CampoReal:new 
        {
            'Custo previsto para julho', 'custo_prev_jul2', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_jul2) 
         },
         	
        CampoReal:new 
        {
            'Custo previsto para agosto', 'custo_prev_ago2', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_ago2) 
         },
         	
        CampoReal:new 
        {
            'Custo previsto para setembro', 'custo_prev_set2', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_set2) 
         },
         	
        CampoReal:new 
        {
            'Custo previsto para outubro', 'custo_prev_out2', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_out2) 
         },
         	
        CampoReal:new 
        {
            'Custo previsto para novembro', 'custo_prev_nov2', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_nov2) 
         },
         	
        CampoReal:new 
        {
            'Custo previsto para dezembro', 'custo_prev_dez2', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_dez2)
         },   
         
         
         
         
        CampoReal:new 
        {
            'Custo previsto para janeiro', 'custo_prev_jan3', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_jan3) 
         },
         
        CampoReal:new 
        {
            'Custo previsto para fevereiro', 'custo_prev_fev3', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_fev3)
         },
         	
        CampoReal:new 
        {
            'Custo previsto para maro', 'custo_prev_mar3', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_mar3) 
         },
         	   	
        CampoReal:new 
        {
            'Custo previsto para abril', 'custo_prev_abr3', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_abr3) 
         },
         	
        CampoReal:new 
        {
            'Custo previsto para maio', 'custo_prev_mai3', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_mai3) 
         },
         
        CampoReal:new 
        {
            'Custo previsto para junho', 'custo_prev_jun3', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_jun3) 
         },
         	
        CampoReal:new 
        {
            'Custo previsto para julho', 'custo_prev_jul3', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_jul3)
         },
         	
        CampoReal:new 
        {
            'Custo previsto para agosto', 'custo_prev_ago3', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_ago3) 
         },
         	
        CampoReal:new 
        {
            'Custo previsto para setembro', 'custo_prev_set3', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_set3)
         },
         	
        CampoReal:new 
        {
            'Custo previsto para outubro', 'custo_prev_out3', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_out3)
         },
         	
        CampoReal:new 
        {
            'Custo previsto para novembro', 'custo_prev_nov3', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_nov3)
         },
         	
        CampoReal:new 
        {
            'Custo previsto para dezembro', 'custo_prev_dez3', nil, 
            { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, trataValor(cgi.custo_prev_dez3)
         }                               	
          	             
   }}
