-- ---------------------------------------------------------------------------------------------------------------------
-- FUNC_ATUALIZA_PROJ_DT_PREV_ATIV.LUA
-- ---------------------------------------------------------------------------------------------------------------------
dofile( "acessabd.lua" )
dofile( "global.lua")

-- -------------------------------------------------------------------------------------------- 
-- Atualizar o FLAG referente as datas previstas e reais das atividades em relacao as datas 
-- previstas e reais do projeto (proj_dt_prev_ativ - tabela PROJETO): forcar com que se tenha 
-- pelo menos uma atividade com data de inicio prevista igual a data de inicio prevista do 
-- projeto e uma atividade com data de fim prevista igual a data de fim prevista do projeto.
-- -------------------------------------------------------------------------------------------- 
function atualizaDatasPrevistas(projeto) 
   local resultado, proj_dt_ini, proj_dt_fim, flag_ini, flag_fim
   
   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end
   
   DBExec("select proj_dt_ini_prev, proj_dt_fim_prev from projeto where proj_cod = "..projeto)
   resultado = DBRow()                
  
   proj_dt_ini = resultado.proj_dt_ini_prev
   proj_dt_fim = resultado.proj_dt_fim_prev   
   
   DBExec("select ativ_dt_ini_prev as ini, ativ_dt_fim_prev as fim from atividade where proj_cod = "..projeto)
   resultado = DBRow()
   flag_ini = 0
   flag_fim = 0      
   
	 while resultado do    	  	 
	    if tonumber(resultado.ini) == tonumber(inclui_data(proj_dt_ini)) then flag_ini = 1 end
	    if tonumber(resultado.fim) == tonumber(inclui_data(proj_dt_fim)) then flag_fim = 1 end
	  	
	    resultado = DBRow()    	  
	 end
	  
	 if flag_ini == 1 and flag_fim == 1 then   	  	 
	    DBExec("update projeto set proj_dt_prev_ativ = 1 where proj_cod = "..projeto)
	 else 	    	     
	    DBExec("update projeto set proj_dt_prev_ativ = 0 where proj_cod = "..projeto)
	 end   
end   

-- Verifica as os pesos, os custos e as datas da atividade
function verificaFormalizacao(projeto) 
   local resultado, proj_dt_ini, proj_dt_fim, soma_ativ, flag_ini, flag_fim
   local query, i
   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end
   
   query="select proj_dt_ini_prev, proj_dt_fim_prev, proj_soma_ativ from projeto where proj_cod = "..projeto
   DBExec(query)
   resultado = DBRow()
   proj_dt_ini = resultado.proj_dt_ini_prev
   proj_dt_fim = resultado.proj_dt_fim_prev   
   soma_ativ   = resultado.proj_soma_ativ
   
      
   query = "select distinct c.proj_cod from custo c, projeto p where p.proj_cod = c.proj_cod and p.proj_cod = "..
                 projeto.." and c.custo_ano >= year(p.proj_dt_ini_prev) and c.custo_ano <= year(p.proj_dt_fim_prev) "..
                 "and (c.custo_prev_ano = 0 or c.custo_prev_ano is null)"
   DBExec(query)
   resultado = DBRow()
   local dt_fim = tonumber(strsub(formataData(proj_dt_fim),7,10))

   if resultado and resultado.proj_cod and (dt_fim >= 2004 and dt_fim <= 2010)then
      flag_custo = 1
   elseif resultado and resultado.proj_cod then
      flag_custo = 0
   else
      flag_custo = 1
   end              
   
   flag_data_ativ = verificaDatasAtividades(projeto)

   if tonumber(soma_ativ) == 100 and flag_data_ativ == 1 and flag_custo == 1 then   	  	 
      return 1   
   else	   	    	     
      return nil
   end   
end   


-- Verifica as datas da atividade
function verificaDatasAtividades(projeto) 
   local resultado, proj_dt_ini, proj_dt_fim, flag_ini, flag_fim, sql
   
   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end
   
   sql = "select proj_dt_ini_prev, proj_dt_fim_prev from projeto where proj_cod = "..projeto
   DBExec(sql)
   resultado = DBRow()                
   proj_dt_ini = resultado.proj_dt_ini_prev
   proj_dt_fim = resultado.proj_dt_fim_prev   
         
   sql = "select ativ_dt_ini_prev as ini, ativ_dt_fim_prev as fim from atividade where proj_cod = "..projeto.." order by ativ_dt_fim_prev"
   DBExec(sql)
   resultado = DBRow()
   flag_ini = 0
   flag_fim = 0         
   
   while resultado do    	  	 
      if flag_ini == 1 and tonumber(resultado.ini) < tonumber(inclui_data(proj_dt_ini)) then 
      	 flag_ini = 0
      elseif tonumber(resultado.ini) == tonumber(inclui_data(proj_dt_ini)) then
      	 flag_ini = 1
      end

      if flag_fim == 1 and tonumber(resultado.fim) > tonumber(inclui_data(proj_dt_fim)) then
      	 flag_fim = 0
      elseif tonumber(resultado.fim) == tonumber(inclui_data(proj_dt_fim)) then
      	 flag_fim = 1
      end
    	
      resultado = DBRow()    	  
   end
    
   if flag_ini == 1 and flag_fim == 1 then   	  	 
      return 1
   else  	    	     
      return nil
   end   
end   

-- Verifica as novas entradas para atividade com as jah existentes (edicao/cadastramento)
function verificaNovasEntradas(projeto, atividade, peso_ativ, data_ini, data_fim) 
   local resultado, soma_peso_ativ, flag_ini, flag_fim
      
   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end  
   
   DBExec("select proj_dt_ini_prev, proj_dt_fim_prev from projeto where proj_cod = "..projeto)
   resultado = DBRow()                
  
   proj_dt_ini = resultado.proj_dt_ini_prev
   proj_dt_fim = resultado.proj_dt_fim_prev  
   
   DBExec("select ativ_dt_ini_prev as ini, ativ_dt_fim_prev as fim, ativ_peso_rel_proj as peso from atividade "..
	  "where proj_cod = "..projeto.." and ativ_cod not in ("..atividade..")")
   resultado = DBRow()
   
   if tonumber(data_ini) == tonumber(inclui_data(proj_dt_ini)) then flag_ini = 1 else flag_ini = 0 end
   if tonumber(data_fim) == tonumber(inclui_data(proj_dt_fim)) then flag_fim = 1 else flag_fim = 0 end    
   
   soma_peso_ativ = tonumber(peso_ativ or 0)
   while resultado do    	  	 
      if tonumber(resultado.ini) == tonumber(inclui_data(proj_dt_ini)) then flag_ini = 1 end
      if tonumber(resultado.fim) == tonumber(inclui_data(proj_dt_fim)) then flag_fim = 1 end
         soma_peso_ativ = soma_peso_ativ + tonumber(resultado.peso)
	  	
         resultado = DBRow()    	  
      end
	  
      if tonumber(soma_peso_ativ) == 100 and flag_ini == 1 and flag_fim == 1 then   	  	 
	 return 1
      elseif tonumber(soma_peso_ativ) == 100 and (flag_ini == 0 or flag_fim == 0) then   	  	 
         return 0
      else	   	    	     
         return nil
      end   
end   