-- --------------------------------------------------------------------------------
-- MAIL
-- --------------------------------------------------------------------------------
-- Envia emails para os usurios especificados.
-- --------------------------------------------------------------------------------
--   $Revision:   $
--
--   $Author:  $
--
--   $Update Date:  $ 
--   
--   $NoKeywords:  $
-- 
-- Copyright by TeCGraf (PUC-RIO)
-- --------------------------------------------------------------------------------
-- Envia e-mail nas funcoes de REVISAO, CANCELAMENTO, CONCLUSAO e FORMALIZACAO
-- Envia e-mail para a pessoa logada enviando tambm e-mail com e para o
-- responsavel pela area de negocio.
-- Caso o projeto nao pertenca ao PLANO EMERGENCIAL DE INTEGRIDADE DE DUTOS
-- ( proj_paeid <>1 ) envia e-mail para a pessoa logada com copia para o
-- responsavel pela area de negocio.
-- Se ( proj_paeid <> 1 ) mas a funcao for CONCLUIDO, entao envia copia do e-mail 
-- para o coordenador corporativo do PEGASO tambem.
-- --------------------------------------------------------------------------------
 
function email(cod_proj, funcao)   
  assert( dofile( 'constantes.lua' ) )     
            
  -- ------------------------------------------------------------------------------
  -- Funo que retorna os campos para envio do(s) E-mail(s)
  -- Inclusive o e_mail do responsavel pela area de negocio
  -- ------------------------------------------------------------------------------     
     if ESTADO_BD ~= 'aberto' then
        AbreBD()
     end
     
     local sql_mail = 'SELECT proj_paeid, proj_nome, proj_coord, a.org_cod, pes_email AS '..
                      'resp_AN_email FROM projeto a, pessoal b, orgao c WHERE proj_cod = '..
                       cod_proj..' AND a.org_cod = c.org_cod AND c.pes_cod_resp = b.pes_cod'
     DBExec(sql_mail)
     local query = DBRow()
     
     paeid  = query.proj_paeid
     nome   = query.proj_nome
     coord  = query.proj_coord    
     org    = query.org_cod         
     copia  = query.resp_AN_email   -- e-mail do responsavel pela area de negocios     
 
  -- ------------------------------------------------------------------------------
  -- Descobre o e-mail do coordenador do Pegaso
  -- ------------------------------------------------------------------------------
     local sql_coord = " SELECT pes_email FROM pessoal WHERE pes_chave = '".._CHAVE_COORDENADOR_PEGASO_.."' "
     DBExec(sql_coord)
     local temp = DBRow()
     local coord_email = ''
     if temp and temp.pes_email then
        coord_email = temp.pes_email
     end     
       
  -- ------------------------------------------------------------------------------
  -- Pega o usuario "LOGADO" no sistema
  -- Descobre o e_mail desse usuario na tabela de PESSOAL 
  -- ------------------------------------------------------------------------------      
     user  = getuser()
     query = " SELECT pes_email FROM pessoal WHERE pes_chave = '"..user.."'"     
     DBExec( query )
     pessoal = DBRow()
          
     origem  = pessoal.pes_email
     destino = pessoal.pes_email
                                                         
     if ESTADO_BD == 'aberto' then
        FechaBD()
     end   
          
  -- ------------------------------------------------------------------------------
  -- Definindo as mensagens de acordo com a funcao de origem (REVISO, 
  -- CANCELAMENTO,CONCLUSO)   
  -- ------------------------------------------------------------------------------
     if funcao == 'cancela' then       
        msg_alerta = 'Cancelamento do Projeto '
        funcao     = 'Cancelamento do Projeto '
        acao       = 'cancelado'
        msgsuc     = 'O Projeto <b>'..nome..'</b> foi cancelado com sucesso!'
     elseif funcao == 'conclui' then    
        msg_alerta = 'Concluso do Projeto '
        funcao     = 'Conclusao do Projeto '        
        acao       = 'concludo'   	
        msgsuc     = 'O Projeto <b>'..nome..'</b> foi concludo com sucesso!'
     elseif funcao == 'revisao' then  
        msg_alerta = 'Reviso do Projeto '
        funcao     = 'Revisao do Projeto '
        acao       = 'revisado' 	
        msgsuc     = 'O Projeto <b>'..nome..'</b> foi revisado com sucesso!'
     elseif funcao == 'formaliza' then  
        msg_alerta = 'Formalizao do Projeto '
        funcao     = 'Formalizacao do Projeto '
        acao       = 'formalizado' 	
        msgsuc     = 'O Projeto <b>'..nome..'</b> foi formalizado com sucesso!'        
     end	    
  
     -- Os caracteres especiais (acentos, cedilha...) foram retirados de funcao para evitar
     -- que o TITULO do e-mail apareca com caracteres estranhos lah na PETROBRAS
     titulo   = funcao..nome         
     mensagem = 'O projeto <'..nome..'> (coordenador: '..coord..') foi '..acao..' com sucesso pelo(a) usurio(a) '..user..'.' 
        
     -- ---------------------------------------------------------------------------
     -- Funcao para envio de E-MAIL            
     -- ---------------------------------------------------------------------------  
     if paeid ~= 1 then  -- nao pertence ao PLANO EMERGENCIAL DE INTEGRIDADE DE DUTOS                                                                                             
        if acao == 'concludo' then
           if temConteudo(copia) then
              copia = copia .. ', ' .. coord_email
           else   
              copia = coord_email
           end
        end                     
                        
     end   
     
     -- Chama a funo de envio de e-mail (envia_mail()) atraves da funo ENVIA_EMAIL definida
     -- em CONSTANTES.LUA
     local ok, msgerr =  ENVIA_EMAIL(destino, origem, titulo, mensagem, copia)
     
     if not ok then 
        if msgerr then	
           if temConteudo(destino) then 	
              email  = 'A notificao de '..msg_alerta..' no pode ser enviada ('..msgerr..').'
           else
              email  = 'A notificao de '..msg_alerta..' no pode ser enviada. O e-mail do responsvel ('..user..') pela alterao no consta na base de dados.'   
           end   
        end         
     else  
        if temConteudo(copia) then       
           email  = 'A notificao de '..msg_alerta..' foi enviada para <b>'..destino..'</b> com cpia(s) para <b>'..copia..'</b>.'    
        else
           email  = 'A notificao de '..msg_alerta..' foi enviada para <b>'..destino..'</b>.'    
        end      
     end      
         
     return msgsuc, email      
end