-- -------------------------------------------------------------------------------------------------
-- NIVEL_ATUALIZACAO.LUA
-- -------------------------------------------------------------------------------------------------
-- $Revision:$
--
-- $Update Date:$ $NoKeywords:$
-- 
-- Copyright by TeCGraf (PUC-RIO)
-- -------------------------------------------------------------------------------------------------  
dofile('acessabd.lua')
dofile('global.lua')
-- -------------------------------------------------------------------------------------------------
-- Abre conexao com o Banco de Dados
-- -------------------------------------------------------------------------------------------------   
   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end

-- Variaveis de configuracao da atualizacao
local ano_mes_atual = tonumber(date('%Y'))
local mes_atual = tonumber(date('%m'))
local dia_atual = tonumber(date('%d'))

local nome_mes = {}
nome_mes[1]  = 'Janeiro';
nome_mes[2]  = 'Fevereiro';
nome_mes[3]  = 'Maro';
nome_mes[4]  = 'Abril';
nome_mes[5]  = 'Maio';
nome_mes[6]  = 'Junho';
nome_mes[7]  = 'Julho';
nome_mes[8]  = 'Agosto';
nome_mes[9]  = 'Setembro';
nome_mes[10] = 'Outubro';
nome_mes[11] = 'Novembro';
nome_mes[12] = 'Dezembro';

local mes_passado
local ano_mes_passado

if mes_atual == 1 then
   mes_passado = 12
   ano_mes_passado = ano_mes_atual - 1
else
   mes_passado = mes_atual - 1
   ano_mes_passado = ano_mes_atual
end

local menor_data = tostring((ano_mes_passado*10000)+(mes_passado*100)+15)
local maior_data = tostring((ano_mes_atual*10000)+(mes_atual*100)+15)

-- -------------------------------------------------------------------------------------------------
-- Vefifica se a ultima atualizacao na tabela atualizacaoProjeto foi a do mes passado
-- Se foi nao e feita nenhuma atualizacao
-- -------------------------------------------------------------------------------------------------
local sql = "SELECT unid_cod FROM atualizacaoProjeto WHERE mes = "..mes_passado.." AND ano = "..ano_mes_passado..""
DBExec(sql)
local realizada = DBRow()

if not realizada and dia_atual >= 15 then
   -- -------------------------------------------------------------------------------------------------
   -- Consulta a tabela de projeto para saber todas as unidades que tem projetos classe I no sistema,
   -- estao em acompanhamento ou concluidos e sao last_versao = s
   -- -------------------------------------------------------------------------------------------------
   sql = "SELECT DISTINCT unid_cod, count( distinct proj_cod) as total FROM projeto WHERE last_versao = 's' AND "..
         "(stat_cod = 2 OR (stat_cod = 4 AND proj_dt_conc >= '"..menor_data.."' AND proj_dt_conc < '"..maior_data.."')) AND "..
         "proj_class = 1 AND unid_cod IS NOT NULL GROUP BY unid_cod ORDER BY unid_cod"
   DBExec(sql)
   local linha = DBRow()
   
   local modificado = {}
   
   local cont = 1
   while linha do
      modificado[linha.unid_cod] = {}
      modificado[linha.unid_cod].total = linha.total
      modificado[linha.unid_cod].atualizado = 0
      
      cont = cont + 1
      linha = DBRow()
   end
   
   -- -------------------------------------------------------------------------------------------------
   -- Consulta a tabela follow_up para saber se tem algum projeto classe I que tenha sido atualizado 
   -- no sistema no ultimo mes para poder atualizar a tabela atualizacaoProjeto
   -- -------------------------------------------------------------------------------------------------
   sql = "SELECT unid_cod, count( distinct proj_cod) as qtd_projeto FROM follow_up, projeto "..
          "WHERE fup_proj_cod = proj_cod AND fup_data >= '"..menor_data.."' AND fup_data < '"..maior_data.."' AND "..
          "last_versao = 's' AND proj_class = 1 AND unid_cod IS NOT NULL AND "..
          "(stat_cod = 2 OR (stat_cod = 4 AND proj_dt_conc >= '"..menor_data.."' AND proj_dt_conc < '"..maior_data.."')) "..
          "GROUP BY unid_cod ORDER BY unid_cod"
   DBExec(sql)
   local fup = DBRow()
   
   while fup do
      if modificado[fup.unid_cod] then
         modificado[fup.unid_cod].atualizado = fup.qtd_projeto
      end
      
      fup = DBRow()
   end
   
   -- -------------------------------------------------------------------------------------------------
   -- Grava os dados da atualizacao dos projeto classe I atualizados no mes passado
   -- -------------------------------------------------------------------------------------------------
   local j = 1

   local unidade, unid_info = next(modificado, nil)
   while j < cont do
      EscreveBD("atualizacaoProjeto", "unid_cod,mes,ano,qtd_proj_classei,total_proj", " "..unidade..", "..
                " "..mes_passado..", "..ano_mes_passado..", "..unid_info.atualizado..", "..unid_info.total.." ")
                
      unidade, unid_info = next(modificado, unidade)
      j = j + 1
   end
   
   print('A atualizao mensal da tabela atualizacaoProjeto foi realizada para ', nome_mes[mes_passado], ' de ', ano_mes_passado, '.')
   
else
   if not realizado then
      print('A atualizao mensal da tabela atualizacaoProjeto j foi realizada para ', nome_mes[mes_passado], ' de ', ano_mes_passado, '.')
   end
end

-- -------------------------------------------------------------------------------------------------
-- Fecha conexao com o Banco de Dados
-- -------------------------------------------------------------------------------------------------   
   if ESTADO_BD == 'aberto' then
      FechaBD()
   end