dofile( 'acessabd.lua' )
dofile( 'global.lua' )
dofile( 'permissao_acesso.lua' )

if ESTADO_BD ~= 'aberto' then
   AbreBD()
end

-- Variaveis de configuracao do relatorio
num_meses = 6
data_hoje = date('%d')..'/'..date('%m')..'/'..date('%Y')
ano_mes_atual = tonumber(date('%Y'))
dia_atual = tonumber(date('%d'))
mes_atual = tonumber(date('%m'))

-- ---------------------------------------------------------------
-- Se o dia for menor que 15  porque o relatorio ainda deve ser
-- gerado em relacao ao mes passado.
-- ---------------------------------------------------------------
if dia_atual < 15 then
   mes_atual = mes_atual - 1
   if mes_atual == 0 then
      mes_atual = 12
      ano_mes_atual = ano_mes_atual - 1
   end
end

if mes_atual == 1 then
   menor_data = tostring(((ano_mes_atual-1)*10000)+(12*100)+15)
   maior_data = tostring((ano_mes_atual*10000)+(mes_atual*100)+15)
else
   menor_data = tostring((ano_mes_atual*10000)+(mes_atual*100)+15)
   if mes_atual == 12 then
      maior_data = tostring(((ano_mes_atual+1)*10000)+(1*100)+15)
   else
      maior_data = tostring((ano_mes_atual*10000)+((mes_atual+1)*100)+15)
   end
end

primeiro_mes = mes_atual - (num_meses - 1)
if primeiro_mes <= 0 then
   primeiro_mes = 12 + primeiro_mes
   ano_primeiro_mes = ano_mes_atual - 1
else
   ano_primeiro_mes = ano_mes_atual
end

nome_mes = {}
nome_mes[1]  = 'Janeiro';
nome_mes[2]  = 'Fevereiro';
nome_mes[3]  = 'Maro';
nome_mes[4]  = 'Abril';
nome_mes[5]  = 'Maio';
nome_mes[6]  = 'Junho';
nome_mes[7]  = 'Julho';
nome_mes[8]  = 'Agosto';
nome_mes[9]  = 'Setembro';
nome_mes[10] = 'Outubro';
nome_mes[11] = 'Novembro';
nome_mes[12] = 'Dezembro';

cgilua.htmlheader()

write('<HTML>\n')
write('<HEAD>\n')
write('<LINK REL="stylesheet" HREF="../pegaso.css" TYPE="text/css">\n')
write('<TITLE>Resultado do Relatrio de Nvel de Atualizao do PEGASO</TITLE>\n') 
  
write('</HEAD>\n')
write('<BODY BACKGROUND="../imagens/moldura_princ.gif">\n')
write('\n')
write('   <CENTER><H2>Resultado do Relatrio de Nvel de Atualizao do PEGASO</H2></CENTER>\n')
write('   <HR WIDTH="98%">\n')   

write('   <TABLE WIDTH="100%" BORDER="0" ALIGN="CENTER">\n')
write('      <TR>\n')
write('         <TD>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>\n')
write('         <TD>\n')
write('         <TABLE WIDTH="90%" BORDER="0" ALIGN="CENTER">\n')

-- -----------------------------------------------------------
-- Consulta a tabela projeto para buscar o total de projetos
-- classe I em acompanhamento e last_versao 's' no dia atual
-- -----------------------------------------------------------
sql = "SELECT unid_cod, count( distinct proj_cod) as qtd_projeto FROM projeto WHERE last_versao = 's' AND "..
      "stat_cod = 2 AND proj_class = 1 AND unid_cod IS NOT NULL GROUP BY unid_cod ORDER BY unid_cod"
DBExec(sql)

local proj = DBRow()
local total = {}

while proj do
   total[proj.unid_cod] = proj.qtd_projeto

   proj = DBRow()
end

-- --------------------------------------------------------------
-- Consulta a tabela de projetos classe I concluidos no periodo
-- --------------------------------------------------------------
sql = "SELECT unid_cod, count( distinct proj_cod) as qtd_proj_conc FROM projeto WHERE last_versao = 's' AND ".. 
      "stat_cod = 4 AND proj_class = 1 AND proj_dt_conc >= '"..menor_data.."' AND ".. 
      "proj_dt_conc < '"..maior_data.."' AND unid_cod IS NOT NULL GROUP BY unid_cod ORDER BY unid_cod"
DBExec(sql)

local conc = DBRow()
local concluido = {}

while conc do
   concluido[conc.unid_cod] = conc.qtd_proj_conc
   
   conc = DBRow()
end

-- --------------------------------------------------------------
-- Consulta a tabela follow_up para verificar se os projetos
-- que foram retornados das querys anteriores foram modificados
-- --------------------------------------------------------------
sql = "SELECT unid_cod, count(distinct proj_cod) as qtd_projeto FROM projeto, follow_up "..
      "WHERE fup_proj_cod = proj_cod AND last_versao = 's' AND (stat_cod = 2 OR "..
      "(stat_cod = 4 AND proj_dt_conc >= '"..menor_data.."' AND proj_dt_conc < '"..maior_data.."')) AND "..
      "proj_class = 1 AND unid_cod IS NOT NULL AND fup_data >= '"..menor_data.."' AND fup_data < '"..maior_data.."' "..
      "GROUP BY unid_cod ORDER BY unid_cod "
DBExec(sql)
local fup = DBRow()
local modificado = {}

while fup do
   modificado[fup.unid_cod] = fup.qtd_projeto + (concluido[fup.unid_cod] or 0)

   fup = DBRow()   
end

-- -----------------------------------------------------------------
-- Consulta a tabela atualizacaoProjeto para buscar as informacoes
-- sobre as atualizacoes dos meses passados
-- -----------------------------------------------------------------
sql = "SELECT * FROM atualizacaoProjeto WHERE ano >= "..ano_primeiro_mes.." ORDER BY unid_cod, ano, mes"
DBExec(sql)
local row = DBRow()
local atualizado = {}

unid_cod = 0
while row do
   if unid_cod ~= row.unid_cod then
      atualizado[row.unid_cod] = {}
   end
   
   atualizado[row.unid_cod][row.mes] = {}
   atualizado[row.unid_cod][row.mes].qtd = row.qtd_proj_classei
   unid_cod = row.unid_cod
   
   row = DBRow()
end

-- ----------------------------------------------------------
-- Consulta as tabelas orgao e unidade para buscar as 
-- siglas e codigos das ANs e UNs
-- Retorna todas as ANs que possuem UN para montar a tabela
-- ----------------------------------------------------------
sql = "SELECT o.org_cod, o.org_sigla, u.unid_cod, u.unid_sigla, "..
      "num_unid = (select count (unid_cod) from unidade where org_cod = o.org_cod group by org_cod)"..
      "FROM orgao o, unidade u WHERE o.org_cod = u.org_cod "..
      "ORDER BY o.org_sigla, u.unid_sigla"
DBExec(sql)
linha = DBRow()

write('<TABLE WIDTH="100%" BORDER="1" ALIGN="CENTER">\n')
write('<TR>\n')
write('<TD ROWSPAN=2><CENTER><B>rea de Negcio</B></CENTER></TD>'..
      '<TD ROWSPAN=2><CENTER><B>Unidade de Negcio</B></CENTER></TD>'..
      '<TD COLSPAN='..num_meses..'><CENTER><B>Nvel de Atualizao do Sistema Carteira de Projetos</B></CENTER></TD>'..
      '<TD ROWSPAN=2><CENTER><B>Total de Projetos Classe I at '..data_hoje..'</B></CENTER></TD>'..
      '<TD ROWSPAN=2><CENTER><B>Total de Projetos Classe I Concludos at '..data_hoje..'</B></CENTER></TD>'..
      '<TD ROWSPAN=2><CENTER><B>Quantidade de Projetos Classe I atualizados at '..data_hoje..'</B></CENTER></TD>'..
      '<TD ROWSPAN=2><CENTER><B>Projetos Atualizados / Total de Projetos (%)</B></CENTER></TD>\n')
write('<TR>\n')
i_mes = primeiro_mes
i = 1
while i <= num_meses do
   write('<TD><CENTER><I>'..nome_mes[i_mes]..'</I></CENTER></TD>')
   if i_mes == 12 then
      i_mes = 1
   else
      i_mes = i_mes + 1
   end
   i = i + 1
end
write('</TR>\n')

orgao = 0
while linha do
   write('<TR>\n')
   if linha.org_cod ~= orgao then
      write('<TD ROWSPAN='..linha.num_unid..'><CENTER>'..linha.org_sigla..'</CENTER></TD>\n')
   end
   write('<TD><CENTER>'..linha.unid_sigla..'</CENTER></TD>\n')
   i = 1
   aux_mes = primeiro_mes
   while i <= num_meses do
      
      if aux_mes == mes_atual then -- Condicao para gerar o ultimo mes da tabela com as informacoes atuais do sistema
         if total[linha.unid_cod] then
            if total[linha.unid_cod] > 0 then
               if modificado[linha.unid_cod] then
                  if modificado[linha.unid_cod] > 0 then -- Tem projeto classe I atualizado no sistema
                     write('<TD BGCOLOR=green></TD>')
                  else -- Tem projetos classe I no sistema mas nao foram atualizados
                     write('<TD BGCOLOR=red></TD>')
                  end
               else -- Tem projetos classe I no sistema mas nao foram atualizados
                  write('<TD BGCOLOR=red></TD>')
               end
            end
         else -- Nao tem projeto classe I no sistema
            write('<TD><CENTER>*</CENTER></TD>')
         end
      else
         if atualizado[linha.unid_cod] and atualizado[linha.unid_cod][aux_mes] 
         and atualizado[linha.unid_cod][aux_mes].qtd then
            if atualizado[linha.unid_cod][aux_mes].qtd == 0 then -- Tem projetos classe I no sistema mas nao foram atualizados
               write('<TD BGCOLOR=red></TD>')
            else -- Tem projeto classe I atualizado no sistema
               write('<TD BGCOLOR=green></TD>')
            end
         else -- Nao tem projeto classe I no sistema ou nao foi inserido na tabela atualizacaoProjeto
            write('<TD><CENTER>*</CENTER></TD>')
         end
      end
      
      if aux_mes == 12 then
         aux_mes = 1
      else
         aux_mes = aux_mes + 1
      end
      i = i + 1
   end
   if total[linha.unid_cod] then -- qtd total de projetos classe I
      write('<TD><CENTER>'..total[linha.unid_cod]..'</CENTER></TD>\n')
   else
      write('<TD><CENTER>0</CENTER></TD>\n')
   end
   if concluido[linha.unid_cod] then -- qtd total de projetos classe I concluidos
      write('<TD><CENTER>'..concluido[linha.unid_cod]..'</CENTER></TD>\n')
   else
      write('<TD><CENTER>0</CENTER></TD>\n')
   end
   if modificado[linha.unid_cod] then -- qtd total de projetos classe I modificados
      write('<TD BGCOLOR="#ECECEC"><CENTER>'..modificado[linha.unid_cod]..'</CENTER></TD>\n')
      flag_denominador = 1
   else
      write('<TD BGCOLOR="#ECECEC"><CENTER>0</CENTER></TD>\n')
   end
   if flag_denominador then -- percentual de projetos modificados
      if concluido[linha.unid_cod]then
         resultado = arredonda((modificado[linha.unid_cod] * 100) / (total[linha.unid_cod] - concluido[linha.unid_cod]) )
      else
         resultado = arredonda((modificado[linha.unid_cod] * 100) / total[linha.unid_cod])
      end
      write('<TD><CENTER>'..resultado..'%</CENTER></TD>\n')
      flag_denominador = nil
   else
      write('<TD><CENTER>-</CENTER></TD>\n')
   end
   write('</TR>\n')
   
   orgao = linha.org_cod
   linha = DBRow()
end

write('            </TABLE>\n')

write('            <TABLE WIDTH="100%" BORDER="0" ALIGN="CENTER">\n')
write('               <TR>\n')
write('                  <TD></TD>\n')
write('               </TR>\n')
write('               <TR>\n')
write('                  <TD></TD>\n')
write('               </TR>\n')
write('               <TR>\n')
write('                  <TD COLSPAN=2><B>Legenda:</B></TD>\n')
write('               </TR>\n')
write('               <TR>\n')
write('                  <TD><CENTER>*</CENTER></TD>\n')
write('                  <TD> Projetos Classe I no cadastrados ou identificados no sistema.</TD>\n')
write('               </TR>\n')
write('               <TR>\n')
write('                  <TD BGCOLOR=red></TD>\n')
write('                  <TD> Unidade no atualizou o sistema.</TD>\n')
write('               </TR>\n')
write('               <TR>\n')
write('                  <TD BGCOLOR=green></TD>\n')
write('                  <TD> Unidade atualizou o sistema.</TD>\n')
write('               </TR>\n')
write('            </TABLE>\n')

write('         </TABLE>\n')
write('         </TD>\n')
write('      </TR>\n')
write('   </TABLE>\n')

write('</BODY>\n')
write('</HTML>\n')


if ESTADO_BD == 'aberto' then
   FechaBD()
end