-- -------------------------------------------------------------------------------------------------
-- tarefasDiariasConsolidacao.lua
-- -------------------------------------------------------------------------------------------------
-- Todos os dias o sistema irah consultar a data da consolidacao ativa (tabela CONSOLIDACAO). 
-- Nos casos de faltarem 15, 10, 5, 1 dia para a consolidacao acontecer, o sistema enviara e-mails
-- para o Grupo de Gestao PEGASO, para o Coordenador Corporativo do PEGASO e para todos os gerentes
-- de AN (Area de Negocio - orgao) e UN (Unidade de negocio).
-- No caso de ser o dia da consolidacao, o sistema habilita todas as unidades de negocio a efetuar
-- a consolidacao e nao envia nenhum e-mail.
-- -------------------------------------------------------------------------------------------------
-- Origem do E-mail : Grupo de Gestao PEGASO   
-- Destino do E-mail: Grupo de Gestao PEGASO, Coordenador Corporativo do PEGASO e todos os gerentes
--                    de AN (Area de Negocio - orgao) e UN (Unidade de negocio).
-- -------------------------------------------------------------------------------------------------
-- $Revision:$
--
-- $Update Date:$ $NoKeywords:$
-- 
-- Copyright by TeCGraf (PUC-RIO)
-- -------------------------------------------------------------------------------------------------

assert(dofile('funcConsolidacaoBD.lua'))
  
write('<font color="blue"><b>O acompanhamento da Consolidao da Carteira de Projetos foi efetuado em '..formataData2( date('%Y%m%d') )..'.</b></font>')      

dataConsolidacao = getDataConsolidacaoAtiva()
  
if dataConsolidacao then  
   numDias = DiasEntre(formataData(date("%d/%m/%Y")),formataData(dataConsolidacao)) - 1
     
   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end
   
   if numDias == 0 then
      DBExec("Update Unidade set consolidacao_habilitada = 1")
      write('<font color="blue">O sistema habilitou todas as unidades de negcio a efetuar a Consolidao da Carteira de Projetos.</font>')
    
   elseif numDias == 1 or numDias == 5 or numDias == 10 or numDias == 15 then                
      mails = {}    
      tinsert(mails, pegaEmail(_CHAVE_COORDENADOR_PEGASO_))
      foreach(_CHAVES_GESTAO_PEGASO_, function (chave, v) tinsert(mails, pegaEmail(chave)) end)               
    
      DBExec("select distinct pes_cod_resp from orgao")    
      rs = {}
      qrs = 0
      plinha = DBRow()
      while plinha do
         rs[qrs] = plinha
         qrs = qrs + 1
         plinha = DBRow()
      end
    
      DBExec("select distinct pes_cod_resp from unidade")    
    
      plinha = DBRow()
      while plinha do
         rs[qrs] = plinha
         qrs = qrs + 1
         plinha = DBRow()
      end   
    
      cont = 0
      while cont < qrs do
         plinha = rs[cont]    
         tinsert(mails, pegaEmail(getChavePes(plinha.pes_cod_resp)))
         cont = cont + 1
      end

      para = {}
      foreachi(mails, function (i, mail)
                         if (mail) then
                            if (not para[1]) then
                                %para[1] = mail          
                            else
                                %para[1] = para[1]..','..mail          
                            end
                         end
                      end)
    
      if numDias == 1 then
         mesgDia = "falta 1 dia"
      else
         mesgDia = "faltam "..tostring(numDias).." dias"
      end

      if para[1] then
         origem   = pegaEmail(_CHAVE_RESP_GESTAO_PEGASO_)
         destino  = para[1]      
         titulo   = [[Consolidao da Carteira de Projetos]]
         mensagem = [[
                      O Grupo Pegaso informa que ]]..mesgDia..[[ para que sejam cadastrados no sistema todos os projetos
                      classe I, II e III visando a consolidao da carteira do programa.
                    ]]

         -- Chama a funo de envio de e-mail (envia_mail()) atraves da funo ENVIA_EMAIL definida
         -- em CONSTANTES.LUA
         local ok, msgerr =  ENVIA_EMAIL(destino, origem, titulo, mensagem, '')    
               
         if not ok then      
            if msgerr then	           
               write('<br><br><font color="red"><i>Os e-mails relativos a Consolidao da Carteira de Projetos no puderam ser enviados (<b>'..msgerr..'</b>).</i></font>')            
            end   
         else 
            write('<br><br><font color="blue"><i>Os e-mails relativos a Consolidao da Carteira de Projetos foram enviados com sucesso!</i></font>')
         end   
      end
   end
end