------------------------- dicionario.lua ---------------------------------------
--
-- PUC-Rio
-- Departamento de Informtica
--
-- Projeto:	VALIDAFORM
-- Arquivo: 	dicionario.lua
-- Descrio:  	Este arquivo contm uma tabela que representa um dicionrio com
--		informaes morfolgicas, sintticas e semnticas de palavras em 
--		portugus. 
 
-- Data:	21/04/1999
-- Autor:      	Gilda Dahis
--
-- 
-- Alteraes:
--     Quem    |   Quando   |   Motivo
-- ------------|------------|---------------------------------------------------
--  Sandro       12/10/2000   Sistema Pegaso
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
dicionario = 
--------------------------------------------------------------------------------
-- tabela que representa um dicionrio com informaes morfolgicas, sintticas  
-- e semnticas de palavras em portugus, as quais so utilizadas pelas funes 
-- do gerador de texto. Esta tabela  indexada pelas strigns que representam
-- as prprias palavras.
--------------------------------------------------------------------------------
{ 
	
	--Colocado por Sandro
	['relatrio'] = { 
			classe = 'nome',
			morfologia =
			{
				genero = 'a',
				numero = 's',
			},
		},
		
	['tarefa'] = { 
			classe = 'nome',
			morfologia =
			{
				genero = 'a',
				numero = 's',
			},
		},

	["dado"] = { 
			classe = 'nome', 			
			morfologia = 			
			{ 
				genero = '',		
			  	numero = '',
			},
		    }, 
	["100%"] = { 
			classe = 'nome', 			
			morfologia = 			
			{ 
				genero = '',		
			  	numero = '',
			},
		    }, 
	["0%"] = { 
			classe = 'nome', 			
			morfologia = 			
			{ 
				genero = '',		
			  	numero = '',
			},			
		    }, 
	["trinta"] = { 
			classe = 'nome', 			
			morfologia = 			
			{ 
				genero = '',		
			  	numero = 's',
			},			
		    }, 
	["custo"] = { 
			classe = 'nome', 			
			morfologia = 			
			{ 
				genero = '',		
			  	numero = 's',
			},			
		    },
	["um"] = { 
    			classe = 'nome', 			
    			morfologia = 			
    			{ 
    				genero = 'o',		
    			  	numero = 's',
    			},			
		     },	
	["primeiro"] = { 
              		  classe = 'nome', 			
              		  morfologia = 			
              		  { 
              		     genero = 'o',		
              			 numero = 's',
              		  },			
		            },			    	    	
	["o(a)"] = { 
			classe = 'nome', 			
			morfologia = 			
			{ 
				genero = '',		
			  	numero = 's',
			},
			excecoes = 
			{ 
				plural = "os(as)" 
			},
		    },
	["a"] = { 
			classe = 'nome', 			
			morfologia = 			
			{ 
				genero = 'a',		
			  	numero = 's',
			},
		},
	[""] = { 
			classe = 'nome', 			
			morfologia = 			
			{ 
				genero = 'a',		
			  	numero = 's',
			},
		},
	["ao"] = { 
			classe = 'nome', 			
			morfologia = 			
			{ 
				genero = 'o',		
			  	numero = 's',
			},
		},
	["campo"] = { 
			classe = 'nome', 			
			morfologia = 			
			{ 
				genero = 'o',		
			  	numero = 's',
			},
		},
	["caracter"] = { 
			classe = 'nome', 			
			morfologia = 			
			{ 
				genero = 'o',		
			  	numero = 's',
			},
		},	
	["chave"] = { 
			classe = 'nome', 			
			morfologia = 			
			{ 
				genero = 'a',		
			  	numero = 's',
			},
		},
	["cliente"] = { 
			classe = 'nome', 			
			morfologia = 			
			{ 
				genero = 'o',		
			  	numero = 's',
			},
		},
	["contato"] = { 
			classe = 'nome', 			
			morfologia = 			
			{ 
				genero = 'o',		
			  	numero = 's',
			},
		},
	["contrato"] = { 
			classe = 'nome', 			
			morfologia = 			
			{ 
				genero = 'o',		
			  	numero = 's',
			},
		},
	['data'] = { 
			classe = 'nome', 			
			morfologia = 			
			{ 
				genero = 'a',		
			  	numero = 's',
			},
		},
	['dgito'] = { 
			classe = 'nome', 			
			morfologia = 			
			{ 
				genero = 'o',		
			  	numero = 's',
			},
		},
	['do'] = { 
			classe = 'nome', 			
			morfologia = 			
			{ 
				genero = 'o',		
			  	numero = 's',
			},
		},
	['emenda'] = { 
			classe = 'nome', 			
			morfologia = 			
			{ 
				genero = 'a',		
			  	numero = 's',
			},
		},
	['especialidade'] = { 
			classe = 'nome', 			
			morfologia = 			
			{ 
				genero = 'a',		
			  	numero = 's',
			},
		},			
	['fase'] = { 
			classe = 'nome', 			
			morfologia = 			
			{ 
				genero = 'a',		
			  	numero = 's',
			},
	},		
	['fevereiro'] = { 
			classe = 'nome', 			
			morfologia = 			
			{ 
				genero = '',		
			  	numero = 's',
			},
		},
	['letra'] = { 
			classe = 'nome', 	
			morfologia = 			
			{ 
				genero = 'a',		
			  	numero = 's',
			}
		},
	['lista'] = { 
			classe = 'nome', 			
			morfologia = 			
			{ 
				genero = 'a',		
			  	numero = 's',
			},
		},
	['login'] = { 
			classe = 'nome', 	
			morfologia = 			
			{ 
				genero = 'o',		
			  	numero = 's',
			}
		},
	['mesmo'] = { 
			classe = 'nome', 			
			morfologia = 			
			{ 
				genero = 'o',		
			  	numero = 's',
			},
			
		},
	['mesma'] = { 
			classe = 'nome', 			
			morfologia = 			
			{ 
				genero = 'a',		
			  	numero = 's',
			},			
		},

	['nenhum'] = { 
			classe = 'nome', 		
			morfologia = 			
			{ 
				genero = 'o',		
			  	numero = 's',
			},			
		},
	['nome'] = { 
			classe = 'nome', 		
			morfologia = 			
			{ 
				genero = 'o',		
			  	numero = 's',
			},			
		},

	['nota'] = { 
				classe = 'nome', 			
				morfologia = 			{ 
				genero = 'a',		
			  	numero = 's',
			},			
		},		 
	['nmero'] = { 
			classe = 'nome',
			morfologia =
			{
				genero = 'o',
				numero = 's',
			}
			},
	["o"] = { 
			classe = 'nome', 			
			morfologia = 			
			{ 
				genero = 'o',		
			  	numero = 's',
			},
		},
	["rgo"] = { 
			classe = 'nome', 			
			morfologia = 			
			{ 
				genero = 'o',		
			  	numero = 's',
			},
		},
	['palavra'] ={ 
			classe = 'nome',
			morfologia =
			{
				genero = 'a',
				numero = 's',
			}
			},
	['percentual'] ={ 
			classe = 'nome',
			morfologia =
			{
				genero = 'o',
				numero = 's',
			}
			},
	['prazo'] = { 
			classe = 'nome',
			morfologia =
			{
				genero = 'o',
				numero = 's',
			}
			},
	['produto'] ={ 
			classe = 'nome',
			morfologia =
			{
				genero = 'o',
				numero = 's',
			}
			},
	['quantidade'] = { 
			classe = 'nome', 			
			morfologia = 			
			{ 
				genero = 'a',		
			  	numero = 's',
			},
		},
	['telefone'] = { 
			classe = 'nome',
			morfologia =
			{
				genero = 'o',
				numero = 's',
			}
			},
	['total'] = { 
			classe = 'nome',
			morfologia =
			{
				genero = 'o',
				numero = 's',
			}
		},
	['uma'] = { 
			classe = 'nome',
			morfologia =
			{
				genero = 'a',
				numero = 's',
			}
		},
	
	------------------------------------------------------------------------
	-- Verbos
	------------------------------------------------------------------------
	['dever'] = { classe = 'verbo' },
	['estar'] = { 
	    classe = 'verbo',
			excecoes = 
			{ 
				presente = 
				{
					['3s'] = 'est',
					['3p'] = 'esto'
				}
			}
	      
   },
	['localizar'] = { classe = 'verbo' },
	['preencher'] = { classe = 'verbo' },
	['relacionar'] = { classe = 'verbo' },
	['ser'] = { 
			classe = 'verbo',
			excecoes = 
			{ 
				preterito_perfeito = 
				{
					['3s'] = 'foi',
					['3p'] = 'foram'
				}
			}
		  },
}